SystemOrganization addCategory: #'AweSOM-VM'!
SystemOrganization addCategory: #'AweSOM-Compiler'!
SystemOrganization addCategory: #'AweSOM-Interpreter'!
SystemOrganization addCategory: #'AweSOM-CoreObjects'!
SystemOrganization addCategory: #'AweSOM-GarbageCollector'!
SystemOrganization addCategory: #'AweSOM-Test'!
SystemOrganization addCategory: #'AweSOM-VM-Test'!
SystemOrganization addCategory: #'AweSOM-Compiler-Test'!
SystemOrganization addCategory: #'AweSOM-GarbageCollector-Test'!
SystemOrganization addCategory: #'AweSOM-Meta'!

!Object methodsFor: '*AweSOM' stamp: 'rkrk 6/12/2009 01:19'!
isSOMObject

	^ false! !

Object subclass: #SOMBytecode
	instanceVariableNames: 'mgenc'
	classVariableNames: 'InstructionSelectorDict'
	poolDictionaries: ''
	category: 'AweSOM-Interpreter'!

SOMBytecode class
	instanceVariableNames: 'instructionName'!

SOMBytecode class
	instanceVariableNames: 'instructionName'!

SOMBytecode subclass: #SOMBCDup
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AweSOM-Interpreter'!

!SOMBCDup methodsFor: 'accessing' stamp: 'rkrk 6/3/2009 14:59'!
stackDepth

	^ 1! !

SOMBytecode subclass: #SOMBCHalt
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AweSOM-Interpreter'!

SOMBytecode subclass: #SOMBCPop
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AweSOM-Interpreter'!

!SOMBCPop methodsFor: 'accessing' stamp: 'rkrk 6/3/2009 15:01'!
stackDepth

	^ -1! !

SOMBytecode subclass: #SOMBCReturnLocal
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AweSOM-Interpreter'!

SOMBytecode subclass: #SOMBCReturnNonLocal
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AweSOM-Interpreter'!

SOMBytecode subclass: #SOMBCStep
	instanceVariableNames: 'originalBytecode owningFrames'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AweSOM-Interpreter'!

!SOMBCStep methodsFor: 'accessing' stamp: 'arv 6/11/2009 00:50'!
originalBytecode
	^ originalBytecode! !

!SOMBCStep methodsFor: 'accessing' stamp: 'arv 6/11/2009 00:50'!
originalBytecode: anObject
	originalBytecode := anObject! !

!SOMBCStep methodsFor: 'accessing' stamp: 'arv 6/11/2009 10:10'!
owningFrames
	^ owningFrames! !

!SOMBCStep methodsFor: 'accessing' stamp: 'arv 6/11/2009 10:10'!
owningFrames: anObject
	owningFrames := anObject! !

!SOMBytecode class methodsFor: 'instance creation' stamp: 'rkrk 5/8/2009 23:45'!
in: methodGenerationContext

	^ self new
		mgenc: methodGenerationContext;
		yourself.! !

!SOMBytecode class methodsFor: 'constant' stamp: 'arv 6/11/2009 01:10'!
instructionSelectorDict

	^ InstructionSelectorDict ifNil: [
		InstructionSelectorDict := Dictionary new
			at: SOMBCReturnNonLocal put: #doReturnNonLocal;
			at: SOMBCDup put: #doDup;
			at: SOMBCPop put: #doPop;
			at: SOMBCHalt put: #doHalt;
			at: SOMBCPushField put: #doPushField;
			at: SOMBCPopLocal put: #doPopLocal;
			at: SOMBCSuperSend put: #doSuperSend;
			at: SOMBCPushArgument put: #doPushArgument;
			at: SOMBCPushGlobal put: #doPushGlobal;
			at: SOMBCSend put: #doSend;
			at: SOMBCStep put: #doStep;
			at: SOMBCPushBlock put: #doPushBlock;
			at: SOMBCPopArgument put: #doPopArgument;
			at: SOMBCReturnLocal put: #doReturnLocal;
			at: SOMBCPushConstant put: #doPushConstant;
			at: SOMBCPushLocal put: #doPushLocal;
			at: SOMBCPopField put: #doPopField;
			yourself]! !

!SOMBytecode methodsFor: 'accessing' stamp: 'mha 11/16/2010 14:39'!
isPushBlock
	^ false! !

!SOMBytecode methodsFor: 'constant' stamp: 'rkrk 5/25/2009 01:50'!
length

	^ 1! !

!SOMBytecode methodsFor: 'accessing' stamp: 'rkrk 5/8/2009 22:50'!
mgenc
	^ mgenc! !

!SOMBytecode methodsFor: 'accessing' stamp: 'rkrk 5/8/2009 22:50'!
mgenc: anObject
	mgenc := anObject! !

!SOMBytecode methodsFor: 'printing' stamp: 'test 5/25/2009 02:26'!
printName

	"'SOMBC' size = 6, SOMBCDup --> DUP"
	| name |
	name := self class name.
	^ (name copyFrom: 6 to: name size) asUppercase! !

!SOMBytecode methodsFor: 'printing' stamp: 'rkrk 5/25/2009 02:12'!
printOn: stream

	stream
		nextPut: $<;
		nextPutAll: self printName;
		nextPut: $>.! !

!SOMBytecode methodsFor: 'accessing' stamp: 'rkrk 6/3/2009 14:58'!
stackDepth

	^ 0! !

SOMBytecode subclass: #SOMBytecodeWithIndex
	instanceVariableNames: 'index'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AweSOM-Interpreter'!

SOMBytecodeWithIndex subclass: #SOMBCPushBlock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AweSOM-Interpreter'!

!SOMBCPushBlock methodsFor: 'accessing' stamp: 'mha 11/16/2010 14:39'!
isPushBlock
	^ true! !

!SOMBCPushBlock methodsFor: 'accessing' stamp: 'rkrk 6/3/2009 15:00'!
stackDepth

	^ 1! !

SOMBytecodeWithIndex subclass: #SOMBCPushConstant
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AweSOM-Interpreter'!

!SOMBCPushConstant methodsFor: 'accessing' stamp: 'rkrk 5/8/2009 23:37'!
const
	^ self literalValue! !

!SOMBCPushConstant methodsFor: 'accessing' stamp: 'rkrk 6/3/2009 15:00'!
stackDepth

	^ 1! !

SOMBytecodeWithIndex subclass: #SOMBCPushGlobal
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AweSOM-Interpreter'!

!SOMBCPushGlobal methodsFor: 'accessing' stamp: 'rkrk 5/8/2009 23:37'!
global
	^ self literalValue! !

!SOMBCPushGlobal methodsFor: 'accessing' stamp: 'rkrk 6/3/2009 15:00'!
stackDepth

	^ 1! !

SOMBytecodeWithIndex subclass: #SOMBCSend
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AweSOM-Interpreter'!

!SOMBCSend methodsFor: 'accessing' stamp: 'rkrk 5/8/2009 23:40'!
selector

	^ self literalValue! !

!SOMBCSend methodsFor: 'accessing' stamp: 'rkrk 6/3/2009 15:07'!
stackDepth

	^ self selector string numArgs negated + 1! !

SOMBCSend subclass: #SOMBCSuperSend
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AweSOM-Interpreter'!

SOMBytecodeWithIndex subclass: #SOMBytecodeWithFieldIndex
	instanceVariableNames: 'fieldIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AweSOM-Interpreter'!

SOMBytecodeWithFieldIndex subclass: #SOMBCPopField
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AweSOM-Interpreter'!

!SOMBCPopField methodsFor: 'accessing' stamp: 'rkrk 6/3/2009 15:02'!
stackDepth

	^ -1! !

SOMBytecodeWithFieldIndex subclass: #SOMBCPushField
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AweSOM-Interpreter'!

!SOMBCPushField methodsFor: 'accessing' stamp: 'rkrk 6/3/2009 15:00'!
stackDepth

	^ 1! !

!SOMBytecodeWithFieldIndex methodsFor: 'accessing' stamp: 'arv 5/26/2009 00:05'!
fieldIndex
	^ fieldIndex! !

!SOMBytecodeWithFieldIndex methodsFor: 'accessing' stamp: 'arv 5/26/2009 00:05'!
fieldIndex: anObject
	fieldIndex := anObject! !

!SOMBytecodeWithFieldIndex methodsFor: 'as yet unclassified' stamp: 'rkrk 5/28/2009 00:54'!
inferFieldIndexFrom: object

	| fieldName |
	fieldName := object universe newString: self literalValue.
	self fieldIndex: (object indexOfInstanceField: fieldName).! !

!SOMBytecodeWithIndex class methodsFor: 'instance creation' stamp: 'test 5/25/2009 02:30'!
in: mgenc index: i

	^ (self in: mgenc)
		index: i;
		yourself.! !

!SOMBytecodeWithIndex methodsFor: 'accessing' stamp: 'rkrk 5/25/2009 01:47'!
index
	^ index! !

!SOMBytecodeWithIndex methodsFor: 'accessing' stamp: 'rkrk 5/25/2009 01:47'!
index: anObject
	index := anObject! !

!SOMBytecodeWithIndex methodsFor: 'constant' stamp: 'rkrk 5/25/2009 01:49'!
length

	^ 2! !

!SOMBytecodeWithIndex methodsFor: 'accessing' stamp: 'rkrk 5/25/2009 02:16'!
literalValue
	self mgenc ifNil: [^ nil].
	^ self mgenc literals at: self index! !

!SOMBytecodeWithIndex methodsFor: 'printing' stamp: 'test 5/25/2009 02:28'!
printOn: stream

	"stream
		nextPut: $<;
		nextPutAll: self printName;
		nextPutAll: ' index: ';
		print: self index; 
		nextPut: $>."
	stream
		nextPut: $<;
		nextPutAll: self printName;
		nextPutAll: ' index: ';
		print: self index;
		nextPutAll: ' value: ';
		print: self literalValue;
		nextPut: $>.! !

SOMBytecodeWithIndex subclass: #SOMBytecodeWithIndexAndContextIndex
	instanceVariableNames: 'contextIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AweSOM-Interpreter'!

SOMBytecodeWithIndexAndContextIndex subclass: #SOMBCPopArgument
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AweSOM-Interpreter'!

!SOMBCPopArgument methodsFor: 'accessing' stamp: 'rkrk 6/3/2009 15:01'!
stackDepth

	^ -1! !

SOMBytecodeWithIndexAndContextIndex subclass: #SOMBCPopLocal
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AweSOM-Interpreter'!

!SOMBCPopLocal methodsFor: 'accessing' stamp: 'rkrk 6/3/2009 15:01'!
stackDepth

	^ -1! !

SOMBytecodeWithIndexAndContextIndex subclass: #SOMBCPushArgument
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AweSOM-Interpreter'!

!SOMBCPushArgument methodsFor: 'accessing' stamp: 'rkrk 6/3/2009 15:01'!
stackDepth

	^ 1! !

SOMBytecodeWithIndexAndContextIndex subclass: #SOMBCPushLocal
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AweSOM-Interpreter'!

!SOMBCPushLocal methodsFor: 'accessing' stamp: 'rkrk 6/3/2009 15:01'!
stackDepth

	^ 1! !

!SOMBytecodeWithIndexAndContextIndex class methodsFor: 'instance creation' stamp: 'test 5/25/2009 02:29'!
in: mgenc index: idx contextIndex: ctxIdx

	^ (self in: mgenc)
		index: idx;
		contextIndex: ctxIdx;
		yourself.! !

!SOMBytecodeWithIndexAndContextIndex methodsFor: 'accessing' stamp: 'rkrk 5/25/2009 01:47'!
contextIndex
	^ contextIndex! !

!SOMBytecodeWithIndexAndContextIndex methodsFor: 'accessing' stamp: 'rkrk 5/25/2009 01:47'!
contextIndex: anObject
	contextIndex := anObject! !

!SOMBytecodeWithIndexAndContextIndex methodsFor: 'constant' stamp: 'rkrk 5/25/2009 01:49'!
length

	^ 3! !

!SOMBytecodeWithIndexAndContextIndex methodsFor: 'printing' stamp: 'test 5/25/2009 02:28'!
printOn: stream
	
	stream
		nextPut: $<;
		nextPutAll: self printName;
		nextPutAll: ' index: ';
		print: self index;
		nextPutAll: ' context: ';
		print: self contextIndex;
		nextPut: $>.! !

Object subclass: #SOMClassGenerationContext
	instanceVariableNames: 'superName isClassSide instanceFields instanceMethods classFields classMethods theName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AweSOM-Compiler'!

!SOMClassGenerationContext methodsFor: 'adding' stamp: 'StefanMarr 5/13/2012 17:56'!
addField: field
	self isClassSide
		ifTrue:  [classFields add: field]
		ifFalse: [instanceFields add: field].! !

!SOMClassGenerationContext methodsFor: 'adding' stamp: 'rkrk 4/25/2009 23:45'!
addFields: fieldNames

	^ self isClassSide
		ifTrue: [self classFields: fieldNames]
		ifFalse: [self instanceFields: fieldNames]! !

!SOMClassGenerationContext methodsFor: 'adding' stamp: 'StefanMarr 5/13/2012 12:26'!
addInstanceField: field
	instanceFields add: field.! !

!SOMClassGenerationContext methodsFor: 'adding' stamp: 'test 4/29/2009 02:17'!
addMethod: methodGenContext

	^ self isClassSide
		ifFalse: [self instanceMethods add: methodGenContext]
		ifTrue: [
			methodGenContext onClassSide: true.
			self classMethods add: methodGenContext]! !

!SOMClassGenerationContext methodsFor: 'variables' stamp: 'rkrk 5/29/2009 01:32'!
allClassFieldsIn: universe

	| superClass |
	self superName = 'nil' ifTrue: [^ self classFields].
	superClass := universe
		globalAt: self superName asSymbol
		ifAbsent: ["self error: 'Field lookup: Cannot find my superclass ' , self superName , '!!'"
			"Transcript
				cr;
				show: 'Field lookup: Cannot find my superclass ' , self superName , '!!'."
			^ self classFields].
	^ superClass somClass allInstanceFields , self classFields.! !

!SOMClassGenerationContext methodsFor: 'variables' stamp: 'rkrk 5/29/2009 01:32'!
allInstanceFieldsIn: universe

	| superClass |
	self superName = 'nil' ifTrue: [^ self instanceFields].
	superClass := universe
		globalAt: self superName asSymbol
		ifAbsent: ["self error: 'Field lookup: Cannot find my superclass ' , self superName , '!!'"
			"Transcript
				cr;
				show: 'Field lookup: Cannot find my superclass ' , self superName , '!!'."
			^ self instanceFields].
	^ superClass allInstanceFields , self instanceFields.! !

!SOMClassGenerationContext methodsFor: 'assembling' stamp: 'rkrk 6/5/2009 01:28'!
assembleIn: universe

	^ self
		assembleIn: universe
		stub: (self createEmptyClassIn: universe).! !

!SOMClassGenerationContext methodsFor: 'assembling' stamp: 'rkrk 6/5/2009 01:25'!
assembleIn: universe stub: classStub

	self
		initInstanceSideOf: classStub in: universe;
		initClassSideOf: classStub in: universe;
		initFieldsOf: classStub in: universe.
	^ classStub! !

!SOMClassGenerationContext methodsFor: 'accessing' stamp: 'rkrk 4/25/2009 18:50'!
classFields
	^ classFields! !

!SOMClassGenerationContext methodsFor: 'accessing' stamp: 'rkrk 4/25/2009 18:50'!
classFields: anObject
	classFields := anObject! !

!SOMClassGenerationContext methodsFor: 'accessing' stamp: 'rkrk 4/25/2009 18:50'!
classMethods
	^ classMethods! !

!SOMClassGenerationContext methodsFor: 'accessing' stamp: 'rkrk 4/25/2009 18:50'!
classMethods: anObject
	classMethods := anObject! !

!SOMClassGenerationContext methodsFor: 'assembling' stamp: 'rkrk 6/5/2009 01:21'!
createEmptyClassIn: universe

	| superclass |
	superclass := universe
		globalAt: self superName
		ifAbsent: [universe loadSOMClass: self superName].
	^ SOMClass 
		inUniverse: universe
		withSomSuperClass: superclass.! !

!SOMClassGenerationContext methodsFor: 'initialization' stamp: 'rkrk 4/25/2009 22:04'!
defaultSuperClassName

	^ 'Object'! !

!SOMClassGenerationContext methodsFor: 'testing' stamp: 'rkrk 4/25/2009 23:01'!
hasField: fieldName

	^ self isClassSide
		ifTrue: [self classFields includes: fieldName]
		ifFalse: [self instanceFields includes: fieldName]! !

!SOMClassGenerationContext methodsFor: 'assembling' stamp: 'rkrk 6/4/2009 14:35'!
initClassSideOf: somClass in: universe

	| fields methods |
	self flag: #rkrk. "Duplication with #initInstanceSideOf:in:"
	somClass somClass somName: (universe newSymbol: self theName , ' class').
	fields := self classFields collect: [:each | universe newString: each].
	somClass somClass somInstanceFields: (universe newArrayWithAll: fields).
	methods := self classMethods collect: [:each | each assembleIn: universe].
	somClass somClass somInstanceInvokables: (universe newArrayWithAll: methods).! !

!SOMClassGenerationContext methodsFor: 'assembling' stamp: 'rkrk 6/5/2009 01:05'!
initFieldsOf: somClass in: universe

	| nAdditionalFields nilObject |
	nAdditionalFields := somClass somClass somInstanceFields size.
	nilObject := universe globalNil.
	somClass fields: (Array new: nAdditionalFields).
	somClass numberOfFields - nAdditionalFields + 1
		to: somClass numberOfFields
		do: [:i | somClass fieldAtIndex: i put: nilObject].! !

!SOMClassGenerationContext methodsFor: 'assembling' stamp: 'rkrk 6/4/2009 14:33'!
initInstanceSideOf: somClass in: universe

	| fields methods |
	somClass somName: (universe newSymbol: self theName).
	fields := self instanceFields collect: [:each | universe newString: each].
	somClass somInstanceFields: (universe newArrayWithAll: fields).
	methods := self instanceMethods collect: [:each | each assembleIn: universe].
	somClass somInstanceInvokables: (universe newArrayWithAll: methods).! !

!SOMClassGenerationContext methodsFor: 'initialization' stamp: 'mkl 4/29/2009 13:50'!
initialize

	super initialize.
	self
		isClassSide: false;
		superName: self defaultSuperClassName;
		instanceFields: OrderedCollection new;
		classFields: OrderedCollection new;
		instanceMethods: OrderedCollection new;
		classMethods: OrderedCollection new;
		theName: ''.! !

!SOMClassGenerationContext methodsFor: 'accessing' stamp: 'rkrk 4/25/2009 18:50'!
instanceFields
	^ instanceFields! !

!SOMClassGenerationContext methodsFor: 'accessing' stamp: 'rkrk 4/25/2009 18:50'!
instanceFields: anObject
	instanceFields := anObject! !

!SOMClassGenerationContext methodsFor: 'accessing' stamp: 'rkrk 4/25/2009 18:50'!
instanceMethods
	^ instanceMethods! !

!SOMClassGenerationContext methodsFor: 'accessing' stamp: 'rkrk 4/25/2009 18:50'!
instanceMethods: anObject
	instanceMethods := anObject! !

!SOMClassGenerationContext methodsFor: 'accessing' stamp: 'rkrk 4/25/2009 18:50'!
isClassSide
	^ isClassSide! !

!SOMClassGenerationContext methodsFor: 'accessing' stamp: 'rkrk 4/25/2009 18:50'!
isClassSide: anObject
	isClassSide := anObject! !

!SOMClassGenerationContext methodsFor: 'accessing' stamp: 'rkrk 4/25/2009 18:50'!
superName
	^ superName! !

!SOMClassGenerationContext methodsFor: 'accessing' stamp: 'rkrk 4/25/2009 18:50'!
superName: anObject
	superName := anObject! !

!SOMClassGenerationContext methodsFor: 'accessing' stamp: 'rkrk 4/25/2009 18:51'!
theName
	^ theName! !

!SOMClassGenerationContext methodsFor: 'accessing' stamp: 'rkrk 4/25/2009 18:52'!
theName: string
	^ theName := string! !

!SOMClassGenerationContext methodsFor: 'accessing' stamp: 'rkrk 4/29/2009 00:32'!
toggleClassSide
	self isClassSide: self isClassSide not! !

Object subclass: #SOMCompiler
	instanceVariableNames: 'universe classPaths'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AweSOM-Compiler'!

!SOMCompiler class methodsFor: 'as yet unclassified' stamp: 'mkl 5/6/2009 17:38'!
inUniverse: universe on: classPaths

	^ self new
		classPaths: classPaths;
		universe: universe;
		yourself.! !

!SOMCompiler methodsFor: 'file access' stamp: 'test 4/29/2009 01:39'!
classFileExtension

	^ '.som'! !

!SOMCompiler methodsFor: 'accessing' stamp: 'mkl 4/29/2009 15:19'!
classPaths
	^ classPaths! !

!SOMCompiler methodsFor: 'accessing' stamp: 'mkl 4/29/2009 15:19'!
classPaths: anObject
	classPaths := anObject! !

!SOMCompiler methodsFor: 'compiling' stamp: 'StefanMarr 5/14/2012 23:20'!
compileSOMClassSource: source stub: classStubOrNil

	| cgenc |
	cgenc := (universe classParser inUniverse: universe onSource: source) start.
	^ classStubOrNil
		ifNil: [cgenc assembleIn: universe]
		ifNotNil: [cgenc assembleIn: universe stub: classStubOrNil].! !

!SOMCompiler methodsFor: 'loading' stamp: 'rkrk 6/5/2009 01:25'!
loadAndCompileSOMClass: className stub: classStubOrNil

	| source |
	source := self sourceOfClassFile: className.
	source ifNil: [^ nil].
	^ self compileSOMClassSource: source stub: classStubOrNil.! !

!SOMCompiler methodsFor: 'file access' stamp: 'StefanMarr 5/9/2012 22:55'!
sourceOfClassFile: className

	| classFile theDir source |
	classFile := className , self classFileExtension.
	theDir := (self classPaths
		collect: [:path |FileDirectory on: path])
		detect: [:dir | dir fileExists: classFile]
		ifNone: [^ nil].
	"theDir ifNil: [self error: 'Cannot find class in classPath']."
	FileStream
		fileNamed: (theDir fullPathFor: classFile)
		do: [:s | source := s contents].
	^ source! !

!SOMCompiler methodsFor: 'accessing' stamp: 'mkl 5/6/2009 17:37'!
universe
	^ universe! !

!SOMCompiler methodsFor: 'accessing' stamp: 'mkl 5/6/2009 17:37'!
universe: anObject
	universe := anObject! !

Object subclass: #SOMHeap
	instanceVariableNames: 'universe objects maxSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AweSOM-GarbageCollector'!

SOMHeap subclass: #SOMAddressableHeap
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AweSOM-GarbageCollector'!

!SOMHeap class methodsFor: 'as yet unclassified' stamp: 'rkrk 6/11/2009 21:24'!
in: universe

	^ self new
		universe: universe;
		yourself.! !

!SOMHeap methodsFor: 'allocating' stamp: 'rkrk 6/12/2009 11:49'!
allocateFor: object

	(object isSOMNumber or: [object isSOMSymbol]) ifTrue: [^ self].
	object gcField: false.
	self basicAllocateFor: object.
	self objects size > self maxSize ifTrue: [
		self collectGarbage].! !

!SOMHeap methodsFor: 'allocating' stamp: 'rkrk 6/12/2009 11:49'!
basicAllocateFor: object

	self objects add: object! !

!SOMHeap methodsFor: 'garbage collection' stamp: 'rkrk 6/12/2009 11:20'!
collectGarbage

	self
		mark;
		sweep.
	self objects size > self maxSize ifTrue: [
		self error: 'Couldn''t free enough space from heap'].! !

!SOMHeap methodsFor: 'default' stamp: 'rkrk 6/12/2009 02:27'!
defaultMaxObjects

	^ 5000! !

!SOMHeap methodsFor: 'initialization' stamp: 'rkrk 6/12/2009 01:02'!
initialize

	super initialize.
	objects := OrderedCollection new.
	maxSize := self defaultMaxObjects.! !

!SOMHeap methodsFor: 'garbage collection' stamp: 'rkrk 6/12/2009 01:17'!
mark

	self rootObjects do: [:ea | self markObject: ea].! !

!SOMHeap methodsFor: 'garbage collection' stamp: 'rkrk 6/12/2009 02:06'!
markObject: somObject

	somObject isSOMObject ifFalse: [^ self].
	somObject gcField ifNil: [^ self].
	somObject gcField ifTrue: [^ self].
	somObject gcField: true.
	somObject allMyReferences do: [:ea | self markObject: ea].! !

!SOMHeap methodsFor: 'accessing' stamp: 'rkrk 6/12/2009 01:01'!
maxSize
	^ maxSize! !

!SOMHeap methodsFor: 'accessing' stamp: 'rkrk 6/12/2009 01:01'!
maxSize: anObject
	maxSize := anObject! !

!SOMHeap methodsFor: 'accessing' stamp: 'rkrk 6/11/2009 21:00'!
objects
	^ objects! !

!SOMHeap methodsFor: 'accessing' stamp: 'rkrk 6/11/2009 21:00'!
objects: anObject
	objects := anObject! !

!SOMHeap methodsFor: 'accessing' stamp: 'rkrk 6/12/2009 02:02'!
rootObjects

	^ self universe globals values , self universe symbolTable values! !

!SOMHeap methodsFor: 'garbage collection' stamp: 'rkrk 6/12/2009 01:27'!
sweep

	"remove marked objects from heap
	reset unmarked objects at the same time"
	| remove |
	self objects removeAllSuchThat: [:ea |
		remove := ea gcField = false.
		ea gcField: false.
		remove].! !

!SOMHeap methodsFor: 'accessing' stamp: 'rkrk 6/11/2009 21:24'!
universe
	^ universe! !

!SOMHeap methodsFor: 'accessing' stamp: 'rkrk 6/11/2009 21:24'!
universe: anObject
	universe := anObject! !

Object subclass: #SOMInterpreter
	instanceVariableNames: 'frame universe currentBytecode stoppedFrame stopped'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AweSOM-Interpreter'!

!SOMInterpreter class methodsFor: 'instance creation' stamp: 'StefanMarr 5/16/2012 00:20'!
inUniverse: universe

	^ self new
		universe: universe;
		yourself.! !

!SOMInterpreter methodsFor: 'accessing' stamp: 'arv 5/27/2009 15:31'!
currentBytecode

	^ currentBytecode! !

!SOMInterpreter methodsFor: 'accessing' stamp: 'arv 5/27/2009 15:31'!
currentBytecode: anObject 

	currentBytecode := anObject! !

!SOMInterpreter methodsFor: 'bytecode processing' stamp: 'arv 5/27/2009 15:31'!
doDup
	"duplicate the topmost element of the stack"
	
	self somFrame 
		push: (self somFrame stackElementAtIndex: 1)! !

!SOMInterpreter methodsFor: 'bytecode processing' stamp: 'arv 6/10/2009 23:13'!
doHalt

	stopped := true! !

!SOMInterpreter methodsFor: 'bytecode processing' stamp: 'arv 5/27/2009 15:29'!
doPop
	"pops the topmost element of the stack"
	
	self somFrame pop! !

!SOMInterpreter methodsFor: 'bytecode processing' stamp: 'arv 5/27/2009 15:31'!
doPopArgument
	"pops the topmost stack element into the argument which is identified by the slot index and context level in the bytecode"
	
	self somFrame 
		argumentAtIndex: (self currentBytecode index)
		contextLevel: (self currentBytecode contextIndex)
		put: (self somFrame pop)! !

!SOMInterpreter methodsFor: 'bytecode processing' stamp: 'arv 5/27/2009 16:07'!
doPopField
	"pops the topmost stack element into the field which is identified by field index in the bytecode"
	
	self somCurrentObject
		fieldAtIndex: (self currentBytecode fieldIndex)
		put: self somFrame pop! !

!SOMInterpreter methodsFor: 'bytecode processing' stamp: 'arv 5/13/2009 18:42'!
doPopLocal
	| localSlot contextLevel |
	localSlot := self currentBytecode index.
	contextLevel := self currentBytecode contextIndex.
	self somFrame 
			localAtIndex: localSlot
			contextLevel: contextLevel
			put: (self somFrame pop)! !

!SOMInterpreter methodsFor: 'bytecode processing' stamp: 'arv 5/13/2009 18:24'!
doPushArgument
	"pushes the argument onto the stack which is identified by the slot index and context level in the next two bytes of the bytecode"
	| slot contextLevel |
	slot := self currentBytecode index.
	contextLevel := self currentBytecode contextIndex.
	self somFrame push: (self somFrame 
			argumentAtIndex: slot
			contextLevel: contextLevel)! !

!SOMInterpreter methodsFor: 'bytecode processing' stamp: 'mkl 5/27/2009 15:35'!
doPushBlock
	| blockMethod block |
	blockMethod := self currentBytecode literalValue.
	block := (SOMBlock inUniverse: self universe)
		somClass: (self universe globalAt: #Block);
		somBlockMethod: blockMethod;
		somContext: self somFrame.
	self somFrame push: block! !

!SOMInterpreter methodsFor: 'bytecode processing' stamp: 'arv 5/13/2009 17:21'!
doPushConstant
	self somFrame push: (self currentBytecode literalValue)! !

!SOMInterpreter methodsFor: 'bytecode processing' stamp: 'arv 5/27/2009 16:06'!
doPushField

	self somFrame push:
		(self somCurrentObject fieldAtIndex: 
			(self currentBytecode fieldIndex)).! !

!SOMInterpreter methodsFor: 'bytecode processing' stamp: 'rkrk 6/3/2009 16:22'!
doPushGlobal

	| global |
	global := 
		self universe 
			globalAt: (self currentBytecode literalValue)
			ifAbsent: [
				self sendUnknownGlobal: 
					self currentBytecode literalValue.
				^ self].
	self somFrame push: global! !

!SOMInterpreter methodsFor: 'bytecode processing' stamp: 'arv 5/13/2009 18:21'!
doPushLocal
	| localSlot contextLevel |
	localSlot := self currentBytecode index.
	contextLevel := self currentBytecode contextIndex.
	self somFrame push: (self somFrame 
			localAtIndex: localSlot
			contextLevel: contextLevel)! !

!SOMInterpreter methodsFor: 'bytecode processing' stamp: 'arv 5/13/2009 12:00'!
doReturnLocal
	"pops the topmost element of the stack and treats it as the return value"
	self popFrameAndPushResult: self somFrame pop! !

!SOMInterpreter methodsFor: 'bytecode processing' stamp: 'arv 5/20/2009 12:33'!
doReturnNonLocal
	"pops the topmost element of the stack and treats it as the return value"
	| result context |
	result := self somFrame pop.
	context := self somFrame outerContext.
	
	self flag: #arv.
	"implement escaped block case"
	
	[self somFrame ~= context] whileTrue: [self popFrame].
	self popFrameAndPushResult: result! !

!SOMInterpreter methodsFor: 'bytecode processing' stamp: 'rkrk 5/29/2009 01:00'!
doSend

	| methodName receiver |
	methodName := self currentBytecode selector.
	receiver := self somFrame stackElementAtIndex: methodName numArgs + 1.
	^ self 
		send: methodName
		toClazz: receiver somClass! !

!SOMInterpreter methodsFor: 'debugging' stamp: 'arv 6/11/2009 10:27'!
doStep

	| bytecodeIndex originalBytecode |
	(self currentBytecode owningFrames includes: self somFrame)
		ifFalse: [
			"if we are not in the right frame; execute the normal bytecode"
			^ self perform: (self instructionSelectors at: 
				self currentBytecode originalBytecode class)].
			
	"uninstall step bytecode if necessary and reinstall original bytecode"
	originalBytecode := self currentBytecode originalBytecode.
	self currentBytecode owningFrames remove: self somFrame.
	self currentBytecode owningFrames ifEmpty: [ 
		bytecodeIndex := self somFrame bytecodeIndex.
		self somMethod bytecodeAt: bytecodeIndex - 1 put: originalBytecode].
	
	"display inspection view again"
	self showInspection.
	
	"execute the normal bytecode"
	self currentBytecode: originalBytecode.
	self perform: (self instructionSelectors at: 
		self currentBytecode class)
	! !

!SOMInterpreter methodsFor: 'bytecode processing' stamp: 'mkl 5/27/2009 16:08'!
doSuperSend
	| methodName superClazz |
	methodName := self currentBytecode selector.
	superClazz := self somFrame outerContext somMethod somHolder somSuperClass.
	self 
		send: methodName
		toClazz: superClazz! !

!SOMInterpreter methodsFor: 'accessing' stamp: 'rkrk 5/25/2009 02:47'!
instructionSelectors
	^ SOMBytecode instructionSelectorDict ! !

!SOMInterpreter methodsFor: 'frame manipulation' stamp: 'arv 5/13/2009 12:00'!
popFrame
	| currentFrame |
	currentFrame := self somFrame.
	self somFrame: currentFrame somPreviousFrame.
	^ currentFrame
		clearPreviousFrame;
		yourself! !

!SOMInterpreter methodsFor: 'frame manipulation' stamp: 'mha 10/29/2010 11:37'!
popFrameAndPushResult: result 

	| poppedMethod |
	poppedMethod := self somFrame somMethod.
	self popFrame.
	self somFrame removeN: poppedMethod numberOfArguments.
	self somFrame push: result! !

!SOMInterpreter methodsFor: 'printing' stamp: 'arv 6/11/2009 01:39'!
printBytecodes
	
	self printBytecodesOn: Transcript.
	Transcript endEntry! !

!SOMInterpreter methodsFor: 'printing' stamp: 'arv 6/11/2009 00:05'!
printBytecodesOn: stream
	| currentFrame |
	
	currentFrame := frame.
	[currentFrame = universe globalNil] whileFalse: 
		[
			currentFrame printBytecodesOn: stream.
			currentFrame := currentFrame somPreviousFrame
		]! !

!SOMInterpreter methodsFor: 'printing' stamp: 'arv 6/11/2009 01:39'!
printFullStacks
	
	self printFullStacksOn: Transcript.
	Transcript endEntry! !

!SOMInterpreter methodsFor: 'printing' stamp: 'arv 6/11/2009 00:06'!
printFullStacksOn: stream
	| currentFrame |
	
	currentFrame := stoppedFrame ifNotNil: [stoppedFrame] ifNil: [frame].
	[currentFrame = universe globalNil] 
		whileFalse: [
			currentFrame printStackOn: stream.
			currentFrame := currentFrame somPreviousFrame
		]! !

!SOMInterpreter methodsFor: 'printing' stamp: 'arv 6/11/2009 01:40'!
printStack
	
	self printStackOn: Transcript.
	Transcript endEntry! !

!SOMInterpreter methodsFor: 'printing' stamp: 'arv 6/11/2009 00:25'!
printStackOn: stream
	| currentFrame |
	
	currentFrame := self somFrame.
	[currentFrame = universe globalNil] 
		whileFalse: [
			stream nextPutAll: currentFrame somMethod asString.
			
			currentFrame somCurrentObject ~= self universe globalNil
				ifTrue: [stream nextPutAll: ' in '; nextPutAll: currentFrame somCurrentObject somClass asString].
				
			currentFrame arguments ~= self universe globalNil
				ifTrue: [stream nextPutAll: ' ('; nextPutAll: currentFrame arguments asString; nextPutAll: ') '].
				
			stream cr.
			currentFrame := currentFrame somPreviousFrame.
		]! !

!SOMInterpreter methodsFor: 'frame manipulation' stamp: 'rkrk 6/5/2009 01:52'!
pushNewFrameWithMethod: method 

	"creates a new frame encapsulating the given method
	and sets the needed length of its stack"
	| frameLength |
	frameLength := method numberOfArguments
		+ method numberOfLocals
		+ method maxStackDepth.
	^ frame := (SOMFrame 
		inUniverse: self universe
		size: frameLength)
		somMethod: method;
		somPreviousFrame: (frame ifNil: [universe globalNil]);
		resetStackPointer;
		bytecodeIndex: 1;
		yourself! !

!SOMInterpreter methodsFor: 'message dispatch' stamp: 'arv 5/27/2009 00:44'!
send: signature toClazz: clazz
	"sends the method to the given class or invokes do not understand"
	(clazz lookupInvokable: signature) 
		ifNotNilDo: [:invokable | invokable invokeInFrame: self somFrame]
		ifNil: [self sendDoesNotUnderstand: signature]! !

!SOMInterpreter methodsFor: 'message dispatch' stamp: 'arv 6/10/2009 23:41'!
sendDoesNotUnderstand: signature
	| arguments receiver |
	"for debugging: in test suite DNU shouldn't be used"
	"self halt."
	
	"assemble and send DO NOT UNDERSTAND"
	arguments := SOMArray inUniverse: universe 
		withAll: (self somFrame popN: signature numArgs).
	"remove receiver from stack"
	receiver := self somFrame pop.
	
	"check if current frame is big enough for this unplanned Send"
	"doesNotUnderstand: needs 3 slots, one for this, one for method name, one for args"
	self somFrame remainingStackSize < 3
		ifTrue: [self somFrame resize: (self somFrame size + 3)].
		
	receiver 
		sendMessage: #doesNotUnderstand:arguments:
		withArguments: 
			(SOMArray inUniverse: universe withAll: 
				{universe newSymbol: signature. arguments})	! !

!SOMInterpreter methodsFor: 'as yet unclassified' stamp: 'arv 5/27/2009 00:11'!
sendUnknownGlobal: globalName 

	"check if current frame is big enough for this unplanned Send"
	"unknownGlobal: needs 2 slots, one for this and one for globalName"
	self somFrame remainingStackSize < 2
		ifTrue: [self somFrame resize: (self somFrame size + 2)].
		
	self somCurrentObject 
		sendMessage: #unknownGlobal:
		withArguments: 
			(SOMArray inUniverse: universe withAll: 
				{universe newSymbol: globalName})! !

!SOMInterpreter methodsFor: 'debugging' stamp: 'rkrk 6/11/2009 22:05'!
showInspection

	| stackTrace bytecodes fullStackTrace stackContents stackPointer topElement realBytecode |
	stackTrace := String streamContents: [:s | self printStackOn: s].	
	stackContents := String streamContents: [:s | self somFrame printStackOn: s].
	realBytecode := self somMethod bytecodeAt: (self somFrame bytecodeIndex - 1).
	bytecodes := String streamContents: [:s | self somFrame printBytecodesOn: s].
	
	stackPointer := self somFrame stackPointer.
	topElement := self somFrame at: stackPointer.
	
	fullStackTrace := String streamContents: [:s | self printFullStacksOn: s].
	
	"inspect local variables or use following commands:"
	"self step"
	"self stepBytecode"
	
	"self halt."
	
	"locals are used by programmers to debug SOM"
	"however for Squeak they are unused"
	"the following lines avoid the annoying unused message of Squeak"
	{stackTrace. bytecodes. fullStackTrace. stackContents. stackPointer. topElement. realBytecode} size.! !

!SOMInterpreter methodsFor: 'accessing' stamp: 'arv 5/27/2009 12:47'!
somCurrentObject
	^ (self somFrame outerContext) somCurrentObject! !

!SOMInterpreter methodsFor: 'accessing' stamp: 'arv 5/13/2009 12:00'!
somFrame
	^ frame! !

!SOMInterpreter methodsFor: 'accessing' stamp: 'arv 5/13/2009 12:00'!
somFrame: anFrame 
	frame := anFrame! !

!SOMInterpreter methodsFor: 'accessing' stamp: 'arv 5/13/2009 12:00'!
somMethod
	^ self somFrame somMethod! !

!SOMInterpreter methodsFor: 'initialization' stamp: 'mha 11/16/2010 14:53'!
start

	stopped := false.
	[stopped] whileFalse: [| bytecode bytecodeIndex |
		bytecodeIndex := self somFrame bytecodeIndex.
		bytecode := self somMethod bytecodeAt: bytecodeIndex.
		self currentBytecode: bytecode.
		"increase bytecode index here because frame might change
		while dispatching current bytecode"
		self somFrame bytecodeIndex: bytecodeIndex + 1.
		self perform: (self instructionSelectors at: bytecode class).
	]! !

!SOMInterpreter methodsFor: 'debugging' stamp: 'arv 6/11/2009 09:56'!
step

	self somFrame installStep! !

!SOMInterpreter methodsFor: 'debugging' stamp: 'arv 6/11/2009 10:03'!
stepBytecode

	self somFrame installStepBytecode! !

!SOMInterpreter methodsFor: 'initialization' stamp: 'arv 6/10/2009 23:14'!
stop
	"rolls back to the first frame which contains the halt command; saves current frame for debug purposes"
	
	| |
	self halt.
	stopped := true! !

!SOMInterpreter methodsFor: 'accessing' stamp: 'arv 5/8/2009 13:33'!
universe
	^ universe! !

!SOMInterpreter methodsFor: 'accessing' stamp: 'arv 5/24/2009 23:24'!
universe: anObject
	universe := anObject! !

Object subclass: #SOMLexer
	instanceVariableNames: 'stream text nextText lineNumber peekDone sym nextSym symChr nextSymChr buf bufP'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AweSOM-Compiler'!

!SOMLexer class methodsFor: 'instance creation' stamp: 'StefanMarr 5/10/2012 21:22'!
on: aReadStream
	| lexer |
	[aReadStream isKindOf: PositionableStream ] assert.
	
	lexer := self new.
	lexer stream: aReadStream.
	^ lexer! !

!SOMLexer methodsFor: 'private' stamp: 'StefanMarr 5/12/2012 22:50'!
bufchar: p
	^ p > buf size
		ifTrue:  [nil]
		ifFalse: [buf at: p]! !

!SOMLexer methodsFor: 'private' stamp: 'StefanMarr 5/10/2012 23:50'!
currentChar
	^ self bufchar: bufP! !

!SOMLexer methodsFor: 'accessing' stamp: 'StefanMarr 5/9/2012 23:32'!
currentLineNumber
	^ lineNumber! !

!SOMLexer methodsFor: 'private' stamp: 'StefanMarr 5/12/2012 22:47'!
endOfBuffer
	^ bufP > (buf size)! !

!SOMLexer methodsFor: 'accessing' stamp: 'StefanMarr 5/13/2012 17:14'!
fillBuffer
	stream atEnd ifTrue: [^ -1].
	
	buf := stream nextLine.
	buf ifNil: [^ -1].
	
	lineNumber := lineNumber + 1.
	
	bufP := 1.
	^ buf size.! !

!SOMLexer methodsFor: 'private' stamp: 'StefanMarr 5/13/2012 17:11'!
hasMoreInput
	self readBufferIfEmpty: [^ false].
	
	^ true! !

!SOMLexer methodsFor: 'initialize-release' stamp: 'StefanMarr 5/13/2012 10:04'!
initialize
	lineNumber := 0.
	peekDone := false.
	text := RWBinaryOrTextStream on: String new.
	buf := ''.
	bufP := 1.! !

!SOMLexer methodsFor: 'helper' stamp: 'StefanMarr 5/10/2012 20:23'!
isOperator: char
	^ char == $~ or: [
	  char == $& or: [
	  char == $| or: [
	  char == $* or: [
	  char == $/ or: [
	  char == $\ or: [
	  char == $+ or: [
	  char == $= or: [
	  char == $> or: [
	  char == $< or: [
	  char == $, or: [
	  char == $@ or: [
	  char == $%
	]]]]]]]]]]]].! !

!SOMLexer methodsFor: 'lexing' stamp: 'StefanMarr 5/13/2012 10:04'!
match: aSymbol
	sym := aSymbol.
	symChr := self currentChar.
	text := RWBinaryOrTextStream with: symChr asString.
	self readNext.
	^ sym.! !

!SOMLexer methodsFor: 'lexing' stamp: 'StefanMarr 5/13/2012 12:50'!
matchColonOrAssignment
	(self bufchar: bufP + 1) == $= ifTrue: [
		sym := #assign.
		bufP := bufP + 2.
		symChr := nil.
		text := RWBinaryOrTextStream with: ':='.
		^ sym
	].

	^ self match: #colon.! !

!SOMLexer methodsFor: 'lexing' stamp: 'StefanMarr 5/13/2012 18:40'!
matchDigit
	sym    := #integer.
	symChr := nil.
	text   := RWBinaryOrTextStream on: String new.

	[ text nextPut: self currentChar.
	  self readNext
	] doWhileTrue: [self currentChar notNil and: [ self currentChar isDigit ]].

	^ sym! !

!SOMLexer methodsFor: 'lexing' stamp: 'StefanMarr 5/13/2012 18:33'!
matchLetter
	symChr := nil.
	text := RWBinaryOrTextStream on: String new.
	
	[self currentChar notNil and: [
		 self currentChar isLetter or: [
		 self currentChar isDigit  or: [
		 self currentChar == $_]]]]
		whileTrue: [
			text nextPut: self currentChar.
			self readNext.
		].
	
	sym := #identifier.
	
	self currentChar == $: ifTrue: [
		sym := #keyword.
		self readNext.
		text nextPut: $:.
		
		(self currentChar notNil and: [self currentChar isLetter]) ifTrue: [
			sym := #keywordSequence.
			[self currentChar isLetter or: [self currentChar == $:]]
				whileTrue: [
					text nextPut: self currentChar.
					self readNext.
				]
		]
	].

	^ sym! !

!SOMLexer methodsFor: 'lexing' stamp: 'StefanMarr 5/13/2012 17:51'!
matchMinusOrSeparator
	(self nextInBufIs: self seperator) ifTrue: [
		text := RWBinaryOrTextStream on: String new.
		[self currentChar == $-] whileTrue: [
			text nextPut: $-.
			self readNext.
		].
		sym := #seperator.
		^ sym.
	].

	^ self match: #minus.
	! !

!SOMLexer methodsFor: 'lexing' stamp: 'StefanMarr 5/11/2012 18:03'!
matchOperator
	| cur |
	(self isOperator: (self bufchar: bufP + 1)) ifTrue: [
		sym := #operatorSequence.
		symChr := nil.
		text := RWBinaryOrTextStream on: String new.
		
		[self isOperator: self currentChar] whileTrue: [
			text nextPut: self currentChar.
			self readNext.
		].
		^ sym.
	].

	cur := self currentChar.
	cur == $~ ifTrue: [ ^ self match: #not ].
	cur == $& ifTrue: [ ^ self match: #and ].
	cur == $| ifTrue: [ ^ self match: #or  ].
	cur == $* ifTrue: [ ^ self match: #star].
	cur == $/ ifTrue: [ ^ self match: #div ].
	cur == $\ ifTrue: [ ^ self match: #mod ].
	cur == $+ ifTrue: [ ^ self match: #plus].
	cur == $= ifTrue: [ ^ self match: #equal].
	cur == $> ifTrue: [ ^ self match: #more].
	cur == $< ifTrue: [ ^ self match: #less].
	cur == $, ifTrue: [ ^ self match: #comma].
	cur == $@ ifTrue: [ ^ self match: #at  ].
	cur == $% ifTrue: [ ^ self match: #per ].
	
	Error signal: 'STEFAN: this is unexpected, I think...'.! !

!SOMLexer methodsFor: 'lexing' stamp: 'StefanMarr 5/13/2012 14:55'!
matchPrimitive
	bufP := bufP + self primitive size.
	sym := #primitive.
	symChr := nil.
	text := RWBinaryOrTextStream with: self primitive.
	^ sym
	! !

!SOMLexer methodsFor: 'lexing' stamp: 'StefanMarr 5/13/2012 10:06'!
matchString
	sym := #STString.
	symChr := nil.
	text := RWBinaryOrTextStream on: String new.
	
	self readNext. "skip start $' "
	[ self currentChar == $' ]
		whileFalse: [
			text nextPut: self currentChar.
			self readNext.
		].
	
	self readNext. "skip the ending $'"
	
	^ sym! !

!SOMLexer methodsFor: 'helper' stamp: 'StefanMarr 5/13/2012 17:48'!
nextInBufIs: aString
	| p |
	p := buf findString: aString startingAt: bufP.
	^ p == bufP! !

!SOMLexer methodsFor: 'accessing' stamp: 'StefanMarr 5/10/2012 18:08'!
nextText
	^ nextText asString! !

!SOMLexer methodsFor: 'lexing' stamp: 'StefanMarr 5/13/2012 10:06'!
peek
	| oldSym oldSymChr oldText |
	peekDone
		ifTrue: [ Error signal: 'SOM Lexer: cannot peek twice!!' ].
	
	oldSym    := sym.
	oldSymChr := symChr.
	oldText   := RWBinaryOrTextStream with: text contents.
	
	nextSym   := self symbol.
	nextSymChr:= symChr.
	nextText  := text.
	
	sym   := oldSym.
	symChr:= oldSymChr.
	text  := oldText.
	
	peekDone := true.
	
	^ nextSym.! !

!SOMLexer methodsFor: 'constant' stamp: 'StefanMarr 5/10/2012 16:10'!
primitive
	^ 'primitive'! !

!SOMLexer methodsFor: 'accessing' stamp: 'StefanMarr 5/10/2012 23:55'!
rawBuffer
	^ buf! !

!SOMLexer methodsFor: 'helper' stamp: 'StefanMarr 5/13/2012 17:21'!
readBufferIfEmpty: aBlock
	[self endOfBuffer] whileTrue: [
		self fillBuffer == -1
			ifTrue: aBlock]! !

!SOMLexer methodsFor: 'private' stamp: 'StefanMarr 5/10/2012 23:53'!
readNext
	bufP := bufP + 1! !

!SOMLexer methodsFor: 'constant' stamp: 'StefanMarr 5/10/2012 16:10'!
seperator
	^ '----'! !

!SOMLexer methodsFor: 'helper' stamp: 'StefanMarr 5/13/2012 17:12'!
skipComment
	self currentChar == $" ifTrue: [
		[
			self readNext.
			self readBufferIfEmpty: [^ self].
		] doWhileTrue: [self currentChar ~= $"].
		self readNext.
	].
! !

!SOMLexer methodsFor: 'helper' stamp: 'StefanMarr 5/13/2012 17:12'!
skipWhitespace
	[self currentChar isSeparator]
		whileTrue: [
			self readNext.
			self readBufferIfEmpty: [^ self]]! !

!SOMLexer methodsFor: 'helper' stamp: 'StefanMarr 5/10/2012 16:46'!
skipWhitespaceAndCommentsOrEnd: atEndBlock
	[	self hasMoreInput ifFalse: atEndBlock.
		self skipWhitespace.
		self skipComment.
	] doWhileTrue: [
		self endOfBuffer 				or: [
		self currentChar isSeparator 	or: [
		self currentChar == $" ]]].! !

!SOMLexer methodsFor: 'accessing' stamp: 'StefanMarr 5/9/2012 23:29'!
stream: aReadStream
	stream := aReadStream.! !

!SOMLexer methodsFor: 'lexing' stamp: 'StefanMarr 5/13/2012 17:50'!
symbol
	| currentChar |
	peekDone ifTrue: [^ self symbolAfterPeek].
	
	self skipWhitespaceAndCommentsOrEnd: [
		sym := #none.
		symChr := nil.
		text := RWBinaryOrTextStream on: String new.
		^ sym
	].

	currentChar := self currentChar.
	
	currentChar == $' ifTrue: [ ^ self matchString ].
	currentChar == $[ ifTrue: [ ^ self match: #newBlock ].
	currentChar == $] ifTrue: [ ^ self match: #endBlock ].
	currentChar == $: ifTrue: [ ^ self matchColonOrAssignment ].
	currentChar == $( ifTrue: [ ^ self match: #newTerm ].
	currentChar == $) ifTrue: [ ^ self match: #endTerm ].
	currentChar == $# ifTrue: [ ^ self match: #pound   ].
	currentChar == $^ ifTrue: [ ^ self match: #exit    ].
	currentChar == $. ifTrue: [ ^ self match: #period  ].
	currentChar == $- ifTrue: [ ^ self matchMinusOrSeparator ].
	(self isOperator: currentChar) ifTrue: [ ^ self matchOperator ].

	(self nextInBufIs: self primitive) ifTrue: [ ^ self matchPrimitive ].
	
	currentChar isLetter ifTrue: [ ^ self matchLetter ].
	currentChar isDigit  ifTrue: [ ^ self matchDigit  ].
	
	"else"
	sym    := #none.
	symChr := currentChar.
	text   := RWBinaryOrTextStream with: currentChar asString.
	
	^ sym! !

!SOMLexer methodsFor: 'lexing' stamp: 'StefanMarr 5/12/2012 23:18'!
symbolAfterPeek
	peekDone := false.
	sym      := nextSym.
	symChr   := nextSymChr.
	text     := nextText.
	^ sym! !

!SOMLexer methodsFor: 'accessing' stamp: 'StefanMarr 5/13/2012 10:01'!
text
	^ text contents! !

Object subclass: #SOMMethodGenerationContext
	instanceVariableNames: 'signature holder outer arguments fakeSource isPrimitive onClassSide locals literals bytecode isFinished isBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AweSOM-Compiler'!

!SOMMethodGenerationContext class methodsFor: 'as yet unclassified' stamp: 'arv 5/13/2009 11:33'!
blockIn: mgenc 
	^ self new
		somHolder: mgenc somHolder;
		outer: mgenc;
		yourself! !

!SOMMethodGenerationContext class methodsFor: 'as yet unclassified' stamp: 'rkrk 6/3/2009 14:35'!
named: n

	^ self new
		signature: n asSymbol;
		yourself! !

!SOMMethodGenerationContext methodsFor: 'accessing' stamp: 'rkrk 5/8/2009 20:59'!
addArgumentIfAbsent: argName

	(self arguments includes: argName) ifTrue: [^ false].
	self arguments add: argName.
	^ true! !

!SOMMethodGenerationContext methodsFor: 'accessing' stamp: 'rkrk 5/13/2009 14:36'!
addLiteralIfAbsent: literal

	| idx |
	idx := self literals indexOf: literal.
	idx isZero ifFalse: [^ idx].
	self literals add: literal.
	^ self literals size! !

!SOMMethodGenerationContext methodsFor: 'accessing' stamp: 'rkrk 5/6/2009 14:20'!
addLocalIfAbsent: varName

	(self locals includes: varName) ifTrue: [^ false].
	self locals add: varName.
	^ true! !

!SOMMethodGenerationContext methodsFor: 'accessing' stamp: 'rkrk 4/28/2009 16:34'!
arguments
	^ arguments! !

!SOMMethodGenerationContext methodsFor: 'accessing' stamp: 'rkrk 4/28/2009 16:34'!
arguments: anObject
	arguments := anObject! !

!SOMMethodGenerationContext methodsFor: 'assembling' stamp: 'test 4/29/2009 02:33'!
assemble: holderClass

	| compileClass |
	compileClass := self onClassSide
		ifTrue: [holderClass class]
		ifFalse: [holderClass].
	compileClass compile: (String streamContents: [:s | s
		nextPutAll: self combineSelectorAndArgs; cr;
		nextPutAll: self fakeSource])! !

!SOMMethodGenerationContext methodsFor: 'assembling' stamp: 'StefanMarr 5/17/2012 16:35'!
assembleIn: universe

	^ self isPrimitive
		ifTrue: [universe primitiveClass
			inUniverse: universe
			named: self signature
			numArgs: arguments size]
		ifFalse: [ (universe methodClass
			inUniverse: universe
			named: self signature
			numArgs: self arguments size
			numLocals: self locals size
			maxStackDepth: self computeMaxStackDepth
			bytecodes: bytecode asArray
			holder: universe globalNil
			lexicalContext: universe globalNil)
				assignLexicalContexts ].! !

!SOMMethodGenerationContext methodsFor: 'bytecode' stamp: 'rkrk 5/9/2009 03:06'!
bcDup
	

	^ self bytecode add: (SOMBCDup in: self)! !

!SOMMethodGenerationContext methodsFor: 'bytecode' stamp: 'arv 5/13/2009 17:11'!
bcHalt
	self bytecode add: SOMBCHalt new.! !

!SOMMethodGenerationContext methodsFor: 'bytecode' stamp: 'rkrk 5/8/2009 23:45'!
bcPop

	self bytecode add: (SOMBCPop in: self).! !

!SOMMethodGenerationContext methodsFor: 'bytecode' stamp: 'arv 5/13/2009 18:46'!
bcPopArgumentIndex: i1 ctxIdx: i2

	self bytecode add: (SOMBCPopArgument in: self index: i1 contextIndex: i2).! !

!SOMMethodGenerationContext methodsFor: 'bytecode' stamp: 'rkrk 5/13/2009 17:31'!
bcPopArgumentIndex: idx ctxIndex: ctxIdx

	self bytecode add: (SOMBCPopArgument in: self index: idx contextIndex: ctxIdx).! !

!SOMMethodGenerationContext methodsFor: 'bytecode' stamp: 'arv 5/21/2009 17:41'!
bcPopField: fieldName

	| idx |
	idx := self addLiteralIfAbsent: fieldName.
	^ self bytecode add: (SOMBCPopField in: self index: idx)! !

!SOMMethodGenerationContext methodsFor: 'bytecode' stamp: 'rkrk 5/9/2009 03:26'!
bcPopLocalIndex: idx ctxIndex: ctxIdx

	self bytecode add: (SOMBCPopLocal in: self index: idx contextIndex: ctxIdx).! !

!SOMMethodGenerationContext methodsFor: 'bytecode' stamp: 'rkrk 5/8/2009 23:46'!
bcPushArgumentIdx: i1 ctxIdx: i2

	self bytecode add: (SOMBCPushArgument in: self index: i1 contextIndex: i2).! !

!SOMMethodGenerationContext methodsFor: 'bytecode' stamp: 'arv 5/24/2009 16:22'!
bcPushBlock: method
	
	| idx |
	idx := self addLiteralIfAbsent: method.
	^ self bytecode add: (SOMBCPushBlock in: self index: idx).! !

!SOMMethodGenerationContext methodsFor: 'bytecode' stamp: 'arv 5/24/2009 21:57'!
bcPushConstant: const
	self addLiteralIfAbsent: const.
	self bytecode add: (SOMBCPushConstant in: self index: (self literalIndex: const)).! !

!SOMMethodGenerationContext methodsFor: 'bytecode' stamp: 'arv 5/25/2009 23:35'!
bcPushField: fieldName

	| idx |
	idx := self addLiteralIfAbsent: fieldName.
	^ self bytecode add: (SOMBCPushField in: self index: idx).! !

!SOMMethodGenerationContext methodsFor: 'bytecode' stamp: 'rkrk 5/8/2009 23:49'!
bcPushGlobal: global

	self addLiteralIfAbsent: global.
	^ self bytecode add: (SOMBCPushGlobal in: self index: (self literalIndex: global)).! !

!SOMMethodGenerationContext methodsFor: 'bytecode' stamp: 'rkrk 5/10/2009 01:51'!
bcPushLocalIndex: i1 ctxIndex: i2

	self bytecode add: (SOMBCPushLocal in: self index: i1 contextIndex: i2).! !

!SOMMethodGenerationContext methodsFor: 'bytecode' stamp: 'rkrk 5/8/2009 23:50'!
bcReturnLocal

	^ self bytecode add: (SOMBCReturnLocal in: self).! !

!SOMMethodGenerationContext methodsFor: 'bytecode' stamp: 'rkrk 5/8/2009 23:50'!
bcReturnNonLocal

	^ self bytecode add: (SOMBCReturnNonLocal in: self).! !

!SOMMethodGenerationContext methodsFor: 'bytecode' stamp: 'arv 6/10/2009 23:40'!
bcSend: selector

	self addLiteralIfAbsent: selector asSymbol.
	^ self bytecode add: (SOMBCSend in: self index: (self literalIndex: selector)).! !

!SOMMethodGenerationContext methodsFor: 'bytecode' stamp: 'arv 6/10/2009 23:40'!
bcSuperSend: selector

	self addLiteralIfAbsent: selector asSymbol.
	^ self bytecode add: (SOMBCSuperSend in: self index: (self literalIndex: selector)).! !

!SOMMethodGenerationContext methodsFor: 'accessing' stamp: 'rkrk 5/4/2009 00:06'!
bytecode
	^ bytecode! !

!SOMMethodGenerationContext methodsFor: 'accessing' stamp: 'rkrk 5/4/2009 00:06'!
bytecode: anObject
	bytecode := anObject! !

!SOMMethodGenerationContext methodsFor: 'bytecode' stamp: 'rkrk 5/6/2009 00:31'!
bytecodeCount
	^ self bytecode 
		inject: 0
		into: [ :sum :ea | sum + ea length ]! !

!SOMMethodGenerationContext methodsFor: 'printing' stamp: 'rkrk 5/10/2009 02:57'!
bytecodeString

	^ String streamContents: [:s |
		self
			bytecodeStringTab: 0
			stream: s].! !

!SOMMethodGenerationContext methodsFor: 'printing' stamp: 'rkrk 5/26/2009 16:24'!
bytecodeStringTab: tabWidth stream: s

	self bytecode do: [:ea |
		tabWidth timesRepeat: [s tab].
		ea printOn: s.
		s cr.
		(ea isKindOf: SOMBCPushBlock) ifTrue: [
			(ea mgenc literals at: ea index) bytecodes first mgenc
				bytecodeStringTab: tabWidth+1
				stream: s.]].! !

!SOMMethodGenerationContext methodsFor: 'assembling' stamp: 'StefanMarr 5/13/2012 15:08'!
combineSelectorAndArgs

	| parts args |
	args := self arguments allButFirst. "First is self"
	args ifEmpty: [^ self signature].
	args size = 1 ifTrue: [^ self signature , ' ' , args first].
	parts := (self signature subStrings: ':')
		with: args
		collect: [:sig :arg | sig , ': ' , arg].
	"Neeeeed join!!!!!!"
	^ (parts inject: '' into: [:all :ea | all , ' ' , ea]) trimBoth.! !

!SOMMethodGenerationContext methodsFor: 'stack size' stamp: 'rkrk 6/3/2009 15:25'!
computeMaxStackDepth

	| depth |
	depth := 0.
	^ self bytecode inject: 0 into: [:maxDepth :ea |
		depth := depth + ea stackDepth.
		depth > maxDepth
			ifTrue: [depth]
			ifFalse: [maxDepth]].! !

!SOMMethodGenerationContext methodsFor: 'bytecode' stamp: 'rkrk 5/7/2009 00:24'!
emitSend: selector isSuper: isSuper

	isSuper
		ifTrue: [self bcSuperSend: selector]
		ifFalse: [self bcSend: selector]! !

!SOMMethodGenerationContext methodsFor: 'accessing' stamp: 'rkrk 4/28/2009 22:45'!
fakeSource
	^ fakeSource! !

!SOMMethodGenerationContext methodsFor: 'accessing' stamp: 'rkrk 4/28/2009 22:45'!
fakeSource: anObject
	fakeSource := anObject! !

!SOMMethodGenerationContext methodsFor: 'accessing' stamp: 'rkrk 5/6/2009 14:14'!
finished

	isFinished := true! !

!SOMMethodGenerationContext methodsFor: 'accessing' stamp: 'rkrk 4/26/2009 22:54'!
holder
	^ holder! !

!SOMMethodGenerationContext methodsFor: 'accessing' stamp: 'rkrk 4/26/2009 22:54'!
holder: anObject
	holder := anObject! !

!SOMMethodGenerationContext methodsFor: 'initialize' stamp: 'rkrk 5/9/2009 04:08'!
initialize

	super initialize.
	self
		isPrimitive: false;
		onClassSide: false;
		locals: OrderedCollection new;
		literals: OrderedCollection new;
		bytecode: OrderedCollection new;
		arguments: OrderedCollection new;
		isFinished: false;
		isBlockMethod: false.! !

!SOMMethodGenerationContext methodsFor: 'accessing' stamp: 'rkrk 5/8/2009 19:11'!
isBlockMethod
	^ isBlock! !

!SOMMethodGenerationContext methodsFor: 'accessing' stamp: 'rkrk 5/8/2009 19:12'!
isBlockMethod: bool
	isBlock := bool! !

!SOMMethodGenerationContext methodsFor: 'accessing' stamp: 'rkrk 5/6/2009 14:14'!
isFinished

	^ isFinished! !

!SOMMethodGenerationContext methodsFor: 'accessing' stamp: 'rkrk 5/6/2009 14:15'!
isFinished: bool

	isFinished := bool! !

!SOMMethodGenerationContext methodsFor: 'accessing' stamp: 'rkrk 4/29/2009 00:58'!
isPrimitive
	^ isPrimitive! !

!SOMMethodGenerationContext methodsFor: 'accessing' stamp: 'rkrk 4/29/2009 00:58'!
isPrimitive: anObject
	isPrimitive := anObject! !

!SOMMethodGenerationContext methodsFor: 'accessing' stamp: 'rkrk 5/8/2009 22:36'!
literalIndex: obj

	| idx |
	idx := self literals indexOf: obj.
	idx isZero ifTrue: [self error: 'Object not found in literal collection'].
	^ idx! !

!SOMMethodGenerationContext methodsFor: 'accessing' stamp: 'rkrk 5/4/2009 00:06'!
literals
	^ literals! !

!SOMMethodGenerationContext methodsFor: 'accessing' stamp: 'rkrk 5/4/2009 00:06'!
literals: anObject
	literals := anObject! !

!SOMMethodGenerationContext methodsFor: 'accessing' stamp: 'rkrk 5/4/2009 00:06'!
locals
	^ locals! !

!SOMMethodGenerationContext methodsFor: 'accessing' stamp: 'rkrk 5/4/2009 00:06'!
locals: anObject
	locals := anObject! !

!SOMMethodGenerationContext methodsFor: 'variables' stamp: 'arv 5/21/2009 18:02'!
lookUpAndPop: varName in: universe

	| lookup |
	lookup := SOMVariableLookup
		lookupVar: (varName = 'super' ifTrue: ['self'] ifFalse: varName)
		inMethodContext: self
		inUniverse: universe.
	lookup found ifFalse: [self error: 'Cannot lookup var ' , varName , ' for pop'].
	lookup isArgument ifTrue: [
		self bcPopArgumentIndex: lookup index ctxIndex: lookup contextIndex.
		^self].
	lookup isLocal ifTrue: [
		self bcPopLocalIndex: lookup index ctxIndex: lookup contextIndex.
		^self].
	lookup isField ifTrue: [
		self bcPopField: varName.
		^self].
	self halt. "trying to store in global"! !

!SOMMethodGenerationContext methodsFor: 'variables' stamp: 'mkl 5/13/2009 19:59'!
lookupVariable: varName in: universe

	| lookup |
	lookup := SOMVariableLookup
		lookupVar: (varName = 'super' ifTrue: ['self'] ifFalse: varName)
		inMethodContext: self
		inUniverse: universe.
	lookup found ifFalse: [Transcript cr; show: 'Cannot lookup var'. ^ self].
	lookup isArgument ifTrue: [
		self bcPushArgumentIdx: lookup index ctxIdx: lookup contextIndex.
		^self].
	lookup isLocal ifTrue: [
		self bcPushLocalIndex: lookup index ctxIndex: lookup contextIndex.
		^self].
	lookup isField ifTrue: [
		self bcPushField: varName.
		^self].
	self bcPushGlobal: varName.
	! !

!SOMMethodGenerationContext methodsFor: 'accessing' stamp: 'test 4/29/2009 02:16'!
onClassSide
	^ onClassSide! !

!SOMMethodGenerationContext methodsFor: 'accessing' stamp: 'test 4/29/2009 02:16'!
onClassSide: anObject
	onClassSide := anObject! !

!SOMMethodGenerationContext methodsFor: 'accessing' stamp: 'rkrk 5/7/2009 00:59'!
outer
	^ outer! !

!SOMMethodGenerationContext methodsFor: 'accessing' stamp: 'rkrk 5/7/2009 00:59'!
outer: anObject
	outer := anObject! !

!SOMMethodGenerationContext methodsFor: 'printing' stamp: 'StefanMarr 5/13/2012 15:07'!
printOn: stream


	self signature ifNil: [
		super printOn: stream.
		^ self].
	stream
		nextPutAll: '<SOMMgenc signature: ';
		nextPutAll: self signature;
		nextPut: $>.! !

!SOMMethodGenerationContext methodsFor: 'bytecode' stamp: 'StefanMarr 5/12/2012 19:30'!
removeLastBytecode
	self bytecode removeLast.! !

!SOMMethodGenerationContext methodsFor: 'bytecode' stamp: 'rkrk 5/9/2009 02:10'!
returnSelf

	self bcPushArgumentIdx: 1 ctxIdx: 1.
	self bcReturnLocal.! !

!SOMMethodGenerationContext methodsFor: 'accessing' stamp: 'rkrk 4/26/2009 02:29'!
signature
	^ signature! !

!SOMMethodGenerationContext methodsFor: 'accessing' stamp: 'rkrk 4/26/2009 02:29'!
signature: anObject
	signature := anObject! !

!SOMMethodGenerationContext methodsFor: 'accessing' stamp: 'arv 5/13/2009 11:32'!
somHolder
	^ holder! !

!SOMMethodGenerationContext methodsFor: 'accessing' stamp: 'arv 5/13/2009 11:33'!
somHolder: anObject 
	holder := anObject! !

Object subclass: #SOMObject
	instanceVariableNames: 'universe theHash fields indexableFields gcField somClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AweSOM-CoreObjects'!

SOMObject class
	instanceVariableNames: 'RealFieldIndexCache NumberOfSharedFieldsCache'!

SOMObject class
	instanceVariableNames: 'RealFieldIndexCache NumberOfSharedFieldsCache'!

SOMObject subclass: #SOMArray
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AweSOM-CoreObjects'!

!SOMArray class methodsFor: 'primitives' stamp: 'mkl 5/27/2009 16:33'!
inSomClass: somClass primnew: size 
	^ self 
		inUniverse: somClass universe
		size: size number! !

!SOMArray class methodsFor: 'as yet unclassified' stamp: 'rkrk 5/13/2009 11:33'!
inUniverse: universe size: size

	^ self
		inUniverse: universe
		withNumberOfAdditionalFields: 0
		withNumberOfIndexableFields: size! !

!SOMArray class methodsFor: 'as yet unclassified' stamp: 'rkrk 5/13/2009 11:40'!
inUniverse: universe withAll: squeakColl

	| result |
	result := self inUniverse: universe size: squeakColl size.
	squeakColl withIndexDo: [:each :i | result at: i put: each].
	^ result! !

!SOMArray methodsFor: 'adding' stamp: 'arv 5/20/2009 03:20'!
add: item
	
	self resize: self size + 1.
	self at: self size put: item! !

!SOMArray methodsFor: 'accessing' stamp: 'test 5/6/2009 16:11'!
at: index
	^ self indexableFields at: index! !

!SOMArray methodsFor: 'accessing' stamp: 'test 5/6/2009 16:11'!
at: index put: object
	^ self indexableFields at: index put: object! !

!SOMArray methodsFor: 'copying' stamp: 'arv 6/4/2009 10:13'!
copyFrom: fromIndex to: toIndex

	^ self indexableFields copyFrom: fromIndex to: toIndex! !

!SOMArray methodsFor: 'enumerating' stamp: 'arv 5/13/2009 12:38'!
do: block

	self indexableFields do: block! !

!SOMArray methodsFor: 'accessing' stamp: 'mkl 5/13/2009 16:27'!
elements
	^ self indexableFields! !

!SOMArray methodsFor: 'accessing' stamp: 'arv 5/21/2009 17:25'!
indexOf: element 
	^ self indexableFields indexOf: element! !

!SOMArray methodsFor: 'primitives' stamp: 'mkl 5/20/2009 15:53'!
primat: index

	^ self at: index number.! !

!SOMArray methodsFor: 'primitives' stamp: 'mkl 5/20/2009 15:54'!
primat: index put: object

	^ self at: index number put: object.! !

!SOMArray methodsFor: 'primitives' stamp: 'mkl 5/20/2009 15:54'!
primlength

	^ universe newNumber: self size! !

!SOMArray methodsFor: 'printing' stamp: 'rkrk 5/25/2009 00:49'!
printOn: stream

	stream
		nextPutAll: 'SOMArray(';
		print: self elements;
		nextPut: $).! !

!SOMArray methodsFor: 'resizing' stamp: 'arv 5/17/2009 14:14'!
resize: newSize
	newSize < self size
		ifTrue: [self indexableFields: (self indexableFields copyFrom: 1 to: newSize)]
		ifFalse: [self indexableFields: (self indexableFields, (Array new: newSize - self size))]! !

!SOMArray methodsFor: 'accessing' stamp: 'arv 5/13/2009 12:37'!
size
	^ self indexableFields size! !

!SOMArray methodsFor: 'accessing' stamp: 'mha 10/29/2010 13:20'!
wipeIndexableFields
	1 to: self elements size do: [ :i | self at: i put: universe globalNil ]! !

!SOMArray methodsFor: 'enumerating' stamp: 'arv 5/13/2009 12:37'!
withIndexDo: block
	indexableFields withIndexDo: block! !

SOMArray subclass: #SOMFrame
	instanceVariableNames: 'somPreviousFrame somContext somMethod stackPointer bytecodeIndex localOffset'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AweSOM-CoreObjects'!

!SOMFrame methodsFor: 'as yet unclassified' stamp: 'arv 5/26/2009 01:01'!
argumentAtIndex: index contextLevel: level

	| contextFrame |
	contextFrame := self frameAtContextLevel: level.
	
	index > contextFrame somMethod numberOfArguments
		ifTrue: [self error: 'index > #args'].
		
	^ contextFrame at: index! !

!SOMFrame methodsFor: 'as yet unclassified' stamp: 'mha 10/20/2010 16:02'!
argumentAtIndex: index contextLevel: level put: object
	| contextFrame |
	contextFrame := self frameAtContextLevel: level.
	
	index > contextFrame somMethod numberOfArguments 
		ifTrue: [self error: 'index > #args'].
		
	(self frameAtContextLevel: level)
		at: index put: object! !

!SOMFrame methodsFor: 'as yet unclassified' stamp: 'arv 5/27/2009 12:52'!
arguments

	^ (1 to: self somMethod numberOfArguments) collect: [ :argIndex |
			self argumentAtIndex: argIndex contextLevel: 1
		]! !

!SOMFrame methodsFor: 'as yet unclassified' stamp: 'rkrk 6/3/2009 16:23'!
at: index put: object

	object = false ifTrue: [self halt].
	^ self indexableFields at: index put: object! !

!SOMFrame methodsFor: 'accessing' stamp: 'arv 6/10/2009 16:06'!
bytecodeIndex
	^ bytecodeIndex! !

!SOMFrame methodsFor: 'accessing' stamp: 'arv 6/10/2009 16:06'!
bytecodeIndex: anObject
	bytecodeIndex := anObject! !

!SOMFrame methodsFor: 'as yet unclassified' stamp: 'arv 5/13/2009 11:29'!
clearPreviousFrame
	self somPreviousFrame: self universe globalNil! !

!SOMFrame methodsFor: 'as yet unclassified' stamp: 'rkrk 6/10/2009 14:15'!
copyArgumentsFrom: oldFrame

	| numArgs |
	numArgs := self somMethod numberOfArguments.
	1 to: numArgs do: [:argIndex |
		self 
			at: argIndex
			put: (oldFrame stackElementAtIndex: numArgs - argIndex + 1)].! !

!SOMFrame methodsFor: 'as yet unclassified' stamp: 'arv 5/13/2009 11:25'!
frameAtContextLevel: level 
	| frame |
	frame := self.
	level - 1 timesRepeat: [ frame := frame somContext ].
	^ frame! !

!SOMFrame methodsFor: 'testing' stamp: 'arv 5/13/2009 11:25'!
hasContext
	^ self somContext ~= self universe globalNil! !

!SOMFrame methodsFor: 'testing' stamp: 'arv 5/13/2009 11:29'!
hasPreviousFrame
	^ self somPreviousFrame ~= self universe globalNil! !

!SOMFrame methodsFor: 'initialization' stamp: 'arv 6/10/2009 16:29'!
initialize
	self localOffset: 0.
	self bytecodeIndex: 0.
	self stackPointer: 0.
	self clearPreviousFrame! !

!SOMFrame methodsFor: 'debugging' stamp: 'arv 6/11/2009 10:30'!
installStep

	| stepBytecodeIndex |
	"find next send or popLocal"
	stepBytecodeIndex := (bytecodeIndex to: self somMethod bytecodes size)
		detect: [:index |
			{SOMBCSend. SOMBCSuperSend. SOMBCPopLocal. SOMBCReturnLocal. SOMBCReturnNonLocal} 
				anySatisfy: [:bytecodeClass | 
					(self somMethod bytecodeAt: index) isKindOf: bytecodeClass]]
		ifNone: [
			self somPreviousFrame ~= universe globalNil
				ifTrue: [self somPreviousFrame installStep].			
			^ self ].
		
	self installStepBytecodeAt: stepBytecodeIndex.! !

!SOMFrame methodsFor: 'debugging' stamp: 'arv 6/11/2009 10:04'!
installStepBytecode

	"find next bytecode or look in caller frame"
	bytecodeIndex > self somMethod bytecodes size
		ifTrue: [
			self somPreviousFrame ~= universe globalNil
				ifTrue: [self somPreviousFrame installStepBytecode].			
			^ self ].
		
	self installStepBytecodeAt: bytecodeIndex! !

!SOMFrame methodsFor: 'debugging' stamp: 'arv 6/11/2009 10:15'!
installStepBytecodeAt: stepBytecodeIndex
	"replace next bytecode with step bytecode"
	
	| bytecode stepBytecode |
	bytecode := self somMethod bytecodeAt: stepBytecodeIndex.
	bytecode ifKindOf: SOMBCStep thenDo: [^ bytecode owningFrames add: self].
	stepBytecode := (SOMBCStep new)
		originalBytecode: bytecode;
		owningFrames: {self} asSet;
		yourself.
	self somMethod bytecodeAt: stepBytecodeIndex put: stepBytecode! !

!SOMFrame methodsFor: 'testing' stamp: 'arv 5/12/2009 00:41'!
isBootstrapFrame
	^ self hasPreviousFrame not! !

!SOMFrame methodsFor: 'as yet unclassified' stamp: 'arv 5/12/2009 13:52'!
localAtIndex: index contextLevel: level
	|contextFrame|
	contextFrame := self frameAtContextLevel: level.
	^ contextFrame at: (contextFrame localOffset + index)! !

!SOMFrame methodsFor: 'as yet unclassified' stamp: 'arv 5/12/2009 13:51'!
localAtIndex: index contextLevel: level put: object
	|contextFrame|
	contextFrame := self frameAtContextLevel: level.
	contextFrame at: (contextFrame localOffset + index) put: object! !

!SOMFrame methodsFor: 'accessing' stamp: 'arv 6/10/2009 16:06'!
localOffset
	^ localOffset! !

!SOMFrame methodsFor: 'accessing' stamp: 'arv 6/10/2009 16:06'!
localOffset: anObject
	localOffset := anObject! !

!SOMFrame methodsFor: 'as yet unclassified' stamp: 'arv 5/13/2009 11:25'!
outerContext
	| currentContext |
	currentContext := self.
	[ currentContext hasContext ] whileTrue: [ currentContext := currentContext somContext ].
	^ currentContext! !

!SOMFrame methodsFor: 'stack manipulation' stamp: 'rkrk 5/25/2009 00:18'!
pop

	| oldPosition |
	oldPosition := self stackPointer.
	oldPosition <= (self somMethod numberOfLocals + self somMethod numberOfArguments) 
		ifTrue: [self error: 'Stack is empty'].
	self stackPointer: oldPosition - 1.
	^ self at: oldPosition! !

!SOMFrame methodsFor: 'stack manipulation' stamp: 'arv 6/4/2009 12:26'!
popN: numOfElements

	| oldPosition |
	numOfElements = 0 ifTrue: [^ {}].
	oldPosition := self stackPointer.
	oldPosition < (self somMethod numberOfLocals + self somMethod numberOfArguments + numOfElements) 
		ifTrue: [self error: 'Stack is empty'].
	self stackPointer: oldPosition - numOfElements.
	^ self copyFrom: oldPosition - numOfElements + 1 to: oldPosition! !

!SOMFrame methodsFor: 'printing' stamp: 'arv 6/11/2009 01:38'!
printBytecodes

	self printBytecodesOn: Transcript.
	Transcript endEntry! !

!SOMFrame methodsFor: 'printing' stamp: 'arv 6/11/2009 00:22'!
printBytecodesOn: stream

	"prints value of stack pointer and the current bytecodes"
	stream
		nextPutAll: 'Method: ';
		nextPutAll: self somMethod asString.
	self somMethod numberOfArguments > 0 ifTrue: [
		stream
			nextPutAll: ' in object: ';
			nextPutAll: (self argumentAtIndex: 1 contextLevel: 1) asString].
	stream cr.
	self somMethod bytecodes doWithIndex: [:bc :index |
		index = (self bytecodeIndex - 1) ifTrue: [stream nextPutAll: '->'].
		stream nextPutAll: bc asString; cr.
	]! !

!SOMFrame methodsFor: 'as yet unclassified' stamp: 'arv 5/24/2009 23:15'!
printOn: stream

	stream 
		nextPutAll: 'SOMFrame(';
		print: self somMethod;
		nextPut: $).! !

!SOMFrame methodsFor: 'printing' stamp: 'arv 6/11/2009 01:37'!
printStack
	
	self printStackOn: Transcript.
	Transcript endEntry.! !

!SOMFrame methodsFor: 'printing' stamp: 'arv 6/11/2009 01:40'!
printStackElement: somObject atIndex: index on: stream 
	
	| somNil somClazz |
	stream
		nextPutAll: 'index ';
		nextPutAll: index asString;
		nextPutAll: ': '.
		
	index <= self somMethod numberOfArguments 
		ifTrue: [stream nextPutAll: '(arg '; nextPutAll: index asString; nextPutAll: ') '].
	((index > self somMethod numberOfArguments) and: [index <= (self somMethod numberOfLocals + self somMethod numberOfArguments)])
		ifTrue: [stream nextPutAll: '(local '; nextPutAll: (index - self somMethod numberOfArguments) asString; nextPutAll: ') '].
			
	somNil := self universe globalNil.
	(somObject isNil or: [ somObject == somNil ]) ifTrue: 
		[ stream
			nextPutAll: 'nil';
			cr.
		^ self ].
	somClazz := [somObject somClass] on: Error do: [somObject].
	(somClazz isNil or: [ somClazz == somNil ]) ifTrue: 
		[ stream
			nextPutAll: 'object without class';
			cr.
		^ self ].
	stream
		nextPutAll: somObject asString;
		nextPutAll: ' with class: ';
		nextPutAll: somClazz asString;
		cr! !

!SOMFrame methodsFor: 'printing' stamp: 'arv 6/11/2009 01:24'!
printStackOn: stream
	"prints value of stack pointer and the content of each stack slot"

	stream nextPutAll: 'Method: ';
		nextPutAll: self somMethod asString;
		nextPutAll: '; Stackpointer: ';
		nextPutAll: self stackPointer asString;
		cr.
	1 to: self stackPointer do:
		[ :index | | somObject |
		somObject := self at: index.
		self printStackElement: somObject atIndex: index on: stream ]! !

!SOMFrame methodsFor: 'stack manipulation' stamp: 'rkrk 5/25/2009 00:21'!
push: object

	self stackPointer: self stackPointer + 1.
	self at: self stackPointer put: object.! !

!SOMFrame methodsFor: 'as yet unclassified' stamp: 'arv 5/13/2009 15:39'!
remainingStackSize
	^ self numberOfIndexableFields - self stackPointer! !

!SOMFrame methodsFor: 'stack manipulation' stamp: 'arv 6/4/2009 12:25'!
removeN: numOfElements

	| oldPosition |
	numOfElements = 0 ifTrue: [^ self].
	oldPosition := self stackPointer.
	oldPosition < (self somMethod numberOfLocals + self somMethod numberOfArguments + numOfElements) 
		ifTrue: [self error: 'Stack is empty'].
	self stackPointer: oldPosition - numOfElements.! !

!SOMFrame methodsFor: 'as yet unclassified' stamp: 'arv 5/13/2009 15:41'!
resetStackPointer
	self localOffset: 
		(self somMethod numberOfArguments).
	self stackPointer: 
		(self somMethod numberOfLocals + self somMethod numberOfArguments) ! !

!SOMFrame methodsFor: 'accessing' stamp: 'mkl 5/27/2009 15:38'!
somContext
	^ somContext! !

!SOMFrame methodsFor: 'accessing' stamp: 'mkl 5/27/2009 15:38'!
somContext: anObject 
	somContext := anObject! !

!SOMFrame methodsFor: 'as yet unclassified' stamp: 'arv 5/27/2009 12:47'!
somCurrentObject
	self somMethod somSignature = self universe globalNil
		ifTrue: [^ self universe globalNil].
	self somMethod numberOfArguments = 0
		ifTrue: [^ self universe globalNil].
	^ self argumentAtIndex: 1 contextLevel: 1! !

!SOMFrame methodsFor: 'accessing' stamp: 'mkl 5/27/2009 15:38'!
somMethod
	^ somMethod! !

!SOMFrame methodsFor: 'accessing' stamp: 'mkl 5/27/2009 15:38'!
somMethod: anObject 
	somMethod := anObject! !

!SOMFrame methodsFor: 'accessing' stamp: 'mkl 5/27/2009 15:36'!
somPreviousFrame
	^ somPreviousFrame! !

!SOMFrame methodsFor: 'accessing' stamp: 'mkl 5/27/2009 15:36'!
somPreviousFrame: anObject 
	somPreviousFrame := anObject! !

!SOMFrame methodsFor: 'as yet unclassified' stamp: 'arv 5/13/2009 15:32'!
stackElementAtIndex: index
	^ self at: (self stackPointer - index + 1) ! !

!SOMFrame methodsFor: 'as yet unclassified' stamp: 'arv 5/12/2009 01:09'!
stackElementAtIndex: index put: object
	self at: (self stackPointer - index + 1) 
		put: object! !

!SOMFrame methodsFor: 'accessing' stamp: 'arv 6/10/2009 16:06'!
stackPointer
	^ stackPointer! !

!SOMFrame methodsFor: 'accessing' stamp: 'arv 6/10/2009 16:06'!
stackPointer: anObject
	stackPointer := anObject! !

SOMObject subclass: #SOMBlock
	instanceVariableNames: 'somBlockMethod somContext'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AweSOM-CoreObjects'!

!SOMBlock methodsFor: 'accessing' stamp: 'mkl 5/27/2009 16:16'!
cacheEvaluationMethodWithParameters: numParams 
	| signature replaceIndex evaluationMethod |
	signature := self evaluationMethodWithParameters: numParams.

	"check if block class already has an evaluationMethod for the given parameter"
	evaluationMethod := self somClass lookupInvokable: signature.
	evaluationMethod class = SOMBlockEvaluation ifTrue: [ ^ self ].

	"add to instance methods or replace existing primitives"
	evaluationMethod ifNotNil: 
		[ replaceIndex := self somClass somInstanceInvokables indexOf: evaluationMethod ].
	evaluationMethod := self createEvalutationMethodWithParameters: numParams.
	replaceIndex ifNil: [ ^ self somClass somInstanceInvokables add: evaluationMethod ].
	self somClass somInstanceInvokables 
		at: replaceIndex
		put: evaluationMethod! !

!SOMBlock methodsFor: 'accessing' stamp: 'mkl 5/27/2009 16:23'!
createEvalutationMethodWithParameters: numParams 
	^ (SOMBlockEvaluation inUniverse: self universe)
		somSignature: (universe newSymbol: (self evaluationMethodWithParameters: numParams));
		numberOfArguments: numParams;
		yourself! !

!SOMBlock methodsFor: 'accessing' stamp: 'arv 5/26/2009 15:49'!
evaluationMethodWithParameters: numParams
	numParams = 0 ifTrue: [^ #value].
	"append with: for each parameter except the first"
	^ (2 to: numParams) inject: #value: into: [ :sig :each | sig, #with:]
	! !

!SOMBlock methodsFor: 'primitives' stamp: 'arv 5/25/2009 00:30'!
primrestart
	universe interpreter somFrame
		bytecodeIndex: 1;
		resetStackPointer! !

!SOMBlock methodsFor: 'accessing' stamp: 'mkl 5/27/2009 15:44'!
somBlockMethod
	^ somBlockMethod! !

!SOMBlock methodsFor: 'accessing' stamp: 'mkl 5/27/2009 15:44'!
somBlockMethod: anObject 
	somBlockMethod := anObject.
	self cacheEvaluationMethodWithParameters: anObject numberOfArguments! !

!SOMBlock methodsFor: 'accessing' stamp: 'mkl 5/27/2009 15:44'!
somContext
	^ somContext! !

!SOMBlock methodsFor: 'accessing' stamp: 'mkl 5/27/2009 15:44'!
somContext: anObject 
	somContext := anObject! !

SOMObject subclass: #SOMClass
	instanceVariableNames: 'somSuperClass somName somInstanceFields somInstanceInvokables'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AweSOM-CoreObjects'!

!SOMClass class methodsFor: 'instance creation' stamp: 'rkrk 6/5/2009 01:07'!
inUniverse: universe withSomSuperClass: superClazz

	| metaclass superMeta |
	"metaclass"
	superMeta := superClazz isClass
		ifTrue: [superClazz somClass]
		ifFalse: [universe globalAt: #Class].
	metaclass := (self inUniverse: universe)
		somClass: (universe globalAt: #Metaclass);
		somSuperClass: superMeta;
		yourself.
	"class"
	^ (self inUniverse: universe)
		somSuperClass: superClazz;
		somClass: metaclass;
		yourself.! !

!SOMClass methodsFor: 'accessing' stamp: 'rkrk 6/4/2009 21:04'!
allInstanceFields

	| instFields |
	instFields := self somInstanceFields elements collect: [:ea | ea string].
	^ self somSuperClass isClass
		ifTrue: [self somSuperClass allInstanceFields , instFields]
		ifFalse: [instFields].! !

!SOMClass methodsFor: 'testing' stamp: 'rkrk 6/4/2009 21:09'!
hasSuperClass

	^ somSuperClass isClass! !

!SOMClass methodsFor: 'accessing' stamp: 'rkrk 6/4/2009 21:03'!
indexOfInstanceField: aSOMSymbol 

	| index |
	index := self somInstanceFields indexOf: aSOMSymbol.
	^ (index = 0 and: [self hasSuperClass])
		ifTrue: [self somSuperClass indexOfInstanceField: aSOMSymbol]
		ifFalse: [self numberOfSuperInstanceFields + index].! !

!SOMClass methodsFor: 'initialization' stamp: 'rkrk 5/29/2009 03:59'!
initialize
	super initialize.
	self
		somInstanceFields: (SOMArray inUniverse: universe);
		somInstanceInvokables: (SOMArray inUniverse: universe);
		somName: (universe newString: '')! !

!SOMClass methodsFor: 'testing' stamp: 'rkrk 6/4/2009 21:09'!
isClass

	^ true! !

!SOMClass methodsFor: 'as yet unclassified' stamp: 'arv 6/10/2009 23:39'!
lookupInvokable: signature
	
	^ self somInstanceInvokables elements 
		detect: [:invokable | invokable somSignature symbol == signature]
		ifNone: [self hasSuperClass
			ifTrue: [self somSuperClass lookupInvokable: signature]
			ifFalse: [nil]]! !

!SOMClass methodsFor: 'accessing' stamp: 'mkl 5/27/2009 16:04'!
numberOfInstanceFields
	^ self somInstanceFields size + self numberOfSuperInstanceFields! !

!SOMClass methodsFor: 'accessing' stamp: 'rkrk 6/4/2009 21:05'!
numberOfSuperInstanceFields
	^ somSuperClass isClass
		ifTrue: [somSuperClass numberOfInstanceFields]
		ifFalse: [0]! !

!SOMClass methodsFor: 'as yet unclassified' stamp: 'mkl 5/27/2009 16:36'!
performPrimitive: selector withArguments: arguments

	"If self is of kind SOMClass, primitives might either be instance primitives of SOMClass or class side primitives of the corresponding class. This dispatch is currently made during invocation.
	This is extremely unsexy code. Class primitives might need access to the universe or the class. Currently class primitives are implemented on the class side of SOMObject subclasses. As class methods do not have access to the universe this / the SOMClass object has to be passed in."
	| class classSelector |
	class := self squeakClass.
	classSelector := ('inSomClass:', selector) asSymbol.
	^ (class respondsTo: classSelector)
		ifTrue: [class perform: classSelector withArguments: {self}, arguments.]
		ifFalse:[self perform: selector withArguments: arguments].! !

!SOMClass methodsFor: 'primitives' stamp: 'mkl 5/27/2009 16:31'!
primnew
	^ self squeakClass 
		inUniverse: universe
		withSomClass: self! !

!SOMClass methodsFor: 'accessing' stamp: 'mkl 5/27/2009 16:03'!
somInstanceFields
	^ somInstanceFields! !

!SOMClass methodsFor: 'accessing' stamp: 'arv 5/27/2009 17:16'!
somInstanceFields: anObject 
	somInstanceFields := anObject.
	somInstanceInvokables ~= universe globalNil
		ifTrue: [somInstanceInvokables do: [ :invokable | 
			(invokable isKindOf: SOMMethod)
				ifTrue: [invokable inferFieldIndexesFrom: self]]]! !

!SOMClass methodsFor: 'accessing' stamp: 'mkl 5/27/2009 16:16'!
somInstanceInvokables
	^ somInstanceInvokables! !

!SOMClass methodsFor: 'accessing' stamp: 'mkl 5/27/2009 16:17'!
somInstanceInvokables: anObject 
	somInstanceInvokables := anObject.
	somInstanceInvokables do: [ :invokable | invokable somHolder: self ]! !

!SOMClass methodsFor: 'accessing' stamp: 'mkl 5/27/2009 16:10'!
somName
	^ somName! !

!SOMClass methodsFor: 'accessing' stamp: 'mkl 5/27/2009 16:10'!
somName: anObject 
	somName := anObject! !

!SOMClass methodsFor: 'accessing' stamp: 'mkl 5/27/2009 16:08'!
somSuperClass
	^ somSuperClass! !

!SOMClass methodsFor: 'accessing' stamp: 'mkl 5/27/2009 16:09'!
somSuperClass: anObject 
	somSuperClass := anObject! !

!SOMClass methodsFor: 'accessing' stamp: 'mkl 5/27/2009 16:13'!
squeakClass
	"We currently look up the required squeak class at runtime. This could be optimized by
	storing it in an instance field. Implementing this has been deferred, as it is currently not possible to add instance fields to SOMObject subclasses that are not automatically mapped to SOM fields."
	^ Smalltalk 
		at: ('SOM' , self somName string) asSymbol
		ifAbsent: [ self somSuperClass squeakClass ]! !

SOMObject subclass: #SOMInvokable
	instanceVariableNames: 'somSignature somHolder somNumberOfArguments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AweSOM-CoreObjects'!

SOMInvokable subclass: #SOMBlockEvaluation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AweSOM-CoreObjects'!

!SOMBlockEvaluation methodsFor: 'invoking' stamp: 'arv 5/27/2009 01:03'!
invokeInFrame: frame

	| block newFrame |
	block := frame stackElementAtIndex: self numberOfArguments + 1.
	newFrame := self universe interpreter
		pushNewFrameWithMethod: block somBlockMethod.
	newFrame somContext: block somContext.
	newFrame copyArgumentsFrom: frame.
	frame pop. "pops self -> block"
	^ newFrame! !

!SOMInvokable class methodsFor: 'instance creation' stamp: 'mkl 5/27/2009 16:23'!
inUniverse: universe named: squeakSymbol numArgs: numArgs 
	| instance |
	instance := self inUniverse: universe.
	squeakSymbol ifNotNil: [ instance somSignature: (universe newSymbol: squeakSymbol) ].
	instance numberOfArguments: numArgs.
	^ instance! !

!SOMInvokable methodsFor: 'initialization' stamp: 'mkl 5/27/2009 16:20'!
initialize
	super initialize.
	somNumberOfArguments := self universe newNumber: 0! !

!SOMInvokable methodsFor: 'invoking' stamp: 'arv 5/12/2009 01:08'!
invokeInFrame: frame
	self subclassResponsibility.! !

!SOMInvokable methodsFor: 'accessing' stamp: 'mkl 5/27/2009 16:20'!
numberOfArguments
	^ somNumberOfArguments number! !

!SOMInvokable methodsFor: 'accessing' stamp: 'rkrk 6/11/2009 21:29'!
numberOfArguments: args 
	somNumberOfArguments := universe newNumber: args! !

!SOMInvokable methodsFor: 'accessing' stamp: 'rkrk 5/27/2009 11:21'!
printOn: stream

	self somSignature = universe globalNil
		ifTrue: [^ stream nextPutAll: '<anonymous SOMMethod>'].
	
	stream
		nextPut: $<;
		nextPutAll: self class name; space;
		nextPutAll: self somSignature string;
		nextPut: $>.! !

!SOMInvokable methodsFor: 'accessing' stamp: 'mkl 5/27/2009 16:20'!
somHolder
	^ somHolder! !

!SOMInvokable methodsFor: 'accessing' stamp: 'mkl 5/27/2009 16:20'!
somHolder: anObject 
	somHolder := anObject! !

!SOMInvokable methodsFor: 'accessing' stamp: 'mkl 5/27/2009 16:19'!
somSignature
	^ somSignature! !

!SOMInvokable methodsFor: 'accessing' stamp: 'mkl 5/27/2009 16:19'!
somSignature: anObject 
	somSignature := anObject! !

SOMInvokable subclass: #SOMMethod
	instanceVariableNames: 'numberOfLocals maxStackDepth bytecodes constants lexicalContext'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AweSOM-CoreObjects'!

!SOMMethod commentStamp: 'mkl 4/30/2009 22:59' prior: 0!
Bytecodes are currently stored in a separate collection. This is not the way it is implemented in cppsom.!

!SOMMethod class methodsFor: 'instance creation' stamp: 'mha 11/16/2010 14:17'!
inUniverse: universe named: squeakSymbol numArgs: nArgs numLocals: nLoc maxStackDepth: nStack bytecodes: bc holder: holder lexicalContext: ctx

	^ (self
		inUniverse: universe
		named: squeakSymbol
		numArgs: nArgs)
		numberOfLocals: nLoc;
		maxStackDepth: nStack;
		bytecodes: bc;
		somHolder: holder;
		lexicalContext: ctx;
		yourself.
		
		! !

!SOMMethod methodsFor: 'initialization' stamp: 'mha 11/16/2010 14:51'!
assignLexicalContexts
	self bytecodes
		select: [ :bc | bc isPushBlock ]
		thenDo: [ :bc | bc literalValue lexicalContext: self ].
	^ self! !

!SOMMethod methodsFor: 'accessing' stamp: 'arv 5/8/2009 14:32'!
bytecodeAt: index 
	^ self bytecodes at: index! !

!SOMMethod methodsFor: 'accessing' stamp: 'arv 5/8/2009 14:07'!
bytecodeAt: index put: bytecode 
	^ self bytecodes
		at: index
		put: bytecode! !

!SOMMethod methodsFor: 'accessing' stamp: 'arv 5/8/2009 14:07'!
bytecodes
	^ bytecodes! !

!SOMMethod methodsFor: 'accessing' stamp: 'arv 5/8/2009 14:07'!
bytecodes: anObject
	bytecodes := anObject! !

!SOMMethod methodsFor: 'accessing' stamp: 'arv 5/13/2009 16:31'!
constantAt: index 
	^ self constants at: index! !

!SOMMethod methodsFor: 'accessing' stamp: 'arv 5/13/2009 16:32'!
constantAt: index put: const
	^ constants at: index put: const! !

!SOMMethod methodsFor: 'accessing' stamp: 'arv 5/13/2009 17:14'!
constants
	^ constants! !

!SOMMethod methodsFor: 'accessing' stamp: 'arv 5/13/2009 17:14'!
constants: anObject
	constants := anObject! !

!SOMMethod methodsFor: 'as yet unclassified' stamp: 'rkrk 5/28/2009 01:00'!
inferFieldIndexesFrom: holder

	self flag: #rkrk. "Cleanup using polymorphism or replace mechanism"
	bytecodes do: [:bytecode |
		(bytecode isKindOf: SOMBytecodeWithFieldIndex) 
			ifTrue: [bytecode inferFieldIndexFrom: holder].
		"infer recursively if block"
		(bytecode isKindOf: SOMBCPushBlock) 
			ifTrue: [bytecode literalValue 
				inferFieldIndexesFrom: holder]].! !

!SOMMethod methodsFor: 'initialization' stamp: 'mha 11/16/2010 14:19'!
initialize

	super initialize.
	self
		maxStackDepth: 0;
		numberOfLocals: 0;
		constants: #();
		bytecodes: #();
		lexicalContext: nil.! !

!SOMMethod methodsFor: 'invoking' stamp: 'rkrk 5/25/2009 01:13'!
invokeInFrame: frame

	| newFrame |
	newFrame := self universe interpreter pushNewFrameWithMethod: self.
	newFrame copyArgumentsFrom: frame.
	^ newFrame! !

!SOMMethod methodsFor: 'accessing' stamp: 'mha 11/16/2010 14:52'!
isBlockMethod
	^ self somSignature == universe globalNil! !

!SOMMethod methodsFor: 'accessing' stamp: 'mha 11/16/2010 14:16'!
lexicalContext
	^ lexicalContext! !

!SOMMethod methodsFor: 'accessing' stamp: 'mha 11/16/2010 14:16'!
lexicalContext: aSOMMethod
	lexicalContext := aSOMMethod! !

!SOMMethod methodsFor: 'accessing' stamp: 'rkrk 6/3/2009 15:24'!
maxStackDepth
	^ maxStackDepth! !

!SOMMethod methodsFor: 'accessing' stamp: 'rkrk 6/3/2009 15:24'!
maxStackDepth: anObject
	maxStackDepth := anObject! !

!SOMMethod methodsFor: 'accessing' stamp: 'rkrk 5/27/2009 16:34'!
mgenc
	^ mgenc! !

!SOMMethod methodsFor: 'accessing' stamp: 'rkrk 5/27/2009 16:34'!
mgenc: anObject
	mgenc := anObject! !

!SOMMethod methodsFor: 'accessing' stamp: 'mkl 4/30/2009 22:54'!
numberOfBytecodes
	^ bytecodes size! !

!SOMMethod methodsFor: 'accessing' stamp: 'arv 5/13/2009 17:14'!
numberOfConstants
	^ self constants size! !

!SOMMethod methodsFor: 'accessing' stamp: 'arv 6/10/2009 16:08'!
numberOfLocals
	^ numberOfLocals! !

!SOMMethod methodsFor: 'accessing' stamp: 'arv 6/10/2009 16:08'!
numberOfLocals: anObject
	numberOfLocals := anObject! !

!SOMMethod methodsFor: 'as yet unclassified' stamp: 'arv 5/27/2009 17:12'!
somHolder: holder

	super somHolder: holder.
	holder ~= universe globalNil ifTrue: [self inferFieldIndexesFrom: holder]! !

SOMInvokable subclass: #SOMPrimitive
	instanceVariableNames: 'realSignature'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AweSOM-CoreObjects'!

!SOMPrimitive class methodsFor: 'primitve selectors' stamp: 'rkrk 5/27/2009 12:59'!
selectorMapping

	^ Dictionary newFrom: {		
		$~ -> #Tilde.
		$& -> #And.
		$| -> #Bar.
		$* -> #Star.
		$/ -> #Slash.
		$@ -> #At.
		$+ -> #Plus.
		$- -> #Minus.
		$= -> #Equal.
		$> -> #GreaterThan.
		$< -> #LowerThan.
		$, -> #Comma.
		$% -> #Percent.
		$\ -> #Backslash}! !

!SOMPrimitive methodsFor: 'as yet unclassified' stamp: 'arv 6/4/2009 10:20'!
invokeInFrame: frame

	| theSelf arguments result |	
	"without self, self is first argument"
	arguments := frame popN: (self numberOfArguments - 1).
	theSelf := frame pop.
	result := theSelf
		performPrimitive: self realSignature symbol
		withArguments: arguments.
	frame push: result.! !

!SOMPrimitive methodsFor: 'accessing' stamp: 'mkl 5/8/2009 19:10'!
realSignature
	^ realSignature! !

!SOMPrimitive methodsFor: 'accessing' stamp: 'mkl 5/8/2009 19:10'!
realSignature: anObject
	realSignature := anObject! !

!SOMPrimitive methodsFor: 'accessing' stamp: 'rkrk 5/25/2009 01:02'!
somSignature: anObject 

	super somSignature: anObject.
	self realSignature: (self translateSignature: self somSignature string)! !

!SOMPrimitive methodsFor: 'as yet unclassified' stamp: 'rkrk 6/2/2009 13:26'!
translateSignature: sqSignature

	"#abc: --> #primabc: #~~ --> #primTildeTilde"
	| transformedSignature isBinary part |
	isBinary := true.
	transformedSignature := sqSignature
		inject: ''
		into: [:acc :each |
			part := self class selectorMapping
				at: each
				ifAbsent: [isBinary := false. each asString].
			acc , part].
	isBinary ifTrue: [transformedSignature := transformedSignature , ':'].
	^ SOMSymbol
		inUniverse: universe
		string: 'prim' , transformedSignature.! !

SOMObject subclass: #SOMNumber
	instanceVariableNames: 'number'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AweSOM-CoreObjects'!

SOMNumber subclass: #SOMBigInteger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AweSOM-CoreObjects'!

!SOMBigInteger methodsFor: 'as yet unclassified' stamp: 'rkrk 6/3/2009 12:48'!
primSlash: other

	^ universe newNumber: self number // other number! !

SOMNumber subclass: #SOMDouble
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AweSOM-CoreObjects'!

SOMNumber subclass: #SOMInteger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AweSOM-CoreObjects'!

!SOMInteger class methodsFor: 'constant' stamp: 'rkrk 6/3/2009 13:50'!
maxInt

	"(2 raisedTo: 31) - 1"
	^ 2147483647! !

!SOMInteger methodsFor: 'primitives' stamp: 'rkrk 5/25/2009 01:00'!
primSlash: other

	^ universe newNumber: self number // other number! !

!SOMInteger methodsFor: 'primitives' stamp: 'mha 9/17/2010 12:15'!
primatRandom

	^ universe newNumber: self number atRandom.! !

!SOMNumber class methodsFor: 'as yet unclassified' stamp: 'rkrk 6/11/2009 21:39'!
create: number in: universe

	number isFloat ifTrue: [^ SOMDouble inUniverse: universe new: number].
	number isInteger ifTrue: [
		^ number <=  SOMInteger maxInt
			ifTrue: [SOMInteger inUniverse: universe new: number]
			ifFalse: [SOMBigInteger inUniverse: universe new: number]].
	self halt.! !

!SOMNumber class methodsFor: 'as yet unclassified' stamp: 'rkrk 6/11/2009 21:50'!
inUniverse: universe new: int

	^ (self inUniverse: universe)
		basicNumber: int;
		yourself! !

!SOMNumber methodsFor: 'accessing' stamp: 'rkrk 6/11/2009 21:40'!
basicNumber: n

	"Private!!"
	number := n! !

!SOMNumber methodsFor: 'testing' stamp: 'rkrk 6/12/2009 02:01'!
isSOMNumber

	^ true! !

!SOMNumber methodsFor: 'accessing' stamp: 'mkl 5/6/2009 17:01'!
number
	^ number! !

!SOMNumber methodsFor: 'primitives' stamp: 'mha 9/17/2010 16:42'!
primAnd: other
	^ universe newNumber: (self number bitAnd: other number)! !

!SOMNumber methodsFor: 'primitives' stamp: 'arv 5/27/2009 16:40'!
primEqual: other

	^ universe newBool: 
		((other isKindOf: SOMNumber)
			and: [self number = other number])! !

!SOMNumber methodsFor: 'primitives' stamp: 'arv 5/24/2009 16:59'!
primLowerThan: other
	
	^ universe newBool: self number < other number! !

!SOMNumber methodsFor: 'primitives' stamp: 'mkl 5/6/2009 18:48'!
primMinus: other
	^ universe newNumber: self number - other number! !

!SOMNumber methodsFor: 'primitives' stamp: 'mkl 5/6/2009 18:51'!
primPercent: other
	^ universe newNumber: self number \\ other number! !

!SOMNumber methodsFor: 'primitives' stamp: 'mkl 5/6/2009 18:48'!
primPlus: other
	^ universe newNumber: self number + other number! !

!SOMNumber methodsFor: 'primitives' stamp: 'arv 5/27/2009 00:36'!
primSlashSlash: other

	^ universe newNumber: self number asFloat / other number! !

!SOMNumber methodsFor: 'primitives' stamp: 'mkl 5/6/2009 18:49'!
primStar: other
	^ universe newNumber: self number * other number! !

!SOMNumber methodsFor: 'primitives' stamp: 'arv 5/27/2009 00:25'!
primasString

	^ self universe newString: self number asString! !

!SOMNumber methodsFor: 'primitives' stamp: 'rkrk 5/29/2009 03:55'!
primsqrt
	^ universe newNumber: self number sqrt! !

!SOMNumber methodsFor: 'printing' stamp: 'rkrk 5/6/2009 21:25'!
printOn: stream

	stream 
		nextPutAll: 'SOMNumber(';
		print: self number;
		nextPut: $).! !

!SOMObject class methodsFor: 'accessing' stamp: 'StefanMarr 4/19/2012 11:05'!
allSharedFields

	^ self allInstVarNames select: [:each | each beginsWith: 'som']! !

!SOMObject class methodsFor: 'compiling' stamp: 'mkl 6/3/2009 18:32'!
doneCompiling
	super doneCompiling.
	self withAllSubclassesDo: [:each | each resetCaches]! !

!SOMObject class methodsFor: 'instance creation' stamp: 'rkrk 5/13/2009 11:41'!
inUniverse: universe

	^ self
		inUniverse: universe
		withNumberOfAdditionalFields: 0! !

!SOMObject class methodsFor: 'instance creation' stamp: 'rkrk 5/9/2009 01:15'!
inUniverse: universe withNumberOfAdditionalFields: numberOfFields

	^ self
		inUniverse: universe
		withNumberOfAdditionalFields: numberOfFields
		withNumberOfIndexableFields: 0! !

!SOMObject class methodsFor: 'instance creation' stamp: 'mha 10/29/2010 13:07'!
inUniverse: universe withNumberOfAdditionalFields: nFields withNumberOfIndexableFields: nIndexableFields

	"It is called 'Additional' because it's the number of fields that are
	allocated in addition to the shared fields"
	| result nilObject |
	nilObject := universe globalNil.
	result := self basicNew
		universe: universe;
		fields: (Array new: nFields);
		indexableFields: (Array new: nIndexableFields withAll: nilObject);
		yourself.
	result
		wipe;
		setDefaultClass;
		initialize.
	universe heap allocateFor: result.
	^ result! !

!SOMObject class methodsFor: 'instance creation' stamp: 'mkl 5/27/2009 16:31'!
inUniverse: universe withSomClass: aSOMClass 
	| numberOfAdditionalFields |
	numberOfAdditionalFields := aSOMClass numberOfInstanceFields - self numberOfSharedFields.
	^ (self 
		inUniverse: universe
		withNumberOfAdditionalFields: numberOfAdditionalFields)
		somClass: aSOMClass;
		yourself! !

!SOMObject class methodsFor: 'instance creation' stamp: 'mkl 5/27/2009 16:32'!
inUniverse: universe withSomClass: aSOMClass numIndexable: numIndexable 
	| numberOfAdditionalFields |
	numberOfAdditionalFields := aSOMClass numberOfInstanceFields - self numberOfSharedFields.
	^ (self 
		inUniverse: universe
		withNumberOfAdditionalFields: numberOfAdditionalFields
		withNumberOfIndexableFields: numIndexable)
		somClass: aSOMClass;
		yourself! !

!SOMObject class methodsFor: 'initialization' stamp: 'rkrk 6/3/2009 18:38'!
initialize

	super initialize.
	self withAllSubclassesDo: [:each | each resetCaches].! !

!SOMObject class methodsFor: 'instance creation' stamp: 'mkl 5/6/2009 18:33'!
new
	self error: 'Use factory methods instead.'! !

!SOMObject class methodsFor: 'accessing' stamp: 'mkl 6/3/2009 17:49'!
numberOfSharedFields

	"Returns the number of fields that are shared between VM and SOM code"
	^ NumberOfSharedFieldsCache! !

!SOMObject class methodsFor: 'accessing' stamp: 'mkl 6/3/2009 17:41'!
realFieldIndexFor: index
	^ RealFieldIndexCache at: index ifAbsentPut: [
		| diff |
		diff := index - self numberOfSharedFields.
		diff <= 0
			ifTrue: [{#shared.
				self allInstVarNames indexOf: (self allSharedFields at: index)}]
			ifFalse: [{#fields. diff}].]! !

!SOMObject class methodsFor: 'as yet unclassified' stamp: 'mkl 6/3/2009 17:52'!
resetCaches
	RealFieldIndexCache := Dictionary new.
	NumberOfSharedFieldsCache := self allSharedFields size.! !

!SOMObject class methodsFor: 'accessing' stamp: 'rkrk 5/25/2009 14:04'!
somName
	^ (self name allButFirst: 3) asSymbol! !

!SOMObject methodsFor: 'accessing' stamp: 'rkrk 6/12/2009 01:24'!
allMyReferences

	| normalFields |
	normalFields := (1 to: self numberOfFields) collect: [:i | self fieldAtIndex: i].
	^ normalFields , self indexableFields ! !

!SOMObject methodsFor: 'accessing' stamp: 'rkrk 5/28/2009 00:49'!
fieldAtIndex: index

	| realIndex |
	realIndex := self realFieldIndexFor: index.
	realIndex first = #fields ifTrue: [^ fields at: realIndex second].
	realIndex first = #shared ifTrue: [^ self instVarAt: realIndex second].
	self error: ['Unexpected symbol'].! !

!SOMObject methodsFor: 'accessing' stamp: 'rkrk 5/28/2009 00:50'!
fieldAtIndex: index put: object

	| realIndex |
	realIndex := self realFieldIndexFor: index.
	realIndex first = #fields ifTrue: [^ fields at: realIndex second put: object].
	realIndex first = #shared ifTrue: [^ self instVarAt: realIndex second put: object].
	self error: ['Unexpected symbol'].! !

!SOMObject methodsFor: 'accessing' stamp: 'mkl 4/30/2009 18:30'!
fields
	^ fields! !

!SOMObject methodsFor: 'accessing' stamp: 'mkl 4/30/2009 18:30'!
fields: anObject
	fields := anObject! !

!SOMObject methodsFor: 'accessing' stamp: 'rkrk 6/12/2009 01:00'!
gcField
	^ gcField! !

!SOMObject methodsFor: 'accessing' stamp: 'rkrk 6/12/2009 01:00'!
gcField: anObject
	gcField := anObject! !

!SOMObject methodsFor: 'accessing' stamp: 'mkl 5/27/2009 15:30'!
indexOfField: aSOMSymbol 
	^ self somClass indexOfInstanceField: aSOMSymbol! !

!SOMObject methodsFor: 'accessing' stamp: 'test 5/6/2009 16:04'!
indexableFields
	^ indexableFields! !

!SOMObject methodsFor: 'accessing' stamp: 'test 5/6/2009 16:04'!
indexableFields: anObject
	indexableFields := anObject! !

!SOMObject methodsFor: 'testing' stamp: 'rkrk 6/4/2009 21:02'!
isClass

	^ false! !

!SOMObject methodsFor: 'testing' stamp: 'rkrk 6/12/2009 02:01'!
isSOMNumber

	^ false! !

!SOMObject methodsFor: 'testing' stamp: 'rkrk 6/12/2009 01:18'!
isSOMObject

	^ true! !

!SOMObject methodsFor: 'testing' stamp: 'rkrk 6/12/2009 02:04'!
isSOMSymbol

	^ false! !

!SOMObject methodsFor: 'accessing' stamp: 'mkl 5/3/2009 11:45'!
numberOfFields
	^ self class numberOfSharedFields + fields size! !

!SOMObject methodsFor: 'accessing' stamp: 'arv 5/8/2009 15:56'!
numberOfIndexableFields
	^ self indexableFields size! !

!SOMObject methodsFor: 'accessing' stamp: 'mkl 5/1/2009 11:32'!
numberOfSharedFields
	^ self class numberOfSharedFields! !

!SOMObject methodsFor: 'message sending' stamp: 'mkl 5/20/2009 16:30'!
performPrimitive: selector withArguments: arguments

	^ self perform: selector withArguments: arguments! !

!SOMObject methodsFor: 'primitives' stamp: 'arv 5/26/2009 23:53'!
primEqualEqual: otherObject 

	^ self universe newBool: self == otherObject! !

!SOMObject methodsFor: 'primitives' stamp: 'arv 6/10/2009 23:47'!
primhalt

	self universe interpreter showInspection.! !

!SOMObject methodsFor: 'primitives' stamp: 'mkl 5/27/2009 12:52'!
primhashcode

	^ universe newNumber: self hash! !

!SOMObject methodsFor: 'primitives' stamp: 'rkrk 6/12/2009 01:46'!
primobjectSize

	"basic object size in SOM++ is: 5 words (vtable, hash, objectSize, numberOfFields, gcField)
	basic object size in AweSOM is: 5 words (universe, hash, objectSize, numberOfFields, gcField)
	additional words are needed for each field
	word is 4 byte and objectSize returns the size in bytes (32-bit aligned)"
	^ self universe newNumber:
		(self class instSize - 1 +
		self numberOfSharedFields +
		self numberOfIndexableFields) * 4! !

!SOMObject methodsFor: 'printing' stamp: 'rkrk 6/11/2009 21:44'!
printOn: stream

	"When self is in SOMUniverse globals then print
	symbol of self as found in global dictionary"
	(self universe symbolFor: self) ifNotNilDo: [:sym |
		stream
			nextPutAll: 'SOMGlobal(';
			nextPutAll: sym;
			nextPut: $).
		^ self].
	self somClass ifNil: [
		stream nextPutAll: 'a SOMObject without class'.
		^ self].
	stream
		nextPutAll: 'a SOM';
		nextPutAll: self somClass somName string! !

!SOMObject methodsFor: 'accessing' stamp: 'mkl 6/3/2009 18:02'!
realFieldIndexFor: index

	^ self class realFieldIndexFor: index! !

!SOMObject methodsFor: 'message sending' stamp: 'mkl 5/27/2009 15:30'!
sendMessage: message withArguments: args 
	| frame invokable |
	frame := self universe interpreter somFrame.
	frame push: self.
	args do: [ :arg | frame push: arg ].
	invokable := self somClass lookupInvokable: message.
	invokable invokeInFrame: frame! !

!SOMObject methodsFor: 'accessing' stamp: 'mkl 5/27/2009 15:35'!
setDefaultClass
	| somName |
	somName := self class somName.
	(universe hasGlobalAt: somName) ifTrue: [ self somClass: (universe globalAt: somName) ]! !

!SOMObject methodsFor: 'accessing' stamp: 'rkrk 6/11/2009 22:11'!
somClass

	self flag: #rkrk. "Hack. Some objects don't have a proper class...'"
	(somClass isKindOf: SOMClass)
		ifFalse: [self setDefaultClass].
	^ somClass! !

!SOMObject methodsFor: 'accessing' stamp: 'mkl 5/27/2009 15:35'!
somClass: anObject 
	somClass := anObject! !

!SOMObject methodsFor: 'accessing' stamp: 'mkl 4/30/2009 19:03'!
theHash
	^ theHash! !

!SOMObject methodsFor: 'accessing' stamp: 'mkl 4/30/2009 18:22'!
theHash: anObject
	theHash := anObject! !

!SOMObject methodsFor: 'accessing' stamp: 'mkl 5/6/2009 11:11'!
universe
	^ universe! !

!SOMObject methodsFor: 'accessing' stamp: 'mkl 5/6/2009 11:11'!
universe: anObject
	universe := anObject! !

!SOMObject methodsFor: 'accessing' stamp: 'arv 5/21/2009 17:49'!
valueInField: fieldName

	^ self fieldAtIndex: (self indexOfField: fieldName)! !

!SOMObject methodsFor: 'accessing' stamp: 'arv 5/21/2009 17:49'!
valueInField: fieldName put: value

	self 
		fieldAtIndex: (self indexOfField: fieldName)
		put: value! !

!SOMObject methodsFor: 'accessing' stamp: 'mha 10/29/2010 13:07'!
wipe
	1 to: self numberOfFields do: [ :i | self fieldAtIndex: i put: universe globalNil ]! !

SOMObject subclass: #SOMString
	instanceVariableNames: 'string'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AweSOM-CoreObjects'!

!SOMString class methodsFor: 'instance creation' stamp: 'rkrk 5/9/2009 01:21'!
inUniverse: universe string: string

	^ (self inUniverse: universe)
		string: string;
		yourself.! !

!SOMString methodsFor: 'comparing' stamp: 'mkl 5/26/2009 16:29'!
= other
	^ (other isKindOf: SOMString) and: [
		self string = other string]! !

!SOMString methodsFor: 'testing' stamp: 'mkl 5/26/2009 16:29'!
hash
	^ self string hash! !

!SOMString methodsFor: 'primitives' stamp: 'mkl 5/26/2009 16:31'!
primEqual: other
	^ universe newBool: self = other! !

!SOMString methodsFor: 'primitives' stamp: 'mkl 5/26/2009 16:33'!
primasSymbol
	
	^ self universe newSymbol: self string! !

!SOMString methodsFor: 'primitives' stamp: 'arv 5/24/2009 17:51'!
primconcatenate: somString 
	
	^ self universe newString: self string, somString string! !

!SOMString methodsFor: 'primitives' stamp: 'mkl 5/26/2009 16:32'!
primhashcode
	^ universe newNumber: self hash! !

!SOMString methodsFor: 'primitives' stamp: 'mkl 5/26/2009 16:32'!
primlength
	^ universe newNumber: self string size! !

!SOMString methodsFor: 'primitives' stamp: 'arv 6/3/2009 17:32'!
primobjectSize
	
	"add 32-bit aligned size of string to basic objectSize"
	^ (super primobjectSize) primPlus:
		(self universe newNumber: ((self string size / 4) ceiling * 4))! !

!SOMString methodsFor: 'primitives' stamp: 'mha 9/17/2010 17:00'!
primprimSubstringFrom: start to: end 
	
	^ self universe newString: 
		(self string copyFrom: start number to: end number)! !

!SOMString methodsFor: 'printing' stamp: 'rkrk 5/8/2009 21:48'!
printOn: stream

	stream 
		nextPutAll: self className;
		nextPut: $(;
		nextPutAll: self string printString;
		nextPut: $).! !

!SOMString methodsFor: 'accessing' stamp: 'mkl 5/1/2009 10:19'!
string
	^ string! !

!SOMString methodsFor: 'accessing' stamp: 'mkl 5/1/2009 10:19'!
string: anObject
	string := anObject! !

SOMString subclass: #SOMSymbol
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AweSOM-CoreObjects'!

!SOMSymbol class methodsFor: 'instance creation' stamp: 'rkrk 5/9/2009 01:21'!
inUniverse: universe string: string

	^ super
		inUniverse: universe
		string: string asSymbol.! !

!SOMSymbol methodsFor: 'testing' stamp: 'rkrk 6/12/2009 02:05'!
isSOMSymbol

	^ true! !

!SOMSymbol methodsFor: 'primitives' stamp: 'mkl 5/26/2009 16:15'!
primEqualEqual: other

	^ self universe newBool: 
	  (self symbol = other symbol
	    ifTrue: [true]
	    ifFalse: [false])! !

!SOMSymbol methodsFor: 'primitives' stamp: 'arv 5/24/2009 17:25'!
primasString

	^ self universe newString: self symbol asString! !

!SOMSymbol methodsFor: 'accessing' stamp: 'rkrk 5/9/2009 01:08'!
symbol

	^ string! !

SOMObject subclass: #SOMSystem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AweSOM-CoreObjects'!

!SOMSystem class methodsFor: 'constants' stamp: 'arv 5/24/2009 22:57'!
successCode

	^ 0! !

!SOMSystem methodsFor: 'primitives' stamp: 'rkrk 5/25/2009 00:54'!
primexit: errorCode
	
	errorCode number ~= SOMSystem successCode ifTrue: [
		self universe interpreter printStack].
	self universe quit: errorCode.! !

!SOMSystem methodsFor: 'primitives' stamp: 'rkrk 6/2/2009 20:24'!
primfullGC

	self flag: #rkrk.! !

!SOMSystem methodsFor: 'primitives' stamp: 'arv 5/26/2009 00:32'!
primglobal: globalSymbol

	^ self universe
		globalAt: globalSymbol symbol
		ifAbsent: [self universe globalNil].! !

!SOMSystem methodsFor: 'primitives' stamp: 'arv 5/26/2009 00:24'!
primglobal: globalSymbol put: globalValue 
	
	self universe
		globalAt: globalSymbol symbol
		put: globalValue! !

!SOMSystem methodsFor: 'primitives' stamp: 'rkrk 6/5/2009 01:04'!
primload: clazzName

	| loadedClazz |
	loadedClazz := self universe loadSOMClass: clazzName string.
	^ loadedClazz
		ifNil: [self universe globalNil]
		ifNotNil: [loadedClazz].! !

!SOMSystem methodsFor: 'primitives' stamp: 'rkrk 6/3/2009 19:37'!
primprintNewline
	
	self universe outStream cr; flush.! !

!SOMSystem methodsFor: 'primitives' stamp: 'rkrk 6/3/2009 19:36'!
primprintString: somString
	
	self universe outStream
		nextPutAll: somString string;
		flush.! !

!SOMSystem methodsFor: 'primitives' stamp: 'rkrk 6/5/2009 02:50'!
primtime
	
	^ universe newNumber: Time millisecondClockValue! !

Object subclass: #SOMParser
	instanceVariableNames: 'universe cgenc sym text lexer nextSym shouldReadSources'
	classVariableNames: 'BinaryOpSyms KeywordSelectorSyms SingleOpSyms'
	poolDictionaries: ''
	category: 'AweSOM-Compiler'!

SOMParser subclass: #SOMClassParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AweSOM-Compiler'!

!SOMClassParser methodsFor: 'patterns' stamp: 'StefanMarr 5/13/2012 17:54'!
classBody
	self expect: #newTerm.
	
	self classSide.
	
	self classInstanceSwitch ifTrue: [
		cgenc toggleClassSide.
		self classSide.].
	
	self expect: #endTerm.! !

!SOMClassParser methodsFor: 'patterns' stamp: 'StefanMarr 5/13/2012 12:13'!
classInstanceSwitch
	^ self accept: #seperator.! !

!SOMClassParser methodsFor: 'patterns' stamp: 'StefanMarr 5/13/2012 17:55'!
classSide
	self vars.
	
	[sym == #identifier       or: [
	 sym == #keyword          or: [
	 sym == #operatorSequence or: [
	 self symIn: BinaryOpSyms]]]]
		whileTrue: [
			self foreignParseMethod].! !

!SOMClassParser methodsFor: 'patterns' stamp: 'StefanMarr 5/17/2012 15:23'!
classStart
	cgenc theName: self identifier.
	
	self expect: #equal.
	
	sym == #identifier
		ifTrue:  [cgenc superName: self identifier.].
		! !

!SOMClassParser methodsFor: 'patterns' stamp: 'StefanMarr 5/13/2012 18:38'!
classdef
	self classStart.
	self classBody.! !

!SOMClassParser methodsFor: 'patterns' stamp: 'StefanMarr 5/13/2012 18:06'!
foreignParseMethod
	| parser result |
	parser := self methodParser.
	parser parseState: self parseState.
	
	result := parser apply: #method.
	
	cgenc addMethod: result.
	self parseState: parser parseState.
	^ result! !

!SOMClassParser methodsFor: 'initialize-release' stamp: 'StefanMarr 5/13/2012 12:15'!
initialize
	super initialize.
	
	self cgenc: SOMClassGenerationContext new.! !

!SOMClassParser methodsFor: 'helper' stamp: 'StefanMarr 5/13/2012 16:31'!
methodParser

	^ super methodParser
		cgenc: self cgenc;
		yourself.! !

!SOMClassParser methodsFor: 'parsing' stamp: 'StefanMarr 5/13/2012 18:39'!
start
	self classdef.
	^ cgenc! !

!SOMClassParser methodsFor: 'patterns' stamp: 'StefanMarr 5/13/2012 17:57'!
vars
	(self accept: #or) ifTrue: [
		[sym == #identifier] whileTrue: [
			cgenc addField: self variable.
		].
		
		self expect: #or.
	]! !

SOMParser subclass: #SOMMethodParser
	instanceVariableNames: 'mgenc'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AweSOM-Compiler'!

!SOMMethodParser methodsFor: 'accept and expect' stamp: 'StefanMarr 5/10/2012 22:21'!
acceptOneOf: symbols
	(self symIn: symbols) ifTrue: [
		self getSym.
		^ true ].

	^ false! !

!SOMMethodParser methodsFor: 'patterns' stamp: 'StefanMarr 5/13/2012 11:27'!
argument
	^ self variable! !

!SOMMethodParser methodsFor: 'patterns' stamp: 'StefanMarr 5/13/2012 11:12'!
assignation
	| list |
	list := OrderedCollection new.
	
	self assignments: list.

	self evaluation.
	
	list do: [:v | mgenc bcDup ].
	list do: [:v | mgenc lookUpAndPop: v in: universe ]! !

!SOMMethodParser methodsFor: 'patterns' stamp: 'StefanMarr 5/13/2012 11:15'!
assignment
	| v |
	v := self variable.
	mgenc addLiteralIfAbsent: v.
	
	self expect: #assign.
	
	^ v! !

!SOMMethodParser methodsFor: 'patterns' stamp: 'StefanMarr 5/13/2012 13:41'!
assignments: vars
	sym == #identifier ifTrue: [
		| var |
		var := self assignment.
		
		self peek.
		
		nextSym == #assign ifTrue: [
			self assignments: vars.
		].
	
		vars add: var.
	]! !

!SOMMethodParser methodsFor: 'patterns' stamp: 'StefanMarr 5/13/2012 09:47'!
binaryMessage: superSend
	| sel |
	sel := self binarySelector.
	
	mgenc addLiteralIfAbsent: sel.
	
	self binaryOperand: false.
	
	superSend ifTrue: [mgenc bcSuperSend: sel]
				ifFalse:[mgenc bcSend: sel].! !

!SOMMethodParser methodsFor: 'patterns' stamp: 'StefanMarr 5/15/2012 23:35'!
binaryOperand: superSend
	| doSuper |
	doSuper := self primary: superSend.
	
	[sym == #identifier] whileTrue:
		[self unaryMessage: doSuper].
	
	^ doSuper! !

!SOMMethodParser methodsFor: 'patterns' stamp: 'StefanMarr 5/10/2012 22:07'!
binaryPattern
	mgenc signature: self binarySelector.
	mgenc addArgumentIfAbsent: self argument.! !

!SOMMethodParser methodsFor: 'selector patterns' stamp: 'StefanMarr 5/15/2012 22:28'!
binarySelector
	| s |
	s := text asSymbol.
	
	(self accept: #or)		ifFalse: [
	(self accept: #comma)	ifFalse: [
	(self accept: #minus)	ifFalse: [
	(self accept: #equal)	ifFalse: [
	(self acceptOneOf: SingleOpSyms) ifFalse: [
	(self accept: #operatorSequence) ifFalse: [
	 self expect: #none    ]]]]]].

	^ s! !

!SOMMethodParser methodsFor: 'patterns' stamp: 'StefanMarr 5/13/2012 23:28'!
blockArgPattern
	| blockSig |
	sym == #colon ifTrue: [self blockPattern ].! !

!SOMMethodParser methodsFor: 'patterns' stamp: 'StefanMarr 5/13/2012 11:47'!
blockArguments
	[ self expect: #colon.
	  mgenc addArgumentIfAbsent: self argument
	] doWhileTrue: [sym == #colon].! !

!SOMMethodParser methodsFor: 'patterns' stamp: 'StefanMarr 5/12/2012 22:57'!
blockBody: hasSeenPeriod
	(self accept: #exit) ifTrue: [
		^ self result.
	].

	sym == #endBlock ifTrue: [
		hasSeenPeriod ifTrue: [ mgenc removeLastBytecode ].
		^ mgenc
			bcReturnLocal;
			finished.
	].

	sym == #endTerm ifTrue: [
		^ mgenc returnSelf; finished.
	].

	self expression.
	(self accept: #period) ifTrue: [
		mgenc bcPop.
		self blockBody: true.
	].
! !

!SOMMethodParser methodsFor: 'patterns' stamp: 'StefanMarr 5/12/2012 19:26'!
blockContents
	(self accept: #or) ifTrue: [
		self locals.
		self expect: #or.
	].

	self blockBody: false.! !

!SOMMethodParser methodsFor: 'patterns' stamp: 'StefanMarr 5/13/2012 11:46'!
blockPattern
	self blockArguments.
	self expect: #or.! !

!SOMMethodParser methodsFor: 'patterns' stamp: 'StefanMarr 5/13/2012 09:31'!
evaluation
	| superSend |
	superSend := self primary: false.
	
	(sym == #identifier       or: [
	 sym == #keyword          or: [
	 sym == #operatorSequence or: [
	 self symIn: BinaryOpSyms]]]) ifTrue: [
		self messages: superSend.
	]! !

!SOMMethodParser methodsFor: 'accept and expect' stamp: 'StefanMarr 5/13/2012 10:54'!
expectOneOf: syms
	| msg |
	(self acceptOneOf: syms)
		ifTrue: [	^ true. ].
	
	msg := RWBinaryOrTextStream on: String new.
	msg nextPutAll: 'unexpected symbol in line '.
	msg nextPutAll: lexer currentLineNumber asString.
	msg nextPutAll: '. Expected one of '.
	
	syms do: [:s | 
		msg nextPutAll: s.
		msg nextPutAll: ', '].
	
	msg nextPutAll: 'but found '.
	msg nextPutAll: sym asString.
	
	self printableSymbol ifTrue: [
		msg nextPutAll: ' (', text contents, ')'].
	
	msg nextPutAll: ': '.
	msg nextPutAll: lexer rawBuffer.
	
	Error signal: msg.! !

!SOMMethodParser methodsFor: 'patterns' stamp: 'StefanMarr 5/12/2012 19:36'!
expression
	self peek.
	nextSym == #assign
		ifTrue:  [self assignation.]
		ifFalse: [self evaluation. ]! !

!SOMMethodParser methodsFor: 'helper' stamp: 'StefanMarr 5/10/2012 21:30'!
fakeCgenc

	cgenc := SOMClassGenerationContext new
			theName: #Dummy;
			yourself.! !

!SOMMethodParser methodsFor: 'helper' stamp: 'StefanMarr 5/17/2012 16:28'!
fakeMgenc

	mgenc := (universe methodGenClass named: #dummy)
		somHolder: cgenc;
		yourself! !

!SOMMethodParser methodsFor: 'patterns' stamp: 'StefanMarr 5/13/2012 10:28'!
formula
	| superSend |
	superSend := self binaryOperand: false.
	
	(sym == #operatorSequence or: [self symIn: BinaryOpSyms])
		ifTrue: [self binaryMessage: superSend ].
	
	"only the first message in a sequence can be a super send"
	[sym == #operatorSequence or: [self symIn: BinaryOpSyms]]
		whileTrue: [self binaryMessage: false ].! !

!SOMMethodParser methodsFor: 'patterns' stamp: 'StefanMarr 5/13/2012 16:34'!
keyword
	| s |
	s := text.
	self expect: #keyword.
	^ s! !

!SOMMethodParser methodsFor: 'patterns' stamp: 'StefanMarr 5/15/2012 22:33'!
keywordMessage: superSend
	| kw sel |
	kw := RWBinaryOrTextStream on: String new.
	
	[ kw nextPutAll: self keyword.
	  self formula.
	] doWhileTrue: [sym == #keyword].

	sel := kw contents asSymbol.
	
	mgenc addLiteralIfAbsent: sel.
	superSend ifTrue:  [mgenc bcSuperSend: sel]
				ifFalse: [mgenc bcSend: sel]! !

!SOMMethodParser methodsFor: 'selector patterns' stamp: 'StefanMarr 5/15/2012 22:29'!
keywordPattern
	| kw |
	kw := RWBinaryOrTextStream on: String new.
	[ kw nextPutAll: self keyword.
	  mgenc addArgumentIfAbsent: self argument
	] doWhileTrue: [sym == #keyword].

	mgenc signature: kw contents asSymbol. "(universe newSymbol:)"! !

!SOMMethodParser methodsFor: 'selector patterns' stamp: 'StefanMarr 5/15/2012 22:29'!
keywordSelector
	| s |
	s := text asSymbol.
	
	self expectOneOf: KeywordSelectorSyms.
	
	^ s! !

!SOMMethodParser methodsFor: 'patterns' stamp: 'StefanMarr 5/13/2012 09:47'!
literal
	sym == #pound    ifTrue: [ ^ self literalSymbol. ].
	sym == #STString ifTrue: [ ^ self literalString. ].

	self literalNumber.! !

!SOMMethodParser methodsFor: 'patterns' stamp: 'StefanMarr 5/12/2012 20:11'!
literalDecimal
	^ self literalInteger.! !

!SOMMethodParser methodsFor: 'patterns' stamp: 'StefanMarr 5/12/2012 23:12'!
literalInteger
	| val |
	val := text contents asInteger.
	self expect: #integer.
	^ val! !

!SOMMethodParser methodsFor: 'patterns' stamp: 'StefanMarr 5/12/2012 20:10'!
literalNumber
	| val lit |
	val := sym == #minus	ifTrue: [self negativeDecimal]
								ifFalse:[self literalDecimal ].
	lit := universe newNumber: val.
	mgenc addLiteralIfAbsent: lit.
	mgenc bcPushConstant: lit.! !

!SOMMethodParser methodsFor: 'patterns' stamp: 'StefanMarr 5/13/2012 11:52'!
literalString
	| s |
	s := universe newString: self string.
	mgenc addLiteralIfAbsent: s.
	mgenc bcPushConstant: s.! !

!SOMMethodParser methodsFor: 'patterns' stamp: 'StefanMarr 5/13/2012 10:44'!
literalSymbol
	| symbol |
	self expect: #pound.
	symbol := sym == #STString	 ifTrue:  [universe newSymbol: self string]
									 ifFalse: [universe newSymbol: self selector].
	
	mgenc addLiteralIfAbsent: symbol.
	mgenc bcPushConstant: symbol.! !

!SOMMethodParser methodsFor: 'patterns' stamp: 'StefanMarr 5/13/2012 11:07'!
locals
	[sym == #identifier] whileTrue: [
		mgenc addLocalIfAbsent: self variable.
	]! !

!SOMMethodParser methodsFor: 'patterns' stamp: 'StefanMarr 5/13/2012 01:17'!
messages: superSend
	| doSuper |
	doSuper := superSend.
		
	sym == #identifier ifTrue: [
		[ self unaryMessage: doSuper.
		  doSuper := false.
		] doWhileTrue: [sym == #identifier].
		
		[sym == #operatorSequence or: [self symIn: BinaryOpSyms]] whileTrue: [
			self binaryMessage: false.
		].
	
		sym == #keyword ifTrue: [
			self keywordMessage: false.
		].
		^ doSuper.
	].

	(sym == #operatorSequence or: [self symIn: BinaryOpSyms]) ifTrue: [
		[ self binaryMessage: doSuper.
		  doSuper := false.
		] doWhileTrue: [sym == #operatorSequence or: [self symIn: BinaryOpSyms]].
		
		sym == #keyword ifTrue: [
			self keywordMessage: false.
		].
		^ doSuper.
	].

	self keywordMessage: doSuper.
! !

!SOMMethodParser methodsFor: 'patterns' stamp: 'StefanMarr 5/13/2012 15:01'!
method
	self methodName.
	self expect: #equal.
	
	sym == #primitive
		ifTrue:  [ mgenc isPrimitive: true.
					 self primitiveBlock.]
		ifFalse: [ self methodBlock ].
	
	^ mgenc! !

!SOMMethodParser methodsFor: 'patterns' stamp: 'StefanMarr 5/13/2012 18:22'!
methodBlock
	self expect: #newTerm.
	self blockContents.
	
	mgenc isFinished ifFalse: [
		mgenc
			bcPop;
			returnSelf;
			finished.
	].

	self expect: #endTerm.! !

!SOMMethodParser methodsFor: 'patterns' stamp: 'StefanMarr 5/17/2012 16:17'!
methodName
	mgenc := universe methodGenClass new.
	mgenc addArgumentIfAbsent: #self.
	mgenc holder: cgenc.
	
	sym == #identifier ifTrue: [ ^ self unaryPattern   ].
	sym == #keyword    ifTrue: [ ^ self keywordPattern ].
	
	"else"
	^ self binaryPattern.! !

!SOMMethodParser methodsFor: 'helper' stamp: 'StefanMarr 5/17/2012 16:17'!
methodParser
	^ super methodParser
		mgenc: (universe methodGenClass blockIn: mgenc);
		yourself! !

!SOMMethodParser methodsFor: 'accessing' stamp: 'StefanMarr 5/13/2012 15:31'!
mgenc
	^ mgenc! !

!SOMMethodParser methodsFor: 'accessing' stamp: 'StefanMarr 5/13/2012 15:31'!
mgenc: anMgenc
	mgenc := anMgenc! !

!SOMMethodParser methodsFor: 'patterns' stamp: 'StefanMarr 5/13/2012 15:10'!
negativeDecimal
	self expect: #minus.
	^ self literalInteger negated ! !

!SOMMethodParser methodsFor: 'patterns' stamp: 'StefanMarr 5/13/2012 15:38'!
nestedBlock
	self expect: #newBlock.
	
	mgenc isBlockMethod: true.
	
	self blockArgPattern.
	self blockContents.
	
	mgenc isFinished ifFalse: [
		mgenc bcReturnLocal; finished.
	].

	self expect: #endBlock.
	
	^ mgenc! !

!SOMMethodParser methodsFor: 'patterns' stamp: 'StefanMarr 5/13/2012 10:30'!
nestedTerm
	self expect: #newTerm.
	
	self expression.
	
	self expect: #endTerm.! !

!SOMMethodParser methodsFor: 'patterns' stamp: 'StefanMarr 5/13/2012 16:16'!
parseNestedBlock
	| parser result blockMethod |
	
	parser := self methodParser.
	parser parseState: self parseState.
	
	result := parser apply: #nestedBlock.
	
	blockMethod := result assembleIn: universe.
	mgenc bcPushBlock: blockMethod.
	
	self parseState: parser parseState.
	
	^ result! !

!SOMMethodParser methodsFor: 'patterns' stamp: 'StefanMarr 5/13/2012 18:24'!
primary: doSuper
	| superSend |
	superSend := doSuper.
	
	sym == #identifier ifTrue: [
		| v |
		v := self variable.
		v = #super ifTrue: [
			"v := #self. sends to #super push #self as receiver"
			superSend := true.
		].
		"self genPushVariable: v."
		mgenc lookupVariable: v in: universe.
		^ superSend.
	].

	sym == #newTerm ifTrue: [
		self nestedTerm.
		^ superSend.
	].

	sym == #newBlock ifTrue: [
		self parseNestedBlock.
		^ superSend
	].

	self literal.
	^ superSend! !

!SOMMethodParser methodsFor: 'patterns' stamp: 'StefanMarr 5/13/2012 15:03'!
primitiveBlock
	self expect: #primitive.
	mgenc fakeSource: '^ SOMPrimitives ', 
						 self cgenc theName,
						 mgenc combineSelectorAndArgs.! !

!SOMMethodParser methodsFor: 'patterns' stamp: 'StefanMarr 5/12/2012 23:21'!
result
	self expression.
	
	mgenc isBlockMethod
		ifTrue:  [ mgenc bcReturnNonLocal ]
		ifFalse: [ mgenc bcReturnLocal    ].
	
	mgenc finished.
	
	self accept: #period.! !

!SOMMethodParser methodsFor: 'patterns' stamp: 'StefanMarr 5/13/2012 10:36'!
selector
	(sym == #operatorSequence or: [self symIn: SingleOpSyms])
		ifTrue: [^ self binarySelector ].
	
	(sym == #keyword or: [sym == #keywordSequence])
		ifTrue: [^ self keywordSelector].
	
	^ self unarySelector! !

!SOMMethodParser methodsFor: 'patterns' stamp: 'StefanMarr 5/13/2012 11:53'!
string
	| s |
	s := text contents.
	self expect: #STString.
	^ s! !

!SOMMethodParser methodsFor: 'patterns' stamp: 'StefanMarr 5/12/2012 23:50'!
unaryMessage: superSend
	| sel |
	sel := self unarySelector.
	
	mgenc emitSend: sel isSuper: superSend ! !

!SOMMethodParser methodsFor: 'patterns' stamp: 'StefanMarr 5/11/2012 17:53'!
unaryPattern
	mgenc signature: self unarySelector! !

!SOMMethodParser methodsFor: 'selector patterns' stamp: 'StefanMarr 5/15/2012 22:29'!
unarySelector
	^ self identifier asSymbol! !

!SOMParser class methodsFor: 'instance creation' stamp: 'StefanMarr 5/10/2012 21:25'!
inUniverse: universe onSource: string
	| readStream parser |
	readStream := string asString readStream.
	
	parser := self new.
	parser stream: readStream.
	parser universe: universe.
	
	^ parser! !

!SOMParser class methodsFor: 'class initialization' stamp: 'StefanMarr 5/10/2012 22:35'!
initialize
	"self initialize"
	SingleOpSyms := #(                     not and or star div mod plus equal more less comma at per none).
	BinaryOpSyms := #(or comma minus equal not and or star div mod plus equal more less comma at per none).
	KeywordSelectorSyms := #(keyword keywordSequence).
	! !

!SOMParser methodsFor: 'accept and expect' stamp: 'StefanMarr 5/13/2012 12:16'!
accept: aSymbol
	sym == aSymbol ifTrue: [
		self getSym.
		^ true ].

	^ false! !

!SOMParser methodsFor: 'compatibility' stamp: 'StefanMarr 5/10/2012 21:58'!
apply: aSymbol
	"For compatibilty with OMeta"
	^ self perform: aSymbol! !

!SOMParser methodsFor: 'accessing' stamp: 'StefanMarr 5/9/2012 23:15'!
cgenc
	^ cgenc! !

!SOMParser methodsFor: 'accessing' stamp: 'StefanMarr 5/9/2012 23:16'!
cgenc: anObject
	cgenc := anObject! !

!SOMParser methodsFor: 'accept and expect' stamp: 'StefanMarr 5/13/2012 12:15'!
expect: aSymbol
	| msg |
	(self accept: aSymbol) ifTrue: [ ^ true ].
	
	msg := RWBinaryOrTextStream on: String new.
	msg nextPutAll: 'unexpected symbol in line '.
	msg nextPutAll: lexer currentLineNumber asString.
	msg nextPutAll: '. Expected '.
	msg nextPutAll: aSymbol asString.
	msg nextPutAll: ', but found '.
	msg nextPutAll: sym asString.
	
	self printableSymbol ifTrue: [
		msg nextPutAll: ' (', text contents, ')'.].
	
	msg nextPutAll: ': '.
	msg nextPutAll: lexer rawBuffer.
	
	Error signal: msg contents.! !

!SOMParser methodsFor: 'private' stamp: 'StefanMarr 5/10/2012 23:03'!
getSym
	sym  := lexer symbol.
	text := lexer text.! !

!SOMParser methodsFor: 'patterns' stamp: 'StefanMarr 5/15/2012 22:28'!
identifier
	| s | 
	s := text asSymbol.
	
	(self accept: #primitive) ifFalse: [
		self expect: #identifier]. 
	
	^ s! !

!SOMParser methodsFor: 'initialize-release' stamp: 'StefanMarr 5/13/2012 14:32'!
initialize
	super initialize.
	sym := #none.
	nextSym := #none.
	shouldReadSources := false.! !

!SOMParser methodsFor: 'helper' stamp: 'StefanMarr 5/13/2012 18:20'!
methodParser
	^ SOMMethodParser new
			universe: self universe;
			shouldReadSources: self shouldReadSources;
			yourself! !

!SOMParser methodsFor: 'accessing' stamp: 'StefanMarr 5/13/2012 18:20'!
parseState
	^ {sym. text. lexer. nextSym.}! !

!SOMParser methodsFor: 'accessing' stamp: 'StefanMarr 5/13/2012 18:21'!
parseState: state
	sym    := state first.
	text   := state second.
	lexer  := state third.
	nextSym:= state fourth.! !

!SOMParser methodsFor: 'private' stamp: 'StefanMarr 5/10/2012 23:03'!
peek
	nextSym := lexer peek.! !

!SOMParser methodsFor: 'private' stamp: 'StefanMarr 5/10/2012 23:09'!
printableSymbol
	^ sym == #integer         or: [
	  sym == #STString        or: [
	  sym == #identifier      or: [
	  sym == #keyword         or: [
	  sym == #keywordSequence or: [
	  sym == #operatorSequence    ]]]]]! !

!SOMParser methodsFor: 'accessing' stamp: 'StefanMarr 5/13/2012 14:31'!
shouldReadSources
	^ shouldReadSources! !

!SOMParser methodsFor: 'accessing' stamp: 'StefanMarr 5/13/2012 14:31'!
shouldReadSources: aBool
	shouldReadSources := aBool! !

!SOMParser methodsFor: 'accessing' stamp: 'StefanMarr 5/13/2012 18:52'!
stream: aReadStream
	lexer := SOMLexer on: aReadStream.
	self getSym.! !

!SOMParser methodsFor: 'helper' stamp: 'StefanMarr 5/13/2012 12:27'!
symIn: symbols
	^ symbols includes: sym ! !

!SOMParser methodsFor: 'accessing' stamp: 'StefanMarr 5/9/2012 23:16'!
universe
	^ universe! !

!SOMParser methodsFor: 'accessing' stamp: 'StefanMarr 5/9/2012 23:16'!
universe: anObject
	universe := anObject! !

!SOMParser methodsFor: 'patterns' stamp: 'StefanMarr 5/13/2012 12:27'!
variable
	^ self identifier! !

Object subclass: #SOMTools
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AweSOM-Meta'!

!SOMTools class methodsFor: 'fileout' stamp: 'rkrk 5/25/2009 00:36'!
fileout

	| cs pi |
	cs := ChangeSet newChangeSet.
	pi := PackageInfo named: 'AweSOM'.
	pi classes do: [:ea | cs addClass: ea].
	pi methods do: [:ea |
		cs
			noteNewMethod: ea compiledMethod
			forClass: ea actualClass
			selector: ea methodSymbol
			priorMethod: nil].
	cs fileOut.! !

!SOMTools class methodsFor: 'linting' stamp: 'rkrk 5/25/2009 00:34'!
lintOnClasses: classes

	| env |
	env := ClassEnvironment
		onEnvironment: BrowserEnvironment new
		classes: classes.
	ORLintBrowser
		openRule: RBCompositeLintRule allRules
		environment: env.! !

!SOMTools class methodsFor: 'as yet unclassified' stamp: 'rkrk 6/2/2009 13:12'!
loc

	| pi |
	pi := PackageInfo named: 'AweSOM'.
	^ pi classes inject: 0 into: [:sum :class | sum + class linesOfCode].
! !

!SOMTools class methodsFor: 'as yet unclassified' stamp: 'rkrk 6/2/2009 13:14'!
locWithoutTests

	| pi |
	pi := PackageInfo named: 'AweSOM'.
	^ (pi classes
		reject: [:class | class inheritsFrom: TestCase])
		inject: 0 into: [:sum :class | sum + class linesOfCode].
! !

!SOMTools class methodsFor: 'as yet unclassified' stamp: 'rkrk 6/3/2009 19:04'!
parseBenchmarkString: string

	"Extracts the numbers from the output"
	^ (string
		regex: 'RESULT\: [0-9]+ ms|All tests completed \([0-9]+ ms\)'
		matchesCollect: [:m | (m allRegexMatches: '[0-9]+') first])
		inject: ''
		into: [:all :ea | all , String cr , ea].
	! !

!SOMTools class methodsFor: 'recompiling' stamp: 'rkrk 5/29/2009 03:50'!
recompile

	"SOMTools recompile"
	(PackageInfo named: 'AweSOM') classes
		do: [:class | class compileAll]
		displayingProgress: 'Recompiling AweSOM'.! !

!SOMTools class methodsFor: 'class path' stamp: 'StefanMarr 5/9/2012 22:52'!
setClassPathBase: basePath

	"SOMTools setClassPathBase: SmalltalkImage current imagePath , '/SOM'"
	| standard examples dir |
	standard := {basePath , '/Smalltalk'. basePath , '/TestSuite'}.
	dir := FileDirectory on: basePath , '/Examples'.
	examples := dir directoryNames
		select: [:ea | (ea beginsWith: '.') not]
		thenCollect: [:ea | dir fullPathFor: ea].
	^ SOMUniverse classPaths: standard , examples.! !

!SOMTools class methodsFor: 'as yet unclassified' stamp: 'rkrk 7/14/2009 23:50'!
usefulStuff

"
SOMUniverse new start: {'TestHarness'}.
SOMUniverse new start: {'MoreBenchmarks'}.
SOMUniverse new start: {'Hello'}.
SOMUniverse new start: {'Echo'. '123'}.
SOMUniverse new start: {'StringTest'}.
SOMUniverse new start: {'All'}.
u := SOMUniverse new.
u eval: '(1 + 2) asString println'.
[u loadAndStoreFromSource: SOMBenchmarkRunner tinyBenchmarkClass] timeToRun.

"! !

Object subclass: #SOMUniverse
	instanceVariableNames: 'globals interpreter outStream heap symbolTable numberCache'
	classVariableNames: 'ClassPaths DefaultInterpreter UseOMeta'
	poolDictionaries: ''
	category: 'AweSOM-VM'!

!SOMUniverse class methodsFor: 'accessing' stamp: 'rkrk 9/28/2009 16:08'!
classPaths

	^ ClassPaths ifNil: [
		self notify: 'classPaths was not set. Use SOMTools>>setClassPathBase: and pass the path to the SOM directory'].! !

!SOMUniverse class methodsFor: 'accessing' stamp: 'mkl 4/29/2009 15:20'!
classPaths: anObject
	ClassPaths := anObject! !

!SOMUniverse class methodsFor: 'accessing' stamp: 'StefanMarr 5/15/2012 23:55'!
defaultInterpreter
	DefaultInterpreter ifNil: [DefaultInterpreter := SOMInterpreter ].
	^ DefaultInterpreter! !

!SOMUniverse class methodsFor: 'accessing' stamp: 'StefanMarr 5/15/2012 23:56'!
defaultInterpreter: interpClass
	DefaultInterpreter := interpClass! !

!SOMUniverse class methodsFor: 'accessing' stamp: 'StefanMarr 5/14/2012 23:46'!
useOMeta
	UseOMeta ifNil: [UseOMeta := true].
	^ UseOMeta! !

!SOMUniverse class methodsFor: 'accessing' stamp: 'StefanMarr 5/14/2012 23:46'!
useOMeta: aBool
	UseOMeta := aBool! !

!SOMUniverse methodsFor: 'bootstrapping' stamp: 'mha 11/16/2010 14:17'!
bootstrapMethod

	^ SOMMethod
		inUniverse: self
		named: #bootstrap
		numArgs: 1
		numLocals: 0
		maxStackDepth: 2
		bytecodes: {SOMBCHalt new}
		holder: (self globalAt: #System)
		lexicalContext: self globalNil.
! !

!SOMUniverse methodsFor: 'bootstrapping' stamp: 'mkl 5/13/2009 16:06'!
bootstrapWithArguments: args 

	self 
		bootstrapWithEntryPoint: ((self globalAt: #System) lookupInvokable: #initialize:)
		withArguments: args.! !

!SOMUniverse methodsFor: 'bootstrapping' stamp: 'rkrk 5/28/2009 01:11'!
bootstrapWithEntryPoint: invokable withArguments: args

	| bootstrapFrame |
	bootstrapFrame := (self interpreter pushNewFrameWithMethod: self bootstrapMethod)
		push: (self globalAt: #system);
		push: args;
		yourself.
	invokable ifNotNil: [invokable invokeInFrame: bootstrapFrame].
	self interpreter start.! !

!SOMUniverse methodsFor: 'universe configuration' stamp: 'StefanMarr 5/15/2012 23:40'!
classParser
	^ ((Smalltalk hasClassNamed: #SOMClassParser2) and: UseOMeta)
		ifTrue: [ Smalltalk at: #SOMClassParser2 ]
		ifFalse:[ SOMClassParser ]! !

!SOMUniverse methodsFor: 'accessing' stamp: 'mkl 5/13/2009 14:16'!
compiler

	^ SOMCompiler inUniverse: self on: self class classPaths! !

!SOMUniverse methodsFor: 'object creation' stamp: 'rkrk 6/4/2009 20:54'!
createGlobal: globalName somClass: className

	| sqClassName sqClass somClass instance |
	"If class exists in Squeak use it as base class"
	sqClassName :=  ('SOM' , className) asSymbol.
	sqClass := (Smalltalk
		classNamed: sqClassName)
		ifNil: [SOMObject].
	somClass := self
		globalAt: className
		ifAbsentPut: [self loadSOMClass: className].
	instance := sqClass
		inUniverse: self
		withSomClass: somClass.
	^ self
		globalAt: globalName
		put: instance.! !

!SOMUniverse methodsFor: 'code evaluation' stamp: 'rkrk 6/11/2009 18:45'!
createShellClassWith: code

	^ String streamContents: [:stream |
		stream
			nextPutAll: 'ShellClass = ('; cr;
			nextPutAll: 'run = ('; cr;
			nextPutAll: code; cr;
			nextPutAll: '))'].! !

!SOMUniverse methodsFor: 'code evaluation' stamp: 'rkrk 6/11/2009 18:48'!
eval: code

	| shellClassSource shellClass |
	self initializeRealGlobalsIfNecessary.
	shellClassSource := self createShellClassWith: code.
	shellClass := self loadAndStoreFromSource: shellClassSource.
	self start: {shellClass somName string}.! !

!SOMUniverse methodsFor: 'gobal accessing' stamp: 'rkrk 6/5/2009 01:58'!
globalAt: aSymbol 

	^ globals at: aSymbol! !

!SOMUniverse methodsFor: 'gobal accessing' stamp: 'mkl 5/13/2009 17:51'!
globalAt: aSymbol ifAbsent: aBlock
	^ globals at: aSymbol ifAbsent: aBlock.! !

!SOMUniverse methodsFor: 'gobal accessing' stamp: 'mkl 5/13/2009 15:40'!
globalAt: aSymbol ifAbsentPut: aBlock
"Treat nil values as absent values"
	| result |
	result := globals at: aSymbol ifAbsentPut: aBlock.
	result ifNil: [
		result := aBlock value.
		globals at: aSymbol put: result].
	^ result! !

!SOMUniverse methodsFor: 'gobal accessing' stamp: 'rkrk 6/5/2009 01:59'!
globalAt: aSymbol put: anObject 

	^ globals 
		at: aSymbol
		put: anObject! !

!SOMUniverse methodsFor: 'gobal accessing' stamp: 'rkrk 6/5/2009 01:55'!
globalNil

	^ self globalAt: #nil! !

!SOMUniverse methodsFor: 'gobal accessing' stamp: 'rkrk 5/8/2009 22:05'!
globals

	^ globals! !

!SOMUniverse methodsFor: 'gobal accessing' stamp: 'mkl 5/6/2009 17:56'!
hasGlobalAt: aSymbol 
	^ globals includesKey: aSymbol! !

!SOMUniverse methodsFor: 'accessing' stamp: 'rkrk 6/11/2009 20:56'!
heap
	^ heap! !

!SOMUniverse methodsFor: 'accessing' stamp: 'rkrk 6/11/2009 20:56'!
heap: anObject
	heap := anObject! !

!SOMUniverse methodsFor: 'initializing' stamp: 'rkrk 6/4/2009 22:46'!
initClassSystem

	| class metaclass |
	class := SOMClass inUniverse: self.
	metaclass := SOMClass inUniverse: self.
	class somClass: metaclass.
	metaclass somClass: class.
	metaclass somSuperClass: class.
	self globalAt: #Class put: class.
	self globalAt: #Metaclass put: metaclass.! !

!SOMUniverse methodsFor: 'initializing' stamp: 'rkrk 6/4/2009 22:49'!
initNil

	self globalAt: #nil put: nil.
	self globalAt: #nil put: (SOMObject inUniverse: self).! !

!SOMUniverse methodsFor: 'initializing' stamp: 'rkrk 6/5/2009 02:12'!
initSystemClassFrom: sqClass

	| superclass somClass |
	superclass := sqClass = SOMObject
		ifTrue: [self globalNil]
		ifFalse: [self globalAt: sqClass superclass somName].
	somClass := SOMClass
		inUniverse: self
		withSomSuperClass: superclass.
	self
		globalAt: sqClass somName
		ifAbsentPut: [somClass].! !

!SOMUniverse methodsFor: 'initializing' stamp: 'rkrk 6/5/2009 01:11'!
initSystemClassesWith: classLoader

	| systemClasses name |
	systemClasses := self sortedSubClassesOf: SOMObject.
	systemClasses do: [:class | self initSystemClassFrom: class].
	(self globalAt: #Class) somSuperClass: (self globalAt: #Object).
	systemClasses do: [:class |
		name := class somName.
		(self globalAt: name) somName: (self newSymbol: name).
		classLoader value: name].! !

!SOMUniverse methodsFor: 'initializing' stamp: 'StefanMarr 5/15/2012 23:56'!
initialize

	super initialize.
	self interpreter: (self class defaultInterpreter inUniverse: self).
	globals := Dictionary new.
	heap := SOMHeap in: self.
	symbolTable := SOMSymbolTable in: self.
	numberCache := IdentityDictionary new.! !

!SOMUniverse methodsFor: 'initializing' stamp: 'rkrk 6/4/2009 23:20'!
initializeFakeGlobals

	| nilClass |
	self
		initNil;
		initClassSystem;
		initSystemClassesWith: [:className | "do nothing"].
	"prepare for tests"
	nilClass := SOMClass 
		inUniverse: self
		withSomSuperClass: (self globalAt: #Object).
	(self globalAt: #nil) somClass: nilClass.
	self globalAt: #Nil put: nilClass.
	self globalAt: #system put: (SOMSystem inUniverse: self).
	self globalAt: #System put: (SOMClass inUniverse: self).
	self globalAt: #true put: (SOMObject inUniverse: self).
	self globalAt: #false put: (SOMObject inUniverse: self).! !

!SOMUniverse methodsFor: 'initializing' stamp: 'rkrk 6/5/2009 02:03'!
initializeRealGlobals

	"self initializeGlobalsWithClassLoader: [:className | self loadSOMClass: className]."
	self
		initNil;
		initClassSystem;
		createGlobal: #nil somClass: #Nil;
		createGlobal: #true somClass: #True;
		createGlobal: #false somClass: #False;
		initSystemClassesWith: [:className | self loadSystemClass: className];
		createGlobal: #system somClass: #System.! !

!SOMUniverse methodsFor: 'initializing' stamp: 'rkrk 6/11/2009 18:48'!
initializeRealGlobalsIfNecessary

	self globalAt: #Array ifAbsent: [self initializeRealGlobals].! !

!SOMUniverse methodsFor: 'accessing' stamp: 'arv 5/8/2009 10:55'!
interpreter
	^ interpreter! !

!SOMUniverse methodsFor: 'accessing' stamp: 'arv 5/8/2009 10:55'!
interpreter: anObject
	interpreter := anObject! !

!SOMUniverse methodsFor: 'loading' stamp: 'rkrk 6/5/2009 02:24'!
loadAndStoreFromSource: source

	| class |
	class := self compiler
		compileSOMClassSource: source
		stub: nil.
	^ self
		globalAt: class somName string
		put: class! !

!SOMUniverse methodsFor: 'loading' stamp: 'rkrk 6/5/2009 01:16'!
loadAndStoreSOMClass: className

	^ self
		globalAt: className
		put: (self loadSOMClass: className)! !

!SOMUniverse methodsFor: 'loading' stamp: 'rkrk 6/5/2009 01:24'!
loadSOMClass: className

	^ self compiler
		loadAndCompileSOMClass: className
		stub: nil.! !

!SOMUniverse methodsFor: 'loading' stamp: 'rkrk 6/5/2009 01:24'!
loadSystemClass: classStubName

	^ self compiler
		loadAndCompileSOMClass: classStubName
		stub: (self globalAt: classStubName ifAbsent: [nil]).! !

!SOMUniverse methodsFor: 'universe configuration' stamp: 'StefanMarr 5/17/2012 16:36'!
methodClass
	^ SOMMethod! !

!SOMUniverse methodsFor: 'universe configuration' stamp: 'StefanMarr 5/17/2012 16:16'!
methodGenClass
	^ SOMMethodGenerationContext! !

!SOMUniverse methodsFor: 'universe configuration' stamp: 'StefanMarr 5/15/2012 23:41'!
methodParser
	^ ((Smalltalk hasClassNamed: #SOMMethodParser2) and: UseOMeta)
		ifTrue: [ Smalltalk at: #SOMMethodParser2 ]
		ifFalse:[ SOMMethodParser ]! !

!SOMUniverse methodsFor: 'object creation' stamp: 'rkrk 5/29/2009 01:17'!
newArrayWithAll: collection

	^ SOMArray
		inUniverse: self
		withAll: collection! !

!SOMUniverse methodsFor: 'object creation' stamp: 'rkrk 5/28/2009 01:07'!
newBool: squeakBool

	^ self globals at: squeakBool name asSymbol.! !

!SOMUniverse methodsFor: 'object creation' stamp: 'rkrk 6/11/2009 22:14'!
newNumber: number

	^ self numberCache
		at: number
		ifAbsentPut: [SOMNumber create: number in: self].! !

!SOMUniverse methodsFor: 'object creation' stamp: 'rkrk 5/8/2009 21:42'!
newString: string

	^ SOMString
		inUniverse: self
		string: string! !

!SOMUniverse methodsFor: 'object creation' stamp: 'rkrk 6/11/2009 21:22'!
newSymbol: symbolOrString

	^ self symbolTable somSymbolFor: symbolOrString.! !

!SOMUniverse methodsFor: 'accessing' stamp: 'rkrk 6/11/2009 21:32'!
numberCache
	^ numberCache! !

!SOMUniverse methodsFor: 'accessing' stamp: 'rkrk 6/11/2009 21:32'!
numberCache: anObject
	numberCache := anObject! !

!SOMUniverse methodsFor: 'accessing' stamp: 'rkrk 6/3/2009 19:38'!
outStream

	^ outStream ifNil: [Transcript]! !

!SOMUniverse methodsFor: 'accessing' stamp: 'rkrk 6/3/2009 19:39'!
outStream: writeStream

	outStream := writeStream! !

!SOMUniverse methodsFor: 'universe configuration' stamp: 'StefanMarr 5/17/2012 16:35'!
primitiveClass
	^ SOMPrimitive! !

!SOMUniverse methodsFor: 'quiting' stamp: 'mha 10/29/2010 10:23'!
quit: errorCode

	interpreter stop.
	Transcript
		cr; cr; cr;
		show: 'VM exited with error code ', errorCode number asString! !

!SOMUniverse methodsFor: 'initializing' stamp: 'rkrk 6/4/2009 22:41'!
sortedSubClassesOf: class

	"Sort by inheritance hierarchy"
	^ (SortedCollection sortBlock: [:a :b | (a inheritsFrom: b) not])
		addAll: class withAllSubclasses;
		sortTopologically;
		yourself! !

!SOMUniverse methodsFor: 'initializing' stamp: 'rkrk 6/11/2009 18:48'!
start: arguments

	| wrappedArguments |
 	self initializeRealGlobalsIfNecessary.
	wrappedArguments := arguments collect: [ :arg | self newString: arg].
	self bootstrapWithArguments: (SOMArray inUniverse: self withAll: wrappedArguments).! !

!SOMUniverse methodsFor: 'gobal accessing' stamp: 'rkrk 5/8/2009 22:29'!
symbolFor: global

	self flag: #rkrk. "Should return SOMSymbol!!!!?"
	^ globals keyAtValue: global ifAbsent: [nil].! !

!SOMUniverse methodsFor: 'accessing' stamp: 'rkrk 6/11/2009 21:22'!
symbolTable
	^ symbolTable! !

!SOMUniverse methodsFor: 'accessing' stamp: 'rkrk 6/11/2009 21:22'!
symbolTable: anObject
	symbolTable := anObject! !

Object subclass: #SOMVariableLookup
	instanceVariableNames: 'varName mgenc universe isArgument isLocal isGlobal isField index contextIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AweSOM-Compiler'!

!SOMVariableLookup class methodsFor: 'instance creation' stamp: 'rkrk 5/10/2009 00:15'!
lookupVar: varName inMethodContext: mgenc inUniverse: universe

	^ self new
		varName: varName;
		mgenc: mgenc;
		universe: universe;
		lookup;
		yourself.! !

!SOMVariableLookup methodsFor: 'accessing' stamp: 'rkrk 5/10/2009 01:13'!
contextIndex
	^ contextIndex! !

!SOMVariableLookup methodsFor: 'accessing' stamp: 'rkrk 5/10/2009 01:13'!
contextIndex: anObject
	contextIndex := anObject! !

!SOMVariableLookup methodsFor: 'testing' stamp: 'StefanMarr 5/12/2012 23:28'!
found

	^ self isArgument or: [
	  self isLocal    or: [
	  self isField    or: [
	  self isGlobal]]]! !

!SOMVariableLookup methodsFor: 'accessing' stamp: 'rkrk 5/10/2009 01:13'!
index
	^ index! !

!SOMVariableLookup methodsFor: 'accessing' stamp: 'rkrk 5/10/2009 01:13'!
index: anObject
	index := anObject! !

!SOMVariableLookup methodsFor: 'initialization' stamp: 'rkrk 5/10/2009 00:55'!
initialize

	isGlobal := isLocal := isField := isArgument := false.
	! !

!SOMVariableLookup methodsFor: 'accessing' stamp: 'rkrk 5/10/2009 00:54'!
isArgument
	^ isArgument! !

!SOMVariableLookup methodsFor: 'accessing' stamp: 'rkrk 5/10/2009 00:54'!
isArgument: anObject
	isArgument := anObject! !

!SOMVariableLookup methodsFor: 'accessing' stamp: 'rkrk 5/10/2009 00:54'!
isField
	^ isField! !

!SOMVariableLookup methodsFor: 'accessing' stamp: 'rkrk 5/10/2009 00:54'!
isField: anObject
	isField := anObject! !

!SOMVariableLookup methodsFor: 'accessing' stamp: 'rkrk 5/10/2009 00:54'!
isGlobal
	^ isGlobal! !

!SOMVariableLookup methodsFor: 'accessing' stamp: 'rkrk 5/10/2009 00:54'!
isGlobal: anObject
	isGlobal := anObject! !

!SOMVariableLookup methodsFor: 'accessing' stamp: 'rkrk 5/10/2009 00:54'!
isLocal
	^ isLocal! !

!SOMVariableLookup methodsFor: 'accessing' stamp: 'rkrk 5/10/2009 00:54'!
isLocal: anObject
	isLocal := anObject! !

!SOMVariableLookup methodsFor: 'lookup' stamp: 'rkrk 5/28/2009 22:48'!
lookup

	#(#lookupArgument #lookupLocal #lookupField #lookupGlobal) do: [:sel |
		self perform: sel.
		self found ifTrue: [^ self]].! !

!SOMVariableLookup methodsFor: 'lookup' stamp: 'rkrk 5/10/2009 01:12'!
lookupArgument

	| currentContext ctxIdx idx |
	currentContext := mgenc.
	ctxIdx := 0.
	idx := 0.
	[idx := currentContext arguments indexOf: varName.
	ctxIdx := ctxIdx + 1.
	currentContext := currentContext outer.
	] doWhileTrue: [idx isZero and: [currentContext notNil]].
	idx isZero ifTrue: [^ self].
	self
		isArgument: true;
		index: idx;
		contextIndex: ctxIdx.! !

!SOMVariableLookup methodsFor: 'lookup' stamp: 'rkrk 5/28/2009 23:41'!
lookupField

	| fields cgenc |
	cgenc := mgenc somHolder.
	cgenc ifNil: [self error: 'mgenc has no holder!!!!!!'].
	"(self varName = 'class' and: [self mgenc holder theName = #ClassA]) ifTrue: [self halt]."
	fields := cgenc isClassSide
		ifFalse: [cgenc allInstanceFieldsIn: self universe]
		ifTrue: [cgenc allClassFieldsIn: self universe].
	(fields includes: varName) ifTrue: [self isField: true]! !

!SOMVariableLookup methodsFor: 'lookup' stamp: 'rkrk 5/29/2009 01:31'!
lookupGlobal

	"if it's nothing else then it's a global"
	self isGlobal: true.
	"issue a warning if the global dict doesn't contain the reference'"
	(self universe hasGlobalAt: self varName asSymbol) ifTrue: [^ self].
	"Transcript
		cr;
		show: 'WARNING: Recognized variable named ';
		show: self varName;
		show: ' in ';
		show: self mgenc holder theName;
		show: '>>';
		show: self mgenc signature;
		show: ' as global but variable doesn''t appear in global dict!!'."! !

!SOMVariableLookup methodsFor: 'lookup' stamp: 'rkrk 5/10/2009 01:13'!
lookupLocal

	| currentContext ctxIdx idx |
	currentContext := mgenc.
	ctxIdx := 0.
	idx := 0.
	[idx := currentContext locals indexOf: varName.
	ctxIdx := ctxIdx + 1.
	currentContext := currentContext outer.
	] doWhileTrue: [idx isZero and: [currentContext notNil]].
	idx isZero ifTrue: [^ self].
	self
		isLocal: true;
		index: idx;
		contextIndex: ctxIdx.! !

!SOMVariableLookup methodsFor: 'accessing' stamp: 'rkrk 5/10/2009 00:14'!
mgenc
	^ mgenc! !

!SOMVariableLookup methodsFor: 'accessing' stamp: 'rkrk 5/10/2009 00:14'!
mgenc: anObject
	mgenc := anObject! !

!SOMVariableLookup methodsFor: 'accessing' stamp: 'rkrk 5/10/2009 00:54'!
universe
	^ universe! !

!SOMVariableLookup methodsFor: 'accessing' stamp: 'rkrk 5/10/2009 00:54'!
universe: anObject
	universe := anObject! !

!SOMVariableLookup methodsFor: 'accessing' stamp: 'rkrk 5/10/2009 00:14'!
varName
	^ varName! !

!SOMVariableLookup methodsFor: 'accessing' stamp: 'rkrk 5/10/2009 00:14'!
varName: anObject
	varName := anObject! !

IdentityDictionary subclass: #SOMSymbolTable
	instanceVariableNames: 'universe'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AweSOM-VM'!

!SOMSymbolTable class methodsFor: 'as yet unclassified' stamp: 'rkrk 6/11/2009 21:24'!
in: universe

	^ self new
		universe: universe;
		yourself.! !

!SOMSymbolTable methodsFor: 'as yet unclassified' stamp: 'rkrk 6/11/2009 21:23'!
somSymbolFor: squeakSymbol

	^ self
		at: squeakSymbol 
		ifAbsentPut: [SOMSymbol
			inUniverse: self universe
			string: squeakSymbol].! !

!SOMSymbolTable methodsFor: 'accessing' stamp: 'rkrk 6/11/2009 21:24'!
universe
	^ universe! !

!SOMSymbolTable methodsFor: 'accessing' stamp: 'rkrk 6/11/2009 21:24'!
universe: anObject
	universe := anObject! !

!SortedCollection methodsFor: '*AweSOM-Squeak-compatibility' stamp: 'StefanMarr 5/9/2012 22:48'!
should: a precede: b

	^ sortBlock ifNil: [a <= b] ifNotNil: [sortBlock value: a value: b]! !

!SortedCollection methodsFor: '*AweSOM-Squeak-compatibility' stamp: 'StefanMarr 5/9/2012 22:47'!
sortTopologically
	"Plenty of room for increased efficiency in this one."

	| remaining result pick |
	remaining := self asOrderedCollection.
	result := OrderedCollection new.
	[remaining isEmpty] whileFalse: [
		pick := remaining select: [:item |
			remaining allSatisfy: [:anotherItem |
				item == anotherItem or: [self should: item precede: anotherItem]]].
		pick isEmpty ifTrue: [self error: 'bad topological ordering'].
		result addAll: pick.
		remaining removeAll: pick].
	^self copySameFrom: result! !

TestCase subclass: #TestCaseWithUniverse
	instanceVariableNames: 'universe'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AweSOM-Test'!

TestCaseWithUniverse subclass: #CompileSOMClassTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AweSOM-Compiler-Test'!

!CompileSOMClassTest methodsFor: 'as yet unclassified' stamp: 'rkrk 6/5/2009 00:53'!
assertSuperClassOf: className is: superClassName

	self
		assert: (universe globalAt: superClassName)
		equals: (universe globalAt: className) somSuperClass.! !

!CompileSOMClassTest methodsFor: 'as yet unclassified' stamp: 'rkrk 6/5/2009 02:26'!
compileSource: source
	
	^ universe loadAndStoreFromSource: source! !

!CompileSOMClassTest methodsFor: 'as yet unclassified' stamp: 'StefanMarr 5/14/2012 23:16'!
createCgencFromSource: source
	
	| parser |
	parser := universe classParser inUniverse: universe onSource: source.
	parser start.
	^ parser cgenc.! !

!CompileSOMClassTest methodsFor: 'as yet unclassified' stamp: 'rkrk 6/4/2009 13:28'!
test01SimpleClassCreation

	| cgenc clazz |
	cgenc := SOMClassGenerationContext new.
	cgenc theName: 'Robert'.
	cgenc instanceFields: {  'alter'. 'adresse'  }.
	clazz := cgenc assembleIn: universe.
	self assert: (clazz isKindOf: SOMClass).
	self assert: clazz somName symbol equals: #Robert.
	self assert: clazz somClass somName symbol equals: #'Robert class'.
	self assert: clazz somSuperClass equals: (universe globalAt: #Object).
	self assert: clazz somInstanceFields size equals: 2.
	self assert: (clazz somInstanceFields at: 1) string equals: 'alter'! !

!CompileSOMClassTest methodsFor: 'as yet unclassified' stamp: 'mkl 5/27/2009 15:55'!
test02CompileClass
	| cgenc clazz |
	cgenc := SOMClassGenerationContext new.
	cgenc classFields: {  'alter'  }.
	clazz := cgenc assembleIn: universe.
	self 
		assert: (clazz somClass somInstanceFields at: 1) string
		equals: 'alter'! !

!CompileSOMClassTest methodsFor: 'as yet unclassified' stamp: 'mkl 5/27/2009 16:16'!
test03CompileClassWithMethod
	| cgenc clazz |
	cgenc := self createCgencFromSource: 'Bla = Array (method1 = (^ 42) method2 = primitive ---- classMethod = ())'.
	clazz := cgenc assembleIn: universe.
	self 
		assert: clazz somInstanceInvokables size
		equals: 2.
	self assert: ((clazz somInstanceInvokables at: 1) isKindOf: SOMMethod).
	self assert: ((clazz somInstanceInvokables at: 2) isKindOf: SOMPrimitive).
	self 
		assert: clazz somClass somInstanceInvokables size
		equals: 1! !

!CompileSOMClassTest methodsFor: 'as yet unclassified' stamp: 'mkl 5/27/2009 16:08'!
test04CompileClassWithSuperclass
	| cgenc clazz |
	cgenc := self createCgencFromSource: 'Bla = Array (method1 = (^ 42) method2 = primitive)'.
	clazz := cgenc assembleIn: universe.
	self 
		assert: clazz somSuperClass
		equals: (universe globalAt: #Array)
	"self assert: clazz superClazz theName symbol equals: #Array."! !

!CompileSOMClassTest methodsFor: 'as yet unclassified' stamp: 'StefanMarr 5/13/2012 18:39'!
test05UnsharedFieldInMethodSubClass
	| cgenc somClass instance privateInstVarNames |
	
	"Instance fields declared in SOM might not map properly to the field 'fields', if on the VM-side instance fields are added to subclasses of SOMObject that are not supposed to be visible from SOM, e.g. Method's field 'bytecodes'."
	
	self loadClazzes: {  #Object. #Method  }.
	cgenc := self createCgencFromSource: 
	  'MethodSubClass = Method(	| thisMightCollideWithBytecodes |
	   setField = (thisMightCollideWithBytecodes := 42.))'.
	somClass := cgenc assembleIn: universe.
	instance := somClass primnew.
	universe 
		bootstrapWithEntryPoint: (somClass somInstanceInvokables at: 1)
		withArguments: instance.
	privateInstVarNames := instance class instVarNames select: [ :each | (each beginsWith: 'som') not ].
	privateInstVarNames do: 
		[ :each | 
		self 
			assert: ((universe newNumber: 42) primEqual: (instance instVarNamed: each))
			equals: (universe globalAt: #false) ]! !

!CompileSOMClassTest methodsFor: 'as yet unclassified' stamp: 'rkrk 6/4/2009 14:39'!
test06AssembleNormalClass

	| class |
	class := self compileSource: 'Test = (| a b| m1=(1+2))'.
	self assert: class somInstanceFields elements second string equals: 'b'.
	self assert: class somInstanceInvokables size equals: 1.! !

!CompileSOMClassTest methodsFor: 'as yet unclassified' stamp: 'rkrk 6/5/2009 00:55'!
xtest07InternalClassHierarchyEqualsSomClassHierarchy

	"This test is currently deactivated. It tests if the class
	hierarchy of system classes is the same as in SOM. Currently
	it isn't but there could be problems in the future because of this'"
	universe := SOMUniverse new.
	universe initializeRealGlobals.
	"self assertSuperClassOf: #Object is: #nil."
	self assertSuperClassOf: #Class is: #Object.
	self assertSuperClassOf: #Metaclass is: #Class.
	self assertSuperClassOf: #Nil is: #Object.
	self assertSuperClassOf: #Array is: #Object.
	self assertSuperClassOf: #Method is: #Array.
	self assertSuperClassOf: #Symbol is: #Object.
	self assertSuperClassOf: #Integer is: #Object.
	self assertSuperClassOf: #BigInteger is: #Object.
	self assertSuperClassOf: #Frame is: #Array.
	self assertSuperClassOf: #Primitive is: #Object.
	self assertSuperClassOf: #String is: #Object.
	self assertSuperClassOf: #Double is: #Object.! !

TestCaseWithUniverse subclass: #CompileSOMMethodTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AweSOM-Compiler-Test'!

!CompileSOMMethodTest methodsFor: 'as yet unclassified' stamp: 'StefanMarr 5/14/2012 23:17'!
createMgencFromSource: source
	
	| parser |
	parser := universe methodParser inUniverse: universe onSource: source.
	^ parser apply: #method.! !

!CompileSOMMethodTest methodsFor: 'as yet unclassified' stamp: 'StefanMarr 5/17/2012 16:17'!
test01BuildSimpleMethod
	| mgenc method |
	mgenc := universe methodGenClass named: 'a:b:c:'.
	method := mgenc assembleIn: universe.
	self 
		assert: method somSignature symbol
		equals: #a:b:c:! !

!CompileSOMMethodTest methodsFor: 'as yet unclassified' stamp: 'arv 5/13/2009 23:44'!
test02BuildByteCode
	| mgenc method |
	mgenc := self createMgencFromSource: 'x: a = (|aLocal| ^a)'.
	method := mgenc assembleIn: universe.
	{SOMBCPushArgument. SOMBCReturnLocal} withIndexDo: [:each :i|
		self assert: ((method bytecodeAt: i) isKindOf: each)].
	self assert: method numberOfLocals equals: 1.
	self assert: method numberOfArguments equals: 2.
! !

!CompileSOMMethodTest methodsFor: 'as yet unclassified' stamp: 'mkl 5/13/2009 16:44'!
test02BuildMethodWithConstants
	| mgenc method |
	mgenc := self createMgencFromSource: 'x: a = (a foo: 42)'.
	method := mgenc assembleIn: universe.
	"waiting for arvid's patch"
	"self assert: (method constantForBytecodeIndex: 1) symbol equals: #foo."! !

TestCaseWithUniverse subclass: #ParseClassTest
	instanceVariableNames: 'parser result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AweSOM-Compiler-Test'!

ParseClassTest subclass: #ParseBytecodeTest
	instanceVariableNames: 'bytecode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AweSOM-Compiler-Test'!

!ParseBytecodeTest methodsFor: 'assertion' stamp: 'rkrk 5/9/2009 00:21'!
assertBcAt: idx is: bcType

	self assert: ((bytecode at: idx) isKindOf: bcType).! !

!ParseBytecodeTest methodsFor: 'assertion' stamp: 'rkrk 5/9/2009 00:27'!
assertLiteralAt: idx accessor: accessorSelector equals: expected

	| literal inner |
	literal := (bytecode at: idx) literalValue.
	self
		assert: (literal respondsTo: accessorSelector)
		description: 'wrong kind of SOMObject?'.
	inner := literal perform: accessorSelector.
	self assert: inner equals: expected.! !

!ParseBytecodeTest methodsFor: 'assertion' stamp: 'rkrk 5/9/2009 00:28'!
assertLiteralAt: idx equals: expected

	| literal |
	literal := (bytecode at: idx) literalValue.
	self assert: literal equals: expected.! !

!ParseBytecodeTest methodsFor: 'running' stamp: 'StefanMarr 5/14/2012 23:18'!
parserClass

	^ universe methodParser! !

!ParseBytecodeTest methodsFor: 'as yet unclassified' stamp: 'rkrk 5/10/2009 01:35'!
setUpParser: source

	super setUpParser: source.
	parser
		fakeCgenc;
		fakeMgenc.! !

!ParseBytecodeTest methodsFor: 'running' stamp: 'rkrk 5/9/2009 00:29'!
setUpParser: source andApply: rule

	super setUpParser: source andApply: rule.
	(result respondsTo: #bytecode) ifTrue: [
		bytecode := result bytecode]! !

!ParseBytecodeTest methodsFor: 'running' stamp: 'rkrk 5/10/2009 01:22'!
setUpParser: source withMgencAndApply: rule

	self setUpParser: source.
	result := parser apply: rule.
	(result respondsTo: #bytecode) ifTrue: [
		bytecode := result bytecode]! !

!ParseBytecodeTest methodsFor: 'tests' stamp: 'rkrk 5/9/2009 04:14'!
test01EmptyMethod

	self setUpParser: 'x = ()' andApply: #method.
	self assertNoFail: result.
	self assert: result locals isEmpty.
	self assert: result arguments size equals: 1. "self"
	self assert: result literals isEmpty.
	self assert: result bytecodeCount equals: 4.
	self assertBcAt: 2 is: SOMBCReturnLocal.! !

!ParseBytecodeTest methodsFor: 'tests' stamp: 'rkrk 5/9/2009 00:11'!
test02Constant

	self setUpParser: 'x = (1)' andApply: #method.
	self assertNoFail: result.
	self assert: result literals size equals: 1.
	self assert: result bytecodeCount equals: 7.
	self assert: result literals first number equals: 1.! !

!ParseBytecodeTest methodsFor: 'tests' stamp: 'rkrk 5/9/2009 00:12'!
test03aReturnObject

	self setUpParser: 'x = (^1.)' andApply: #method.
	self assertNoFail: result.
	self assert: result bytecodeCount equals: 3.
	self assert: result bytecode size equals: 2! !

!ParseBytecodeTest methodsFor: 'tests' stamp: 'rkrk 5/9/2009 00:12'!
test03bReturnObject

	self setUpParser: 'x = (^1)' andApply: #method.
	self assertNoFail: result.
	self assert: result bytecodeCount equals: 3.
	self assert: result bytecode size equals: 2! !

!ParseBytecodeTest methodsFor: 'tests' stamp: 'rkrk 5/9/2009 00:12'!
test04MultipleExpressions

	self setUpParser: 'x = (1. 2. 3. ^self)' andApply: #method.
	self assertNoFail: result.
	self assert: result isFinished.
	self assert: result bytecodeCount equals: 13.
	self assert: result bytecode size equals: 8.
	self assertBcAt: 8 is: SOMBCReturnLocal.! !

!ParseBytecodeTest methodsFor: 'tests' stamp: 'rkrk 5/9/2009 00:12'!
test05UnaryMessage

	self setUpParser: 'x = (1 test)' andApply: #method.
	self assertNoFail: result.
	self assert: result bytecode size equals: 5.
	self assertLiteralAt: 2 equals: 'test'.
	self assert: result bytecodeCount equals: 9.
! !

!ParseBytecodeTest methodsFor: 'tests' stamp: 'rkrk 5/9/2009 00:13'!
test06MultipleUnaryMessages

	self setUpParser: 'x = (1 test test2 test3)' andApply: #method.
	self assertNoFail: result.
	self assert: result bytecode size equals: 7.
	self assertLiteralAt: 3 equals: 'test2'.
	self assertLiteralAt: 4 equals: 'test3'.
	self assert: result bytecodeCount equals: 13.
! !

!ParseBytecodeTest methodsFor: 'tests' stamp: 'rkrk 5/9/2009 00:13'!
test07BinaryMessage

	self setUpParser: 'x = (1 + 2)' andApply: #method.
	self assertNoFail: result.
	self assertLiteralAt: 1 accessor: #number equals: 1.
	self assertLiteralAt: 2 accessor: #number equals: 2.
	self assertLiteralAt: 3 equals: '+'.! !

!ParseBytecodeTest methodsFor: 'tests' stamp: 'rkrk 5/9/2009 00:13'!
test08BinaryUnaryMessage

	self setUpParser: 'x = (1 + 2 test)' andApply: #method.
	self assertNoFail: result.
	self assertLiteralAt: 1 accessor: #number equals: 1.
	self assertLiteralAt: 2 accessor: #number equals: 2.
	self assertLiteralAt: 3 equals: 'test'.
	self assertLiteralAt: 4 equals: '+'.
	self assert: result bytecode size equals: 7.! !

!ParseBytecodeTest methodsFor: 'tests' stamp: 'rkrk 5/9/2009 00:13'!
test09MultipleBinaryMessages

	self setUpParser: 'x = (1 + 2 ++ 3)' andApply: #method.
	self assertNoFail: result.
	self assertLiteralAt: 1 accessor: #number equals: 1.
	self assertLiteralAt: 2 accessor: #number equals: 2.
	self assertLiteralAt: 4 accessor: #number equals: 3.
	self assertLiteralAt: 3 equals: '+'.
	self assertLiteralAt: 5 equals: '++'.! !

!ParseBytecodeTest methodsFor: 'tests' stamp: 'rkrk 5/9/2009 00:13'!
test10aKeywordMessage

	self setUpParser: 'x = (1 a: 2)' andApply: #method.
	self assertNoFail: result.
	self assertLiteralAt: 1 accessor: #number equals: 1.
	self assertLiteralAt: 2 accessor: #number equals: 2.
	self assertLiteralAt: 3 equals: 'a:'.! !

!ParseBytecodeTest methodsFor: 'tests' stamp: 'rkrk 5/9/2009 00:13'!
test10bKeywordMessage

	self setUpParser: 'x = (1 a: 2 b: 3)' andApply: #method.
	self assertNoFail: result.
	self assertLiteralAt: 1 accessor: #number equals: 1.
	self assertLiteralAt: 2 accessor: #number equals: 2.
	self assertLiteralAt: 3 accessor: #number equals: 3.
	self assertLiteralAt: 4 equals: 'a:b:'.! !

!ParseBytecodeTest methodsFor: 'tests' stamp: 'rkrk 5/9/2009 00:13'!
test10cKeywordMessage

	self setUpParser: 'x = (1 a: self test)' andApply: #method.
	self assertNoFail: result.
	self assertLiteralAt: 1 accessor: #number equals: 1.
	self assertLiteralAt: 3 equals: 'test'.
	self assertLiteralAt: 4 equals: 'a:'.! !

!ParseBytecodeTest methodsFor: 'tests' stamp: 'rkrk 5/9/2009 00:13'!
test10dKeywordMessage

	self setUpParser: 'x = (self test a: 1)' andApply: #method.
	self assertNoFail: result.
	self assertLiteralAt: 3 accessor: #number equals: 1.
	self assertLiteralAt: 2 equals: 'test'.
	self assertLiteralAt: 4 equals: 'a:'.! !

!ParseBytecodeTest methodsFor: 'tests' stamp: 'rkrk 5/9/2009 00:13'!
test11KeywordBinaryMessage

	self setUpParser: 'x = (1 + 2 a: 3 b: 4)' andApply: #method.
	self assertNoFail: result.
	self assertLiteralAt: 1 accessor: #number equals: 1.
	self assertLiteralAt: 2 accessor: #number equals: 2.
	self assertLiteralAt: 3 equals: '+'.
	self assertLiteralAt: 4 accessor: #number equals: 3.
	self assertLiteralAt: 5 accessor: #number equals: 4.
	self assertLiteralAt: 6 equals: 'a:b:'.! !

!ParseBytecodeTest methodsFor: 'tests' stamp: 'rkrk 5/9/2009 00:46'!
test12KeywordBinaryUnaryMessage

	self setUpParser: 'x = (1 + 2 test a: 3 test2 b: 4 test3.)' andApply: #method.
	self assertNoFail: result.
	self assertLiteralAt: 1 accessor: #number equals: 1.
	self assertLiteralAt: 2 accessor: #number equals: 2.
	self assertLiteralAt: 3 equals: 'test'.
	self assertLiteralAt: 4 equals: '+'.
	self assertLiteralAt: 5 accessor: #number equals: 3.
	self assertLiteralAt: 6 equals: 'test2'.
	self assertLiteralAt: 7 accessor: #number equals: 4.
	self assertLiteralAt: 8 equals: 'test3'.
	self assertLiteralAt: 9 equals: 'a:b:'.! !

!ParseBytecodeTest methodsFor: 'tests' stamp: 'rkrk 5/9/2009 00:46'!
test13ParenthesisExpr

	self setUpParser: 'x = ((1 + 2) test)' andApply: #method.
	self assertNoFail: result.
	self assertLiteralAt: 1 accessor: #number equals: 1.
	self assertLiteralAt: 2 accessor: #number equals: 2.
	self assertLiteralAt: 3 equals: '+'.
	self assertLiteralAt: 4 equals: 'test'.! !

!ParseBytecodeTest methodsFor: 'tests' stamp: 'rkrk 5/9/2009 02:10'!
test14aSuperSimple

	self setUpParser: 'x = (super test)' andApply: #method.
	self assertNoFail: result.
	self assert: bytecode first index equals: 1. "self"
	self assertLiteralAt: 2 equals: 'test'.
	self assertBcAt: 2 is: SOMBCSuperSend.! !

!ParseBytecodeTest methodsFor: 'tests' stamp: 'rkrk 5/9/2009 02:11'!
test14bSuperMsgAsArg

	self setUpParser: 'x = (1 a: super test)' andApply: #method.
	self assertNoFail: result.
	self assertLiteralAt: 1 accessor: #number equals: 1.
	self assert: bytecode second index equals: 1. "self"
	self assertLiteralAt: 3 equals: 'test'.
	self assertBcAt: 3 is: SOMBCSuperSend.
	self assertLiteralAt: 4 equals: 'a:'.
	self assertBcAt: 4 is: SOMBCSend.! !

!ParseBytecodeTest methodsFor: 'tests' stamp: 'rkrk 5/9/2009 00:46'!
test15SimpleBlock

	self setUpParser: 'x = ([])' andApply: #method.
	self assertNoFail: result.
	self assertBcAt: 1 is: SOMBCPushBlock.! !

!ParseBytecodeTest methodsFor: 'tests' stamp: 'rkrk 5/9/2009 00:45'!
test16SimpleBlockWithContent

	self setUpParser: 'x = ([1])' andApply: #method.
	self assertNoFail: result.
	self assertBcAt: 1 is: SOMBCPushBlock.
	self assertNoFail: bytecode first mgenc.! !

!ParseBytecodeTest methodsFor: 'tests' stamp: 'rkrk 5/9/2009 00:48'!
test17SimpleBlockWithContent

	self setUpParser: '[1]' withMgencAndApply: #nestedBlock.
	self assertNoFail: result.
	self assertLiteralAt: 1 accessor: #number equals: 1.
	self assertBcAt: 2 is: SOMBCReturnLocal.
	self assert: bytecode size equals: 2.! !

!ParseBytecodeTest methodsFor: 'tests' stamp: 'rkrk 5/9/2009 00:50'!
test18BlockReturn

	self setUpParser: '[^1]' withMgencAndApply: #nestedBlock.
	self assertNoFail: result.
	self assertLiteralAt: 1 accessor: #number equals: 1.
	self assertBcAt: 2 is: SOMBCReturnNonLocal.
	self assert: bytecode size equals: 2.! !

!ParseBytecodeTest methodsFor: 'tests' stamp: 'rkrk 9/15/2009 15:00'!
test19BlockArguments

	self setUpParser: '[:a :abc | 1]' withMgencAndApply: #nestedBlock.
	self assertNoFail: result.
	self assert: result arguments size = 2.
	self assert: (result arguments includes: 'a').
	self assert: (result arguments includes: 'abc').! !

!ParseBytecodeTest methodsFor: 'tests' stamp: 'mkl 5/13/2009 20:09'!
test20MultipleArguments

	self setUpParser: '[''abc'' println. ^nil]' withMgencAndApply: #nestedBlock.
	self assertNoFail: result.
	self assertLiteralAt: 1 accessor: #string equals: 'abc'.
	self assertLiteralAt: 2 equals: 'println'.
	self assertBcAt: 4 is: SOMBCPushGlobal.
	self assertLiteralAt: 4 equals: 'nil'.
	self assertBcAt: 5 is: SOMBCReturnNonLocal.! !

!ParseBytecodeTest methodsFor: 'tests' stamp: 'rkrk 5/9/2009 01:00'!
test21aSimpleSymbol

	self setUpParser: 'x=(#someSymbol)' andApply: #method.
	self assertNoFail: result.
	self assertLiteralAt: 1 accessor: #symbol equals: #someSymbol.! !

!ParseBytecodeTest methodsFor: 'tests' stamp: 'rkrk 5/9/2009 01:00'!
test21bSymbol

	self setUpParser: 'x=(#someSymbol:a:)' andApply: #method.
	self assertNoFail: result.
	self assertLiteralAt: 1 accessor: #symbol equals: #someSymbol:a:.! !

!ParseBytecodeTest methodsFor: 'tests' stamp: 'rkrk 5/9/2009 03:28'!
test22aSimpleAssignment

	self setUpParser: 'x=(| a | a := 2)' andApply: #method.
	self assertNoFail: result.
	self assertLiteralAt: 1 accessor: #number equals: 2.
	self assertBcAt: 2 is: SOMBCDup.
	self assertBcAt: 3 is: SOMBCPopLocal.
	self assert: bytecode third index equals: 1.
	self assert: bytecode third contextIndex equals: 1.! !

!ParseBytecodeTest methodsFor: 'tests' stamp: 'rkrk 5/10/2009 01:43'!
test22bMultipleAssignments

	self setUpParser: 'x=(| a b | b := a := field := 2)'.
	parser cgenc addFields: {'field'}.
	bytecode := (parser apply: #method) bytecode.
	self assertNoFail: result.
	self assertLiteralAt: 1 accessor: #number equals: 2.
	self assertBcAt: 2 is: SOMBCDup.
	self assertBcAt: 3 is: SOMBCDup.
	self assertBcAt: 4 is: SOMBCDup.
	self assertBcAt: 5 is: SOMBCPopField.
	self assert: bytecode fifth index equals: 3. "literal indexof field"
	self assert: bytecode sixth index equals: 1. "local index"
	self assert: bytecode seventh index equals: 2. "local index"! !

!ParseBytecodeTest methodsFor: 'tests' stamp: 'rkrk 5/9/2009 03:51'!
test23MultipleAssignments

	self setUpParser: 'x: a=(1 + a)' andApply: #method.
	self assertNoFail: result.
	self assertBcAt: 2 is: SOMBCPushArgument.
	self assert: bytecode second index equals: 2. "1 is self"
	self assert: bytecode second contextIndex equals: 1.! !

!ParseBytecodeTest methodsFor: 'tests' stamp: 'rkrk 5/13/2009 18:58'!
test24aSelfLookupWithBlock

	| blockBc |
	self setUpParser: 'x: a=( [self].)' andApply: #method.
	self assertNoFail: result.
	blockBc := (result literals at: bytecode first index ) bytecodes.
	self assert: (blockBc first isKindOf: SOMBCPushArgument).
	self assert: blockBc first index equals: 1.
	self assert: blockBc first contextIndex equals: 2.! !

!ParseBytecodeTest methodsFor: 'tests' stamp: 'test 5/25/2009 02:31'!
test24bLocalAndArgumentLookupWithBlock

	| innerBlockBc firstInnerBlock |
	self setUpParser: 'x: a y: b=([ |x y| [b + y] ])' andApply: #method.
	self assertNoFail: result.
	firstInnerBlock := (result literals at: bytecode first index) bytecodes first.
	innerBlockBc := (firstInnerBlock mgenc literals at: firstInnerBlock index) bytecodes.
	self assert: (innerBlockBc first isKindOf: SOMBCPushArgument).
	self assert: innerBlockBc first index equals: 3. "first is self, second a, third b"
	self assert: innerBlockBc first contextIndex equals: 3.
	self assert: (innerBlockBc second isKindOf: SOMBCPushLocal).
	self assert: innerBlockBc second index equals: 2.
	self assert: innerBlockBc second contextIndex equals: 2.! !

!ParseBytecodeTest methodsFor: 'tests' stamp: 'rkrk 5/10/2009 02:20'!
test25BlockInBlock

	self setUpParser: '[ [] ]' andApply: #nestedBlock.
	self assertNoFail: result.
	self assertBcAt: 1 is: SOMBCPushBlock.! !

!ParseBytecodeTest methodsFor: 'tests' stamp: 'test 5/12/2009 18:26'!
test26returnArgument

	self setUpParser: 'x: a = (^a)' andApply: #method.
	self assertNoFail: result.
	self assertBcAt: 1 is: SOMBCPushArgument.
	self assertBcAt: 2 is: SOMBCReturnLocal.! !

!ParseBytecodeTest methodsFor: 'tests' stamp: 'test 5/13/2009 17:34'!
test27StoreIntoArgument

	self setUpParser: 'x: a = (a := 1)' andApply: #method.
	self assertNoFail: result.
	self assertBcAt: 1 is: SOMBCPushConstant.
	self assertBcAt: 2 is: SOMBCDup.
	self assertBcAt: 3 is: SOMBCPopArgument.! !

!ParseBytecodeTest methodsFor: 'tests' stamp: 'test 5/13/2009 20:01'!
test28GlobalsTest

	self setUpParser: 'x = (^ EmptyTest, DoubleTest, HashTest)' andApply: #method.
	self assertNoFail: result.
	"self halt."
	"self assertBcAt: 1 is: SOMBCPushConstant."! !

!ParseBytecodeTest methodsFor: 'tests' stamp: 'StefanMarr 5/17/2012 16:29'!
test29do
	| block |
	self setUpParser: 'do: block = ( self doIndexes: [ :i | block value: (self at: i) ] )' andApply: #method.
	self assertNoFail: result.

	self assertBcAt: 1 is: SOMBCPushArgument.
	self assert: (bytecode at: 1) index equals: 1.
	self assert: (bytecode at: 1) contextIndex equals: 1.
	
	self assertBcAt: 2 is: SOMBCPushBlock.
	self assert: (bytecode at: 2) index equals: 1.
	self assert: ((bytecode at: 2) literalValue isKindOf: SOMMethod).
	
	self assertBcAt: 3 is: SOMBCSend.
	self assert: (bytecode at: 3) index equals: 2.
	self assert: (bytecode at: 3) literalValue equals: #doIndexes:.
	self assert: (bytecode at: 3) literalValue class equals: ByteSymbol.
	
	self assertBcAt: 4 is: SOMBCPop.
	self assertBcAt: 5 is: SOMBCPushArgument.
	self assertBcAt: 6 is: SOMBCReturnLocal.
	
	block := (bytecode at: 1) literalValue.
	bytecode := block bytecodes.
	
	self assertBcAt: 1 is: SOMBCPushArgument.
	self assertBcAt: 2 is: SOMBCPushArgument.
	self assertBcAt: 3 is: SOMBCPushArgument.
	self assertBcAt: 4 is: SOMBCSend.
	self assertBcAt: 5 is: SOMBCSend.
	self assertBcAt: 6 is: SOMBCReturnLocal.! !

!ParseClassTest methodsFor: 'assertion' stamp: 'rkrk 4/26/2009 01:44'!
assertNoFail: parseResult

	"parser printPosition"
	self deny: (parseResult isKindOf: OMetaFail).! !

!ParseClassTest methodsFor: 'running' stamp: 'StefanMarr 5/14/2012 23:19'!
parserClass

	^ universe classParser! !

!ParseClassTest methodsFor: 'running' stamp: 'mkl 5/12/2009 17:38'!
setUp
	super setUp.
	parser := nil.! !

!ParseClassTest methodsFor: 'running' stamp: 'rkrk 5/10/2009 01:20'!
setUpParser: source

	parser := self parserClass
		inUniverse: universe
		onSource: source.! !

!ParseClassTest methodsFor: 'running' stamp: 'rkrk 5/9/2009 00:29'!
setUpParser: source andApply: rule

	self setUpParser: source.
	result := parser apply: rule.! !

!ParseClassTest methodsFor: 'tests' stamp: 'rkrk 4/25/2009 23:15'!
test01SimpleClassDef

	self setUpParser: 'Class1 = ()'.
	self assertNoFail: parser start.
	self assert: parser cgenc theName equals: #Class1.
	self assert: parser cgenc superName equals: #Object.! !

!ParseClassTest methodsFor: 'tests' stamp: 'rkrk 4/25/2009 23:16'!
test02ClassInstVars

	self setUpParser: 'Class1 = ( | a b cdef |)'.
	self assertNoFail: parser start.
	self
		assert: parser cgenc instanceFields
		equals: {'a'. 'b'. 'cdef'} asOrderedCollection.! !

!ParseClassTest methodsFor: 'tests' stamp: 'rkrk 4/25/2009 23:16'!
test03RecognizeSpaces

	self setUpParser: '"bla " Class1 = ()'.
	self assertNoFail: parser start.
	self assert: parser cgenc theName equals: #Class1.! !

!ParseClassTest methodsFor: 'tests' stamp: 'rkrk 6/3/2009 14:35'!
test04aRecognizeMethodUnary
	| methods |
	self setUpParser: 'Class1 = ( abc = ())'.
	self assertNoFail: parser start.
	methods := parser cgenc instanceMethods.
	self 
		assert: methods size
		equals: 1.
	self 
		assert: methods first signature
		equals: #abc! !

!ParseClassTest methodsFor: 'tests' stamp: 'rkrk 6/3/2009 14:35'!
test04bRecognizeMethodBinary
	| methods |
	self setUpParser: 'Class1 = ( & a = ())'.
	self assertNoFail: parser start.
	methods := parser cgenc instanceMethods.
	self 
		assert: methods size
		equals: 1.
	self 
		assert: methods first signature
		equals: #&! !

!ParseClassTest methodsFor: 'tests' stamp: 'rkrk 6/3/2009 14:36'!
test04cRecognizeKeywordMethod
	| methods |
	self setUpParser: 'Class1 = ( a: x abc: y = ())'.
	self assertNoFail: parser start.
	methods := parser cgenc instanceMethods.
	self 
		assert: methods size
		equals: 1.
	self 
		assert: methods first signature
		equals: #a:abc:! !

!ParseClassTest methodsFor: 'tests' stamp: 'rkrk 4/26/2009 02:38'!
test05RecognizeMultipleMethods

	| methods |
	self setUpParser: 'Class1 = ( a: x abc: y = ()
     & bool = ()
	test = ()
)'.
	self assertNoFail: parser start.
	methods := parser cgenc instanceMethods.
	self assert: methods size equals: 3.! !

!ParseClassTest methodsFor: 'tests' stamp: 'rkrk 4/29/2009 00:38'!
test06RecognizeClassMethods

	| methods |
	self setUpParser: 'Class1 = ( ---- test = () )'.
	self assertNoFail: parser start.
	self assert: parser cgenc isClassSide.
	methods := parser cgenc classMethods.
	self assert: methods size equals: 1.! !

!ParseClassTest methodsFor: 'tests' stamp: 'rkrk 4/29/2009 00:53'!
test06aRecognizeClassSide

	self setUpParser: 'Class1 = ( ---- | a | test = () x = (1 +2))'.
	self assertNoFail: parser start.
	self assert: parser cgenc isClassSide.
	self assert: parser cgenc classMethods size equals: 2.
	self assert: parser cgenc classFields size equals: 1.! !

!ParseClassTest methodsFor: 'tests' stamp: 'rkrk 4/29/2009 00:54'!
test06bRecognizeInstanceAndClassSide

	self setUpParser: 'Class1 = ( | a | y = (1) ---- | a | test = ())'.
	self assertNoFail: parser start.
	self assert: parser cgenc instanceMethods size equals: 1.
	self assert: parser cgenc instanceFields size equals: 1.
	self assert: parser cgenc classMethods size equals: 1.
	self assert: parser cgenc classFields size equals: 1.! !

!ParseClassTest methodsFor: 'tests' stamp: 'rkrk 5/13/2009 14:40'!
test07AccessInstanceVars

	| mgenc bc |
	self setUpParser: 'Class1 = (|a| y = (^a))'.
	self assertNoFail: parser start.
	mgenc := parser cgenc instanceMethods first.
	bc := mgenc bytecode.
	self assert: (bc first isKindOf: SOMBCPushField).
	self assert: (bc second isKindOf: SOMBCReturnLocal).! !

ParseClassTest subclass: #ParseCompleteClassTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AweSOM-Compiler-Test'!

!ParseCompleteClassTest methodsFor: 'as yet unclassified' stamp: 'rkrk 5/13/2009 14:43'!
classObject

	^ 'Object = nil (

    | class |
    
    "Accessing"
    class     = ( ^class )
    
    "Primitive size in bytes"
    objectSize = primitive
    
    "Comparing"
    =  other    = ( ^self == other )
    <> argument = ( ^(self = argument) not )
    == other    = primitive
    isNil       = ( ^false )
    " If you override =, you MUST override hashcode as well.  The rule
      obj1 = obj2   =>  obj1 hashcode = obj2 hashcode
      must be valid for all objects, or Hashtable will not work"
    
    "Converting"
    asString  = ( ^''instance of '' + (self class) )
    , element = ( ^(Vector new append: self) append: element )
    hashcode  = primitive
    
    "Evaluating"
    value     = ( ^self )
    
    "Printing"
    print     = ( self asString print )
    println   = ( self print. system printNewline )
    
    "Error handling"
    error: string = ( '''' println. (''ERROR: '' + string) println. system exit )
    
    "Abstract method support"
    subclassResponsibility = (
        self error: ''This method is abstract and should be overridden''
    )
    
    "Error recovering"
    doesNotUnderstand: selector arguments: arguments = (
        self error:
            (''Method '' + selector + '' not found in class '' + class name)
    )
    
    escapedBlock: block = (
        self error: ''Block has escaped and cannot be executed''
    )
    
    unknownGlobal: name = ( ^system resolve: name )
    
    "Reflection"
    respondsTo: aSymbol = (
        (self class hasMethod: aSymbol)
            ifTrue:  [ ^true ]
            ifFalse: [ | cls |
                cls := self class superclass.
                [ cls isNil ] whileFalse: [
                    (cls hasMethod: aSymbol)
                        ifTrue:  [ ^true ]
                        ifFalse: [ cls := cls superclass ] ].
                ^ false ]
    )
    
)'! !

!ParseCompleteClassTest methodsFor: 'as yet unclassified' stamp: 'rkrk 6/2/2009 19:46'!
classSystem

	^ '"

$Id: System.som 226 2008-04-21 12:45:01Z michael.haupt $

Copyright (c) 2001-2007 see AUTHORS file

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the ''Software''), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED ''AS IS'', WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
"

System = (

    "Accessing"
    global: name            = primitive
    global: name put: value = primitive
    
    "Initializing"
    initialize: arguments = (
        | application |
        
        "Make sure we have got at least one argument"
        (arguments length < 1) ifTrue: [ ''No class specified'' println. ^nil ].
        
        "Load the class with the specified name, create an instance of it, and
         run it. If there is more than only the class given on the command line,
         and the class has a method #run:, the arguments array is passed to it,
         otherwise, #run is sent."
        application := (self resolve: (arguments at: 1) asSymbol) new.
        
        (arguments length > 1) && (application class hasMethod: #run:)
            ifTrue:  [ application run: arguments ]
            ifFalse: [ application run ]
    )
    
    "Loading and resolving"
    load:    symbol = primitive
    resolve: symbol = (
        | class current_class |
        
        "Check if we''ve already got the global"
        (self global: symbol) == nil ifFalse: [ ^self global: symbol ].
        
        "Try loading the class"
        class := self load: symbol.
        (class == nil) ifFalse: [
            "Put class and its super-classes into global dictionary. We can stop
             as soon as we find a super-class in the globals dictionary because
             in this case, all its super-classes must have been added to the
             dictionary earlier"
             current_class := class.
             [ (self global: (current_class name)) == nil ] whileTrue: [
                self global: (current_class name) put: current_class.
                current_class := current_class superclass. ].
            ^class ].
        self error: ''Unable to resolve '' + symbol
    )
    
    "Exiting"
    exit: error  = primitive  
    exit         = ( self exit: 0 )
    
    "Printing"
    printString: string = primitive
    printNewline        = primitive
    
    "Time"
    time = primitive
    
    "Force Garbage Collection"
    fullGC = primitive
    
    ----------------------------------
    
    "Allocation"
    new = ( self error: ''The system object is singular'' )
    
)
'! !

!ParseCompleteClassTest methodsFor: 'tests' stamp: 'rkrk 5/10/2009 03:28'!
test01parseSystem

	| cgenc |
	self setUpParser: self classSystem.
	self assertNoFail: parser start.
	cgenc := parser cgenc.
	"self halt."! !

!ParseCompleteClassTest methodsFor: 'tests' stamp: 'test 5/13/2009 14:46'!
test02parseObject

	| cgenc |
	self setUpParser: self classObject.
	self assertNoFail: parser start.
	cgenc := parser cgenc.
	"self halt."! !

ParseClassTest subclass: #ParseMethodTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AweSOM-Compiler-Test'!

!ParseMethodTest methodsFor: 'running' stamp: 'StefanMarr 5/14/2012 23:19'!
parserClass

	^ universe methodParser! !

!ParseMethodTest methodsFor: 'running' stamp: 'rkrk 5/10/2009 01:35'!
setUpParser: source

	super setUpParser: source.
	parser
		"fakeMgenc;"
		fakeCgenc.! !

!ParseMethodTest methodsFor: 'tests' stamp: 'rkrk 6/3/2009 14:31'!
test01SimpleMethodDef

	self setUpParser: 'x = (1)'.
	self assertNoFail: (result := parser apply: #method).
	self assert: (result isKindOf: SOMMethodGenerationContext).
	self 
		assert: result signature
		equals: #x! !

!ParseMethodTest methodsFor: 'tests' stamp: 'rkrk 9/15/2009 15:00'!
test02ParseArguments

	self setUpParser: 'x: abc y: def4 = ( 1 + 1 )'.
	self assertNoFail: (result := parser apply: #method).
	self assert: result arguments size = 3. "First is self"
	self assert: (result arguments includes: 'abc').
	self assert: (result arguments includes: 'def4').! !

!ParseMethodTest methodsFor: 'tests' stamp: 'rkrk 5/27/2009 15:27'!
test03FakeParseBody

	self setUpParser: 'x: abc y: def4 = ( 1 * (2*(2)). )'.
	parser shouldReadSources: true.
	self assertNoFail: (result := parser apply: #method).
	self assert: result fakeSource equals: ' 1 * (2*(2)). '.! !

!ParseMethodTest methodsFor: 'tests' stamp: 'StefanMarr 5/13/2012 14:48'!
test04Primitive

	| res |
	self setUpParser: '"Accessing" at: index = primitive'.
	self assertNoFail: (res := parser apply: #method).
	self assert: res isPrimitive.! !

!ParseMethodTest methodsFor: 'tests' stamp: 'rkrk 5/10/2009 01:40'!
test05PrimitiveMethodGeneratesBody

	self setUpParser: 'test = primitive'.
	parser fakeCgenc. "className = Dummy"
	self assertNoFail: (result := parser apply: #method).
	self assert: result fakeSource equals: '^ SOMPrimitives Dummytest'! !

!ParseMethodTest methodsFor: 'tests' stamp: 'rkrk 5/10/2009 01:39'!
test06PrimitiveWithParameters

	self setUpParser: 'test: a test: b = primitive'.
	self assertNoFail: (result := parser apply: #method).
	self assert: result fakeSource equals: '^ SOMPrimitives Dummytest: a test: b'! !

!ParseMethodTest methodsFor: 'tests' stamp: 'rkrk 5/6/2009 13:59'!
test07LocalVars

	| result |
	self setUpParser: 'x = (| abc |)'.
	self assertNoFail: (result := parser apply: #method).
	self assert: result locals equals: {'abc'} asOrderedCollection.! !

!ParseMethodTest methodsFor: 'tests' stamp: 'test 5/10/2009 03:28'!
test08SystemResolveMethod

	| src |
	src := 'resolve: symbol = (
        | class currentclass |
        (self global: symbol) == nil ifFalse: [ ^self global: symbol ].        
        class := self load: symbol.
        (class == nil) ifFalse: [
             currentclass := class.
             [ (self global: (currentclass name)) == nil ] whileTrue: [
                self global: (currentclass name) put: currentclass.
                currentclass := currentclass superclass. ].
            ^class ].
        self error: ''Unable to resolve '' + symbol
    )'.
	self setUpParser: src.
	self assertNoFail: (result := parser apply: #method).
	"self halt."! !

!ParseMethodTest methodsFor: 'tests' stamp: 'rkrk 5/27/2009 15:21'!
test09HashEntryRun

	| src |
	src := 'run = ("(")'.
	self setUpParser: src.
	self assertNoFail: (result := parser apply: #method).
"	self halt."! !

!ParseMethodTest methodsFor: 'tests' stamp: 'rkrk 5/27/2009 16:52'!
test10BigIntegerTestRun

	| src |
	src := 'run: harness = (-1)'.
	self setUpParser: src.
	self assertNoFail: (result := parser apply: #method).
"	self halt."! !

!ParseMethodTest methodsFor: 'tests' stamp: 'rkrk 5/27/2009 17:08'!
test11ReflectionTestRun

	| src |
	src := 'run: harness = (self x: #==)'.
	self setUpParser: src.
	self assertNoFail: (result := parser apply: #method).
"	self halt."! !

!ParseMethodTest methodsFor: 'tests' stamp: 'StefanMarr 5/13/2012 17:36'!
test12SimpleOperatorMethodDef

	self setUpParser: '& bool = ()'.
	self assertNoFail: (result := parser apply: #method).
	self assert: (result isKindOf: SOMMethodGenerationContext).
	self assert: result signature 			equals: '&'.
	self assert: result arguments size  		equals: 2.
	self assert: result arguments first 		equals: #self.
	self assert: result arguments second 	equals: #bool.! !

TestCaseWithUniverse subclass: #SOMClassTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AweSOM-VM-Test'!

!SOMClassTest methodsFor: 'tests' stamp: 'rkrk 6/4/2009 19:52'!
test01ObjectCreation

	| clazz instance |
	self loadClazzes: {#Object}.
	clazz := universe loadSOMClass: #TestHarness.
	instance := clazz primnew.
	self assert: clazz equals: instance somClass! !

!SOMClassTest methodsFor: 'tests' stamp: 'mkl 5/27/2009 16:34'!
test02Subclassing
	| somArray newClass newInstance |
	self loadClazzes: {  #Array. #Object  }.
	somArray := universe globalAt: #Array.
	newClass := SOMClass 
		inUniverse: universe
		withSomSuperClass: somArray.
	self 
		assert: newClass squeakClass
		equals: SOMArray.
	newInstance := newClass primnew.
	self 
		assert: newInstance somClass
		equals: newClass! !

!SOMClassTest methodsFor: 'tests' stamp: 'rkrk 6/5/2009 02:25'!
test03LookupOfFields

	| source class method pushBc field |
	self loadClazzes: {#Object.}.
	source := 'ClassA = ( | x | m=(x) )'.
	class := universe loadAndStoreFromSource: source.
	method := class somInstanceInvokables at: 1.
	pushBc := method bytecodes first.
	self shouldnt: [field := class allInstanceFields at: pushBc fieldIndex] raise: Error.
	self assert: field string equals: 'x'.! !

!SOMClassTest methodsFor: 'tests' stamp: 'rkrk 6/5/2009 02:25'!
test04LookupOfFieldDefinedInSuperclass

	| source class method pushBc field |
	self loadClazzes: {#Object.}.
	source := 'ClassA = ( m=(class) )'.
	class := universe loadAndStoreFromSource: source.
	method := class somInstanceInvokables at: 1.
	pushBc := method bytecodes first.
	self shouldnt: [field := class allInstanceFields at: pushBc fieldIndex] raise: Error.
	self assert: field string equals: 'class'.! !

!SOMClassTest methodsFor: 'tests' stamp: 'rkrk 6/5/2009 02:26'!
test05ClassDoesNotRegisterInUniverseAfterCompiling

	universe loadAndStoreFromSource: 'ClassA = ()'.
	self assert: (universe hasGlobalAt: #ClassA).! !

!SOMClassTest methodsFor: 'tests' stamp: 'rkrk 6/4/2009 19:04'!
test06ClassClassHasCorrectInstanceFields

	| classClass |
	self loadClazzes: #(#Object #Class).
	classClass := universe globalAt: #Class.
	self
		assert: classClass allInstanceFields
		equals: #('class' 'superClass' 'name' 'instanceFields' 'instanceInvokables')! !

!SOMClassTest methodsFor: 'tests' stamp: 'rkrk 6/5/2009 02:25'!
test07MetaClassHasInstanceFields

	| class field method pushFieldBc |
	self loadClazzes: {#Object. #Class}.
	class := universe loadAndStoreFromSource: 'ClassA = (---- | x | m = (x))'.
	self assert: class somClass somInstanceFields size equals: 1.
	method := class somClass somInstanceInvokables at: 1.
	pushFieldBc := method bytecodes first.
	self shouldnt: [field := class fieldAtIndex: pushFieldBc fieldIndex] raise: Error.
	self assert: universe globalNil equals: field.! !

TestCaseWithUniverse subclass: #SOMFrameTest
	instanceVariableNames: 'frame frame2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AweSOM-VM-Test'!

!SOMFrameTest methodsFor: 'running' stamp: 'rkrk 5/26/2009 21:53'!
setUp

	super setUp.
	frame := (SOMFrame 
		inUniverse: universe
		size: 10)
		somMethod: (SOMMethod 
				inUniverse: universe
				withNumberOfAdditionalFields: 0);
		yourself.
	frame2 := (SOMFrame 
		inUniverse: universe
		size: 10)
		somMethod: (SOMMethod 
				inUniverse: universe
				withNumberOfAdditionalFields: 0);
		yourself! !

!SOMFrameTest methodsFor: 'tests' stamp: 'arv 5/13/2009 15:38'!
test01Push
	self assert: frame stackPointer equals: 0.
	frame push: 'A'.
	self assert: frame stackPointer equals: 1! !

!SOMFrameTest methodsFor: 'tests' stamp: 'arv 5/12/2009 16:23'!
test02Pop
	frame push: 'A'.
	self assert: 'A' equals: (frame pop).
	
	frame push: 'A'.
	frame push: 'B'.
	self assert: 'B' equals: (frame pop);
		assert: 'A' equals: (frame pop).! !

!SOMFrameTest methodsFor: 'tests' stamp: 'arv 5/13/2009 11:26'!
test03Context
	self 
		assert: universe globalNil
		equals: frame somContext.
	self assert: frame = (frame frameAtContextLevel: 1).
	self 
		assert: frame somContext
		equals: (frame frameAtContextLevel: 2).
	frame2 somContext: frame.
	self 
		assert: frame
		equals: frame2 somContext.
	self 
		assert: frame2
		equals: (frame2 frameAtContextLevel: 1).
	self 
		assert: frame2 somContext
		equals: (frame2 frameAtContextLevel: 2).
	self 
		assert: frame2 somContext somContext
		equals: (frame2 frameAtContextLevel: 3)! !

!SOMFrameTest methodsFor: 'tests' stamp: 'arv 5/12/2009 16:23'!
test04StackSize
	self assert: 10 equals: frame remainingStackSize.
	
	9 to: 0 by: -1 do: [ :expectedRemainingSize |
		frame push: 'A'.
		self assert: expectedRemainingSize equals: frame remainingStackSize.
	].! !

!SOMFrameTest methodsFor: 'tests' stamp: 'mkl 5/27/2009 16:23'!
test05CallPrimitive
	| theSelf theOther method |
	theSelf := SOMInteger 
		inUniverse: universe
		new: 50.
	theOther := SOMInteger 
		inUniverse: universe
		new: 8.
	frame
		push: theSelf;
		push: theOther.
	method := SOMPrimitive inUniverse: universe.
	method
		numberOfArguments: 2;
		somSignature: (SOMSymbol 
				inUniverse: universe
				string: '-');
		invokeInFrame: frame.
	self 
		assert: frame pop number
		equals: 42! !

TestCaseWithUniverse subclass: #SOMGCTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AweSOM-GarbageCollector-Test'!

!SOMGCTest methodsFor: 'as yet unclassified' stamp: 'rkrk 6/12/2009 01:11'!
setUp

	universe := SOMUniverse new.
	universe globalAt: #nil put: nil.! !

!SOMGCTest methodsFor: 'as yet unclassified' stamp: 'rkrk 6/12/2009 01:02'!
test01ObjectCollectionExists

	universe initializeFakeGlobals.
	self assert: universe heap objects notEmpty.! !

!SOMGCTest methodsFor: 'as yet unclassified' stamp: 'rkrk 6/12/2009 01:09'!
test02CollectUnreferencedObjects

	| object |
	self assert: universe heap objects isEmpty.
	object := SOMObject inUniverse: universe.
	self assert: universe heap objects size equals: 1.
	universe heap collectGarbage.
	self assert: universe heap objects isEmpty.! !

!SOMGCTest methodsFor: 'as yet unclassified' stamp: 'rkrk 6/12/2009 01:14'!
test03DontCollectGlobalObjects

	| object |
	object := SOMObject inUniverse: universe.
	universe globalAt: #test put: object.
	self assert: universe heap objects size equals: 1.
	universe heap collectGarbage.
	self assert: universe heap objects size equals: 1.! !

!SOMGCTest methodsFor: 'as yet unclassified' stamp: 'rkrk 6/12/2009 01:29'!
test04DontCollectObjectsReferencedFromGlobals

	| object object2 |
	object := SOMObject inUniverse: universe.
	universe globalAt: #test put: object.
	object2 := SOMObject inUniverse: universe.
	object fieldAtIndex: 1 put: object2.
	self assert: universe heap objects size equals: 2.
	universe heap collectGarbage.
	self assert: universe heap objects size equals: 2.! !

!SOMGCTest methodsFor: 'as yet unclassified' stamp: 'rkrk 6/12/2009 01:30'!
test05CollectObjectsNotReferencedAnymore

	| object object2 |
	object := SOMObject inUniverse: universe.
	universe globalAt: #test put: object.
	object2 := SOMObject inUniverse: universe.
	object fieldAtIndex: 1 put: object2.
	self assert: universe heap objects size equals: 2.
	universe heap collectGarbage.
	self assert: universe heap objects size equals: 2.
	object fieldAtIndex: 1 put: nil.
	universe heap collectGarbage.
	self assert: universe heap objects size equals: 1.! !

TestCaseWithUniverse subclass: #SOMGlobalsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AweSOM-VM-Test'!

!SOMGlobalsTest methodsFor: 'tests' stamp: 'mkl 5/27/2009 16:08'!
test01Metaclass
	| clazz metaclazz object nilObject |
	metaclazz := universe globalAt: #Metaclass.
	clazz := universe globalAt: #Class.
	object := universe globalAt: #Object.
	nilObject := universe globalAt: #nil.
	self 
		assert: metaclazz somClass somClass
		equals: metaclazz.
	self 
		assert: object somSuperClass
		equals: nilObject.
	self 
		assert: object somClass somSuperClass
		equals: clazz.
	self 
		assert: object somClass somClass
		equals: metaclazz! !

!SOMGlobalsTest methodsFor: 'tests' stamp: 'mkl 5/27/2009 16:08'!
test02Subclass
	| object array |
	object := universe globalAt: #Object.
	array := universe globalAt: #Array.
	self 
		assert: array somSuperClass
		equals: object.
	self 
		assert: array somClass somSuperClass
		equals: object somClass! !

!SOMGlobalsTest methodsFor: 'tests' stamp: 'mkl 5/27/2009 16:08'!
test03NilClass
	| nilObject nilClass object |
	nilObject := universe globalAt: #nil.
	nilClass := universe globalAt: #Nil.
	object := universe globalAt: #Object.
	self 
		assert: nilObject somClass
		equals: nilClass.
	self 
		assert: nilObject somClass somSuperClass
		equals: object! !

TestCaseWithUniverse subclass: #SOMInterpreterTest
	instanceVariableNames: 'interpreter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AweSOM-VM-Test'!

SOMInterpreterTest class
	instanceVariableNames: 'mgec callerFrame'!

SOMInterpreterTest class
	instanceVariableNames: 'mgec callerFrame'!

!SOMInterpreterTest methodsFor: 'helper' stamp: 'arv 5/20/2009 12:53'!
assembleMethod: name withArguments: args withByteCodes: byteCodeGenerator 
	^ self assembleMethod: name withArguments: args withLocals: {} withByteCodes: byteCodeGenerator! !

!SOMInterpreterTest methodsFor: 'helper' stamp: 'StefanMarr 5/17/2012 16:17'!
assembleMethod: name withArguments: args withLocals: locals withByteCodes: byteCodeGenerator

	| testMgenc |
	testMgenc := universe methodGenClass named: name.
	byteCodeGenerator value: testMgenc.
	testMgenc arguments
		add: 'self';
		addAll: args.
	testMgenc locals addAll: locals.
	^ testMgenc assembleIn: universe.! !

!SOMInterpreterTest methodsFor: 'helper' stamp: 'arv 5/20/2009 12:52'!
assembleMethod: name withByteCodes: byteCodeGenerator 
	^ self assembleMethod: name withArguments: {} withLocals: {} withByteCodes: byteCodeGenerator! !

!SOMInterpreterTest methodsFor: 'helper' stamp: 'arv 5/20/2009 12:52'!
assembleMethod: name withLocals: locals withByteCodes: byteCodeGenerator 
	^ self assembleMethod: name withArguments: {} withLocals: locals withByteCodes: byteCodeGenerator! !

!SOMInterpreterTest methodsFor: 'running' stamp: 'StefanMarr 5/14/2012 23:22'!
compileMethod: source 

	| parser mgenc |
	parser := universe methodParser inUniverse: universe onSource: source.
	mgenc := parser apply: #method.
	^ mgenc assembleIn: universe.! !

!SOMInterpreterTest methodsFor: 'running' stamp: 'rkrk 5/26/2009 21:52'!
setUp

	super setUp.
	interpreter := universe interpreter.! !

!SOMInterpreterTest methodsFor: 'helper' stamp: 'arv 5/20/2009 15:46'!
startInterpreterWith: method 
	self startInterpreterWith: method withLocals: {} withArguments: {}! !

!SOMInterpreterTest methodsFor: 'helper' stamp: 'arv 5/20/2009 15:45'!
startInterpreterWith: method withArguments: args
	self startInterpreterWith: method withLocals: {} withArguments: args! !

!SOMInterpreterTest methodsFor: 'helper' stamp: 'arv 5/20/2009 15:45'!
startInterpreterWith: method withLocals: locals
	self startInterpreterWith: method withLocals: locals withArguments: {}! !

!SOMInterpreterTest methodsFor: 'helper' stamp: 'arv 5/20/2009 15:44'!
startInterpreterWith: method withLocals: locals withArguments: args
	| frame |
	frame := interpreter pushNewFrameWithMethod: method.
	locals withIndexDo: [:each :index | 
		frame localAtIndex: index contextLevel: 1 put: each].
	args withIndexDo: [:each :index | 
		frame argumentAtIndex: index contextLevel: 1 put: each].
	interpreter start.! !

!SOMInterpreterTest methodsFor: 'tests' stamp: 'mkl 5/13/2009 16:13'!
test01Bootstrap
	universe bootstrapWithArguments: {}! !

!SOMInterpreterTest methodsFor: 'tests' stamp: 'arv 5/20/2009 15:40'!
test02PushConstant
	self startInterpreterWith: 
		(self assembleMethod: 'test' withByteCodes: [:mgenc | 
			mgenc 
				bcPushConstant: (universe newNumber: 42); 
				bcHalt
		]).
	
	self 
		assert: 42
		equals: interpreter somFrame pop number.
	self 
		should: [ interpreter somFrame pop ]
		raise: Error! !

!SOMInterpreterTest methodsFor: 'tests' stamp: 'arv 5/20/2009 16:03'!
test03Dup
	"Duplicates the constant 42 on the stack and checks if there are exactly
	2 matching items on the stack"
	self startInterpreterWith: 
		(self assembleMethod: 'test' 
			withByteCodes: [:mgenc | 
				mgenc 
					bcPushConstant: (universe newNumber: 42); 
					bcDup;
					bcHalt
			]).
	
	self 
		assert: 42
		equals: interpreter somFrame pop number.
	self 
		assert: 42
		equals: interpreter somFrame pop number.
	self 
		should: [ interpreter somFrame pop ]
		raise: Error! !

!SOMInterpreterTest methodsFor: 'tests' stamp: 'arv 5/20/2009 15:38'!
test04PushGlobal
	self startInterpreterWith: 
		(self assembleMethod: 'test' 
			withByteCodes: [:mgenc | 
				mgenc 
					bcPushGlobal: #nil;
					bcHalt
			]).
			
	self assert: universe globalNil = interpreter somFrame pop.
	self 
		should: [ interpreter somFrame pop ]
		raise: Error! !

!SOMInterpreterTest methodsFor: 'tests' stamp: 'arv 5/20/2009 15:38'!
test05PushLocal
	self startInterpreterWith: 
		(self assembleMethod: 'test' 
			withLocals: {'a'. 'b'} 
			withByteCodes: [:mgenc | 
				mgenc 
					bcPushLocalIndex: 2 ctxIndex: 1;
					bcHalt
			])
		withLocals: {universe newNumber: 41. universe newNumber: 42}.
	
	self assert: 42 equals: interpreter somFrame pop number.
	self should: [interpreter somFrame pop] raise: Error! !

!SOMInterpreterTest methodsFor: 'tests' stamp: 'arv 5/20/2009 15:38'!
test06PushArguments
	self startInterpreterWith: 
		(self assembleMethod: 'test' 
			withArguments: {'a'. 'b'} 
			withByteCodes: [:mgenc | 
				mgenc 
					bcPushArgumentIdx: 2 ctxIdx: 1;
					bcHalt
			])
		withArguments: {universe newNumber: 41. universe newNumber: 42}.
	
	self assert: 42 equals: interpreter somFrame pop number.
	self should: [interpreter somFrame pop] raise: Error! !

!SOMInterpreterTest methodsFor: 'tests' stamp: 'arv 5/20/2009 15:40'!
test07Pop
	self startInterpreterWith: 
		(self assembleMethod: 'test' 
			withByteCodes: [:mgenc | 
				mgenc 
					bcPushConstant: (universe newNumber: 42); 
					bcDup;
					bcPop;
					bcHalt
			]).
	
	self assert: 42 equals: interpreter somFrame pop number.
	self should: [interpreter somFrame pop] raise: Error! !

!SOMInterpreterTest methodsFor: 'tests' stamp: 'arv 5/20/2009 15:47'!
test08PopLocal
	"Pushes constant 42 to stack and pops it into local variable"
	self startInterpreterWith: 
		(self assembleMethod: 'test' 
			withLocals: {'a'. 'b'} 
			withByteCodes: [:mgenc | 
				mgenc 
					bcPushConstant: (universe newNumber: 42);
					bcPopLocalIndex: 2 ctxIndex: 1;
					bcHalt
			])
		withLocals: {universe newNumber: 41. nil}.
		
	self assert: 42 equals: (interpreter somFrame localAtIndex: 2 contextLevel: 1) number.
	self should: [interpreter somFrame pop] raise: Error! !

!SOMInterpreterTest methodsFor: 'tests' stamp: 'arv 5/20/2009 15:49'!
test09PopArgument
	"Pushes constant 42 to stack and pops it into argument"
	self startInterpreterWith: 
		(self assembleMethod: 'test' 
			withArguments: {'a'. 'b'} 
			withByteCodes: [:mgenc | 
				mgenc 
					bcPushConstant: (universe newNumber: 42);
					bcPopArgumentIndex: 2 ctxIdx: 1;
					bcHalt
			])
		withArguments: {universe newNumber: 41. nil}.
	
	self assert: 42 equals: (interpreter somFrame argumentAtIndex: 2 contextLevel: 1) number.
	self should: [interpreter somFrame pop] raise: Error! !

!SOMInterpreterTest methodsFor: 'tests' stamp: 'rkrk 6/3/2009 17:23'!
test10ReturnLocal

	| callerFrame calleeFrame method |
	method := self
		assembleMethod: 'main' 
		withByteCodes: [:mgenc | mgenc bcHalt].
	method maxStackDepth: 2.
	callerFrame := interpreter pushNewFrameWithMethod: method.
	callerFrame push: (universe newSymbol: #self).
	
	method := self compileMethod: 'subroutine = (^ 42)'.
	calleeFrame := interpreter pushNewFrameWithMethod: method.
	calleeFrame somPreviousFrame: callerFrame.

	
	interpreter start.
	
	self should: [calleeFrame pop] raise: Error.
	self assert: 42 equals: callerFrame pop number.
	self should: [callerFrame pop] raise: Error! !

!SOMInterpreterTest methodsFor: 'tests' stamp: 'mkl 5/27/2009 16:31'!
test11Send
	| testClazz testMethod testInstance |
	testClazz := SOMClass inUniverse: universe.
	testMethod := self 
		assembleMethod: 'testMessage:p2:'
		withArguments: {  'a'. 'b'  }
		withByteCodes: 
			[ :mgenc | 
			mgenc
				bcPushArgumentIdx: 2
					ctxIdx: 1;
				bcReturnLocal ].
	testClazz somInstanceInvokables: (SOMArray 
			inUniverse: universe
			withAll: {  testMethod  }).
	testClazz somInstanceFields: (SOMArray 
			inUniverse: universe
			withAll: {  (universe newString: 'class')  }).
	testInstance := SOMObject 
		inUniverse: universe
		withSomClass: testClazz.
	self startInterpreterWith: (self 
			assembleMethod: 'main'
			withByteCodes: 
				[ :mgenc | 
				mgenc
					bcPushConstant: testInstance;
					bcPushConstant: #param1;
					bcPushConstant: #param2;
					bcSend: #testMessage:p2:;
					bcHalt ]).
	self 
		assert: #param1
		equals: interpreter somFrame pop.
	self 
		should: [ interpreter somFrame pop ]
		raise: Error! !

!SOMInterpreterTest methodsFor: 'tests' stamp: 'mkl 5/27/2009 16:31'!
test12DNU
	| testClazz testMethod testInstance params result |
	self loadClazzes: {  #Array. #Object  }.
	testClazz := SOMClass inUniverse: universe.
	params := SOMArray 
		inUniverse: universe
		size: 5.
	testMethod := self 
		assembleMethod: 'doesNotUnderstand:arguments:'
		withArguments: {  'message'. 'arguments'  }
		withByteCodes: 
			[ :mgenc | 
			1 
				to: 3
				do: 
					[ :paramIndex | 
					mgenc
						bcPushConstant: params;
						bcPushConstant: (universe newNumber: paramIndex);
						bcPushArgumentIdx: paramIndex
							ctxIdx: 1;
						bcSend: #at:put: ].
			mgenc bcReturnLocal ].
	testClazz somInstanceInvokables: (SOMArray 
			inUniverse: universe
			withAll: {  testMethod  }).
	testClazz somInstanceFields: (SOMArray 
			inUniverse: universe
			withAll: {  (universe newString: 'class')  }).
	testInstance := SOMObject 
		inUniverse: universe
		withSomClass: testClazz.
	self startInterpreterWith: (self 
			assembleMethod: 'main'
			withByteCodes: 
				[ :mgenc | 
				mgenc
					bcPushConstant: testInstance;
					bcPushConstant: #param1;
					bcPushConstant: #param2;
					bcPushConstant: #param3;
					bcSend: #unknownMethod:p2:p3:;
					bcHalt ]).
	result := interpreter somFrame pop.
	self 
		should: [ interpreter somFrame pop ]
		raise: Error.
	self 
		assert: testInstance
		equals: (params at: 1).
	self 
		assert: #unknownMethod:p2:p3:
		equals: (params at: 2) symbol.
	self 
		assert: {  #param1. #param2. #param3  }
		equals: (params at: 3) elements! !

!SOMInterpreterTest methodsFor: 'tests' stamp: 'mkl 5/27/2009 16:23'!
test13Block
	| testMethod |
	self loadClazzes: {  #Object. #Block  }.
	testMethod := self 
		assembleMethod: 'testMessage:p2:'
		withArguments: {  'a'. 'b'  }
		withByteCodes: 
			[ :mgenc | 
			mgenc
				bcPushArgumentIdx: 2
					ctxIdx: 1;
				bcReturnLocal	"pushes the second REAL param" ].
	testMethod numberOfArguments: 2.	"no self"
	self startInterpreterWith: (self 
			assembleMethod: 'main'
			withByteCodes: 
				[ :mgenc | 
				mgenc
					bcPushBlock: testMethod;
					bcPushConstant: #param1;
					bcPushConstant: #param2;
					bcSend: #value:with:;
					bcHalt ]).
	self 
		assert: #param2
		equals: interpreter somFrame pop.
	self 
		should: [ interpreter somFrame pop ]
		raise: Error! !

!SOMInterpreterTest methodsFor: 'tests' stamp: 'rkrk 6/3/2009 17:42'!
test14ReturnNonLocal

	| callerFrame calleeFrame method |
	method := self 
		assembleMethod: 'main'
		withByteCodes: [:mgenc | mgenc bcHalt].
	method maxStackDepth: 2.
	callerFrame := interpreter pushNewFrameWithMethod: method.
	callerFrame push: (universe newSymbol: #self).
	
	method := self compileMethod: 'subroutine = ([^42] value. ^24)'.
	calleeFrame := interpreter pushNewFrameWithMethod: method.
	calleeFrame somPreviousFrame: callerFrame.
	
	interpreter start.
	self 
		assert: 42
		equals: callerFrame pop number.
	self 
		should: [callerFrame pop]
		raise: Error! !

!SOMInterpreterTest methodsFor: 'tests' stamp: 'mkl 5/27/2009 16:34'!
test15SuperSend
	| testClazz testMethod superClazz superMethod testInstance |
	superClazz := SOMClass inUniverse: universe.
	superMethod := self 
		assembleMethod: 'test'
		withByteCodes: 
			[ :mgenc | 
			mgenc
				bcPushConstant: (universe newNumber: 42);
				bcReturnLocal ].
	superMethod somHolder: superClazz.
	superClazz somInstanceInvokables: (SOMArray 
			inUniverse: universe
			withAll: {  superMethod  }).
	superClazz somInstanceFields: (SOMArray 
			inUniverse: universe
			withAll: {  (universe newString: 'class')  }).
	testClazz := SOMClass 
		inUniverse: universe
		withSomSuperClass: superClazz.
	testMethod := self 
		assembleMethod: 'test'
		withByteCodes: 
			[ :mgenc | 
			mgenc
				bcPushArgumentIdx: 1
					ctxIdx: 1;
				bcSuperSend: 'test';
				bcReturnLocal ].
	testMethod somHolder: testClazz.
	testClazz somInstanceInvokables: (SOMArray 
			inUniverse: universe
			withAll: {  testMethod  }).
	testClazz somInstanceFields: (SOMArray 
			inUniverse: universe
			withAll: {  (universe newString: 'class')  }).
	testInstance := SOMObject 
		inUniverse: universe
		withSomClass: testClazz.
	self startInterpreterWith: (self 
			assembleMethod: 'main'
			withByteCodes: 
				[ :mgenc | 
				mgenc
					bcPushConstant: testInstance;
					bcSend: #test;
					bcHalt ]).
	self 
		assert: 42
		equals: interpreter somFrame pop number.
	self 
		should: [ interpreter somFrame pop ]
		raise: Error! !

!SOMInterpreterTest methodsFor: 'tests' stamp: 'mkl 5/27/2009 16:31'!
test16PushField
	| testClazz testMethod testInstance testFieldName |
	testFieldName := universe newString: 'testField'.
	testClazz := SOMClass inUniverse: universe.
	testMethod := self 
		assembleMethod: 'testMessage'
		withByteCodes: 
			[ :mgenc | 
			mgenc
				bcPushField: testFieldName string;
				bcReturnLocal ].
	testClazz somInstanceInvokables: (SOMArray 
			inUniverse: universe
			withAll: {  testMethod  }).
	testClazz somInstanceFields: (SOMArray 
			inUniverse: universe
			withAll: {  (universe newString: 'class'). testFieldName  }).
	testInstance := SOMObject 
		inUniverse: universe
		withSomClass: testClazz.
	testInstance 
		valueInField: testFieldName
		put: (universe newNumber: 42).
	self startInterpreterWith: (self 
			assembleMethod: 'main'
			withByteCodes: 
				[ :mgenc | 
				mgenc
					bcPushConstant: testInstance;
					bcSend: #testMessage;
					bcHalt ]).
	self 
		assert: 42
		equals: interpreter somFrame pop number.
	self 
		should: [ interpreter somFrame pop ]
		raise: Error! !

!SOMInterpreterTest methodsFor: 'tests' stamp: 'mkl 5/27/2009 16:31'!
test17PopField
	| testClazz testMethod testInstance testFieldName |
	testFieldName := universe newString: 'testField'.
	testClazz := SOMClass inUniverse: universe.
	testMethod := self 
		assembleMethod: 'testMessage'
		withByteCodes: 
			[ :mgenc | 
			mgenc
				bcPushConstant: (universe newNumber: 42);
				bcPopField: testFieldName string;
				bcPushArgumentIdx: 1
					ctxIdx: 1;
				bcReturnLocal ].
	testClazz somInstanceInvokables: (SOMArray 
			inUniverse: universe
			withAll: {  testMethod  }).
	testClazz somInstanceFields: (SOMArray 
			inUniverse: universe
			withAll: {  (universe newString: 'class'). testFieldName  }).
	testInstance := SOMObject 
		inUniverse: universe
		withSomClass: testClazz.
	self startInterpreterWith: (self 
			assembleMethod: 'main'
			withByteCodes: 
				[ :mgenc | 
				mgenc
					bcPushConstant: testInstance;
					bcSend: #testMessage;
					bcHalt ]).
	self 
		assert: 42
		equals: (testInstance valueInField: testFieldName) number.
	self 
		assert: testInstance
		equals: interpreter somFrame pop.
	self 
		should: [ interpreter somFrame pop ]
		raise: Error! !

TestCaseWithUniverse subclass: #SOMLexerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AweSOM-Compiler-Test'!

!SOMLexerTest methodsFor: 'tests' stamp: 'StefanMarr 5/9/2012 23:49'!
testIsOperator
	| lexer |
	lexer := SOMLexer new.

	'~&|*/\+=><,@%' asCharacterSet do: [:c |
		self assert: (lexer isOperator: c).
	]
	! !

TestCaseWithUniverse subclass: #SOMMethodTest
	instanceVariableNames: 'method'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AweSOM-VM-Test'!

!SOMMethodTest methodsFor: 'as yet unclassified' stamp: 'StefanMarr 5/14/2012 23:22'!
createMethod: source

	method := ((universe methodParser
		inUniverse: universe
		onSource: source) apply: #method) assembleIn: universe.! !

!SOMMethodTest methodsFor: 'as yet unclassified' stamp: 'rkrk 6/3/2009 15:25'!
test01MaxStackSize

	self createMethod: 'x = ()'.
	self assert: method maxStackDepth equals: 1.
	self createMethod: 'x = (1. 2. ''abc''. #def)'.
	self assert: method maxStackDepth equals: 1.! !

!SOMMethodTest methodsFor: 'as yet unclassified' stamp: 'rkrk 6/3/2009 15:25'!
test02MaxStackSize

	self createMethod: 'x = (1+2)'.
	self assert: method maxStackDepth equals: 2.! !

!SOMMethodTest methodsFor: 'as yet unclassified' stamp: 'rkrk 6/3/2009 15:25'!
test03MaxStackSize

	self createMethod: 'x: a = ( self a: 3 b: a)'.
	self assert: method maxStackDepth equals: 3.! !

TestCaseWithUniverse subclass: #SOMNumberTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AweSOM-VM-Test'!

!SOMNumberTest methodsFor: 'as yet unclassified' stamp: 'rkrk 6/3/2009 13:54'!
testIntegerVsBigInteger

	| n |
	n := universe newNumber: SOMInteger maxInt.
	self assert: n class equals: SOMInteger.
	n := universe newNumber: SOMInteger maxInt + 1.
	self assert: n class equals: SOMBigInteger.! !

TestCaseWithUniverse subclass: #SOMObjectTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AweSOM-VM-Test'!

SOMObjectTest subclass: #SOMFakeObjectTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AweSOM-VM-Test'!

!SOMFakeObjectTest class methodsFor: 'as yet unclassified' stamp: 'mkl 5/13/2009 15:43'!
shouldInheritSelectors
	^ false "reset to true in order to execute fake object tests"! !

!SOMFakeObjectTest methodsFor: 'running' stamp: 'rkrk 5/13/2009 11:16'!
setUp

	"These should be set automatically when loading SOM classes"
	| objectClass instanceFields |
	super setUp.
	objectClass := universe globalAt: #Object.
	instanceFields := SOMArray inUniverse: universe size: 1.
	instanceFields at: 1 put: (universe newString: 'class').
	objectClass instanceFields: instanceFields.! !

!SOMObjectTest methodsFor: 'tests' stamp: 'rkrk 6/5/2009 01:04'!
test01CreateSimpleObject
	| object |
	object := SOMObject inUniverse: universe withNumberOfAdditionalFields: 1.
	"Objects now come with a default class"
	"self 
		assert: (object fieldAtIndex: 1)
		equals: (universe globalAt: #nil)."
	self 
		assert: (object fieldAtIndex: 2)
		equals: (universe globalNil).
	self assert: object numberOfFields equals: 2.! !

!SOMObjectTest methodsFor: 'tests' stamp: 'mkl 5/3/2009 12:01'!
test02FieldAccess
	| object1 object2 |
	object1 := SOMObject inUniverse: universe withNumberOfAdditionalFields: 1.
	object2 := SOMObject inUniverse: universe withNumberOfAdditionalFields: 0.
	object1 
		fieldAtIndex: 1
		put: object2.
	self 
		assert: (object1 fieldAtIndex: 1)
		equals: object2! !

!SOMObjectTest methodsFor: 'tests' stamp: 'mkl 5/27/2009 15:35'!
test03aSharedFields
	| clazz object |
	clazz := SOMObject inUniverse: universe.
	object := SOMObject 
		inUniverse: universe
		withNumberOfAdditionalFields: 0.
	object somClass: clazz.
	self 
		assert: object somClass
		equals: (object fieldAtIndex: 1).
	object somClass: nil.
	object 
		fieldAtIndex: 1
		put: clazz.
	self 
		assert: object somClass
		equals: (object fieldAtIndex: 1).
	self 
		should: [ object fieldAtIndex: 2 ]
		raise: Error.
	self 
		should: 
			[ object 
				fieldAtIndex: 2
				put: 42 ]
		raise: Error! !

!SOMObjectTest methodsFor: 'tests' stamp: 'mkl 5/27/2009 16:09'!
test03bSharedFields
	| clazz1 clazz2 |
	clazz1 := SOMClass inUniverse: universe.
	clazz2 := SOMClass inUniverse: universe.
	clazz1 somSuperClass: clazz2.
	self 
		assert: clazz2
		equals: clazz1 somSuperClass.
	self 
		assert: clazz2
		equals: (clazz1 fieldAtIndex: 2).
	clazz1 somSuperClass: nil.
	self 
		assert: nil
		equals: clazz1 somSuperClass.
	self 
		assert: nil
		equals: (clazz1 fieldAtIndex: 2).
	clazz1 
		fieldAtIndex: 2
		put: clazz2.
	self 
		assert: clazz2
		equals: clazz1 somSuperClass.
	self 
		assert: clazz2
		equals: (clazz1 fieldAtIndex: 2)! !

!SOMObjectTest methodsFor: 'tests' stamp: 'rkrk 5/13/2009 11:17'!
test04Array

	| array |
	array := SOMArray inUniverse: universe size: 2.
	array at: 1 put: 42.
	array at: 2 put: 23.
	self assert: (array at: 1) equals: 42.
	self assert: (array at: 2) equals: 23! !

!SOMObjectTest methodsFor: 'tests' stamp: 'mkl 5/27/2009 16:32'!
test04bArray
	| array |
	self loadClazzes: {  #Object. #Array  }.
	array := SOMArray 
		inUniverse: universe
		withSomClass: (universe globalAt: #Array)
		numIndexable: 3.
	array 
		at: 3
		put: 42.
	self 
		assert: (array at: 3)
		equals: 42.
	self 
		should: [ array at: 4 ]
		raise: Error! !

!SOMObjectTest methodsFor: 'tests' stamp: 'rkrk 5/13/2009 11:19'!
test05UniverseAccess

	| array |
	array := SOMArray inUniverse: universe withNumberOfAdditionalFields: 2.
	self assert: array universe globalNil equals: universe globalNil.! !

TestCaseWithUniverse subclass: #SOMPrimitiveTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AweSOM-VM-Test'!

!SOMPrimitiveTest methodsFor: 'tests' stamp: 'mkl 5/27/2009 15:30'!
test01AddIntegers
	| a b c |
	a := universe newNumber: 5.
	b := universe newNumber: 7.
	c := a primPlus: b.
	self 
		assert: c number
		equals: 12.
	self 
		assert: c somClass
		equals: (universe globalAt: #Integer).
	a := SOMInteger 
		inUniverse: universe
		new: 5.
	b := SOMDouble 
		inUniverse: universe
		new: 7.5.
	c := a primPlus: b.
	self 
		assert: c number
		equals: 12.5.
	self 
		assert: c somClass
		equals: (universe globalAt: #Double)! !

!SOMPrimitiveTest methodsFor: 'tests' stamp: 'mha 9/17/2010 16:45'!
test02AsString
	| a s |
	a := SOMInteger 
		inUniverse: universe
		new: 5678.
	s := a primasString.
	self 
		assert: s string
		equals: '5678'.
	self 
		assert: s somClass
		equals: (universe globalAt: #String)! !

!SOMPrimitiveTest methodsFor: 'tests' stamp: 'arv 5/13/2009 11:32'!
test03PrimitiveNames
	| primitive |
	primitive := SOMPrimitive inUniverse: universe.
	primitive somSignature: (SOMSymbol 
			inUniverse: universe
			string: '-').
	self 
		assert: primitive realSignature string
		equals: #primMinus:.
	primitive somSignature: (SOMSymbol 
			inUniverse: universe
			string: '//').
	self 
		assert: primitive realSignature string
		equals: #primSlashSlash:.
	primitive somSignature: (SOMSymbol 
			inUniverse: universe
			string: 'key:word:').
	self 
		assert: primitive realSignature string
		equals: #primkey:word:.
	primitive somSignature: (SOMSymbol 
			inUniverse: universe
			string: 'unary').
	self 
		assert: primitive realSignature string
		equals: #primunary! !

!SOMPrimitiveTest methodsFor: 'tests' stamp: 'mkl 5/27/2009 15:30'!
test04PrimitiveNew
	| clazz instance primLength |
	self loadClazzes: {  #Object. #Array  }.
	clazz := universe globalAt: #Array.
	instance := clazz primnew.
	self 
		assert: instance somClass
		equals: clazz.
	instance := clazz 
		performPrimitive: #primnew:
		withArguments: {  (universe newNumber: 5)  }.
	self 
		assert: instance somClass
		equals: clazz.
	primLength := instance 
		performPrimitive: #primlength
		withArguments: {   }.
	self 
		assert: primLength number
		equals: 5! !

!SOMPrimitiveTest methodsFor: 'tests' stamp: 'mkl 5/26/2009 16:39'!
test05PrimitiveComparison

	| symbol1 symbol2 string1 |
	symbol1 := universe newSymbol: 'banana'.
	symbol2 := universe newSymbol: 'banana'.
	string1 := universe newString: 'banana'.
	self assert: (symbol1 primEqualEqual: symbol2) equals: (universe newBool: true).
	
	self assert: (symbol1 primEqual: string1) equals: (universe newBool: true).! !

TestCaseWithUniverse subclass: #SOMUniverseTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AweSOM-VM-Test'!

!SOMUniverseTest methodsFor: 'tests' stamp: 'mkl 5/6/2009 11:22'!
test01GlobalAccess
	self assert: universe globalNil equals: (universe globalAt: #nil).! !

!TestCaseWithUniverse methodsFor: 'as yet unclassified' stamp: 'rkrk 6/5/2009 01:13'!
loadClazzes: classes 

	classes do: [:class | universe loadSystemClass: class]! !

!TestCaseWithUniverse methodsFor: 'as yet unclassified' stamp: 'mkl 5/13/2009 15:23'!
setUp
	super setUp.
	universe := SOMUniverse new.
	universe initializeFakeGlobals.! !

!SequenceableCollection methodsFor: '*AweSOM' stamp: 'arv 5/20/2009 15:32'!
zip: otherCollection
	"Zips together (think of the zip on a pair of trousers) 2+ sequences, providing an array of tuples. Each tuple contains one value per original sequence. Tuples can be converted to something else by applying the optional iterator on them."

	| dictionary |
	dictionary := Dictionary new.
	self withIndexDo: [ :element :index |
		dictionary at: element put: (otherCollection at: index)
	].
	^ dictionary! !
SOMParser initialize!
SOMObject initialize!
